/**
 *	@file	MainFrm.h
 *	@brief	interface of the CMainFrame class
 */
// {CŏȂĂ(minit)

/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "stdafx.h"

#include "MenuControl.h"
#include "CmbboxPrxy.h"
#include "AccelManager.h"
#include "resource.h"
#include <math.h>
#include <stdlib.h>
#include <windows.h>

#include "DonutExplorerBar.h"
#include "PluginBar.h"

#include "DonutPFunc.h"

#include "dialog/DebugWindow.h"
#include "dialog/OpenURLDialog.h"
#include "PropertySheet.h"
#include "MenuEncode.h"
#include "RebarSupport.h"
#include "StyleSheetOption.h"
#include "ExStyle.h"
#include "DialogHook.h"
#include "MenuDropTargetWindow.h"
#include "ParseInternetShortcutFile.h"

#include "option/AddressBarPropertyPage.h"	//+++ AddressBar.h蕪
#include "option/SearchPropertyPage.h"		//+++ SearchBar.h蕪
#include "option/LinkBarPropertyPage.h" 	//+++

// #include "Thumbnail.h"					//+++.



#ifdef _DEBUG
	const bool _Donut_MainFrame_traceOn = false;
	#define dmfTRACE	if (_Donut_MainFrame_traceOn)  ATLTRACE
#else
	#define dmfTRACE
#endif


static const CLSID CLSID_IEnumPrivacyRecords = { 0x3050f844, 0x98b5, 0x11cf, { 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b } };

#ifndef WM_XBUTTONDOWN
 #define WM_XBUTTONDOWN 				0x020B
 #define WM_XBUTTONUP					0x020C
 #define GET_KEYSTATE_WPARAM(wParam)	( LOWORD(wParam) )
 #define GET_XBUTTON_WPARAM(wParam) 	( HIWORD(wParam) )
 #define MK_XBUTTON1					0x0020
 #define MK_XBUTTON2					0x0040
 #define XBUTTON1						0x0001
 #define XBUTTON2						0x0002
#endif

const UINT		STDBAR_ID[] 	= { ATL_IDW_COMMAND_BAR, ATL_IDW_TOOLBAR				, IDC_ADDRESSBAR, IDC_MDITAB , IDC_LINKBAR				   , IDC_SEARCHBAR					};
const UINT		STDBAR_STYLE[]	= { RBBS_USECHEVRON    , RBBS_USECHEVRON | RBBS_BREAK	, RBBS_BREAK	, RBBS_BREAK , RBBS_USECHEVRON | RBBS_BREAK, RBBS_BREAK 					};
//const UINT	STDBAR_STYLE[]	= { RBBS_USECHEVRON    , RBBS_USECHEVRON | RBBS_BREAK	, RBBS_BREAK	, RBBS_BREAK , RBBS_USECHEVRON | RBBS_BREAK, RBBS_USECHEVRON | RBBS_BREAK	};
const LPTSTR	STDBAR_TEXT[]	= { _T("")/*NULL*/	   , _T("")/*NULL*/ 				,_T("AhX") , NULL		 , _T("N") 			   , _T("") 					};	// memo. NULL ƈԍ̃{^VFuɊ܂߂邱ƂłȂ



void _PrivateTerm();


class CMainFrame
	:	public CMDIFrameWindowImpl			< CMainFrame >
	,	public CMessageFilter
	,	public CIdleHandler
	,	public CAppCommandHandler			< CMainFrame >
	,	public CUpdateCmdUI 				< CMainFrame >
	,	public CWindowMenuCommandHandler	< CMainFrame >
	,	public CDDEMessageHandler			< CMainFrame >
	,	public CMDIFrameTitleUpsideDownMessageHandlerWeb < CMainFrame >
	,	public CHelpMessageLine 			< CMainFrame >
	,	public CMSMouseWheelMessageHandler	< CMainFrame >
	,	public CMainFrameFileDropTarget 	< CMainFrame >
	,	public CReBarVerticalBorder 		< CMainFrame >
{
public:
	// Declarelations
	DECLARE_FRAME_WND_CLASS(DONUT_WND_CLASS_NAME, IDR_MAINFRAME)
	//DECLARE_MTL_REBAR_UPDATELAYOUT() //͔p~UpdateLayout֐

private:
	typedef CMDIFrameWindowImpl<CMainFrame>  baseClass;

	// Constants
	enum {
		SHDVID_SSLSTATUS	=	33, 					//SSLؖ\p
		ENT_READ_ACCEL		=	 2,
		STDBAR_COUNT		=	 6,
	};

	enum {
		_nPosFavoriteMenu	   = 3, _nPosFavGroupMenu	=  2, _nPosViewMenu   = 2,
		_nPosFavoriteMenuOfTab = 2, _nPosMRU			= 12, _nPosWindowMenu = 5, _nWindowMenuItemCount = 14,
		_nPosCssMenu		   = 4, _nPosSubCssMenu 	= 14, _nPosEncodeMenu = 2, _nPosEncodeMenuSub	 = 17
	};

	// Daba members
	CCommandBarCtrl2					m_CmdBar;
	CDonutToolBar						m_ToolBar;
	CDonutLinksBarCtrl<CMainFrame>		m_LinkBar;

public:
	CDonutAddressBar					m_AddressBar;
	CMDITabCtrl 						m_MDITab;

private:
	CDonutSearchBar 					m_SearchBar;
	CDonutReBarCtrl 					m_ReBar;

	CDonutStatusBarCtrl 				m_wndStatusBar;
	CProgressBarCtrl					m_wndProgress;
	CComboBoxPrxyR						m_cmbBox;

	CMainOption 						m_MainOption;
	CDonutSecurityZone					m_secZone;

	CSplitterWindow 					m_wndSplit;
	CDonutExplorerBar					m_ExplorerBar;

	CDonutFavoritesMenu<CMainFrame> 	m_FavoriteMenu;
	CFavoriteGroupMenu<CMainFrame>		m_FavGroupMenu;
	CExplorerMenuImpl<CStyleSheetMenu>	m_styleSheetMenu;
	CExplorerMenuImpl<CExplorerMenu>	m_ScriptMenu;
	CMenu								m_ScriptMenuMst;

	//added by minit
	//for Custom Context Dropmenu
	CDonutFavoritesMenu<CMainFrame> 	m_DropFavoriteMenu;
	CFavoriteGroupMenu<CMainFrame>		m_DropFavGroupMenu;
	CExplorerMenuImpl<CExplorerMenu>	m_DropScriptMenu;
	//for EncodeMenu
	CMenuEncode 						m_MenuEncode;

	CMenuControl						m_mcCmdBar;
	CMenuControl						m_mcToolBar;

	CContainedWindow					m_wndMDIClient;
	CFont								m_font;

	// FullScreen support
	BOOL								m_bStatusBarVisibleUnlessFullScreen;

	UINT_PTR							m_nBackUpTimerID;
	CMenuHandle 						m_menuWindow;

	HWND								m_hWndFocus;

	CSimpleMap<UINT, BOOL>				m_mapToolbarOldVisible;

	BOOL								m_bShow;

	CMenuDropTargetWindow				m_wndMenuDropTarget;

	HANDLE								m_hGroupThread;
	CDebugWindow						m_wndDebug;

	int 								m_OnUserOpenFile_nCmdShow;		//+++ OɎsOnUserOpenFile()őIꂽnCmdShow̍T.

	int 								m_nMenuBarStyle; //+++
	int/*COLORREF*/ 					m_nBgColor; 	//+++ wiF
	CBitmap 							m_bmpBg;		//+++ BG摜
	//CBitmap							m_bmpBgStretch; //+++ BG摜`p
	bool								m_bTray;		//+++ gCĂ邩ǂ̃tO.
	//bool								m_bMinimized;	//+++ ŏĂ邩ǂ
	bool								m_bOldMaximized;//+++ ő剻Ăǂ
	bool								m_bFullScreen;	//+++ gC̕ApɑtXN[ǂێ
	CString 							m_strIcon;		//+++ ACR̖O.
	CString 							m_strIconSm;	//+++ ACR̖O.

public:
	// Constructor/Destructor
	CMainFrame()
		: m_FavoriteMenu(this, ID_INSERTPOINT_FAVORITEMENU)
		, m_FavGroupMenu(this, ID_INSERTPOINT_GROUPMENU)
		, m_styleSheetMenu(ID_INSERTPOINT_CSSMENU, _T("(empty)"), ID_INSERTPOINT_CSSMENU, ID_INSERTPOINT_CSSMENU_END)
		, m_LinkBar(this, ID_INSERTPOINT_FAVORITEMENU)
		, m_nBackUpTimerID(0)
		, m_wndMDIClient(this, 1)
		, CDDEMessageHandler<CMainFrame>( _T("Donut") )
		, m_hWndFocus(NULL)
		, m_ExplorerBar(m_wndSplit)
		, m_ScriptMenu(ID_INSERTPOINT_SCRIPTMENU, _T("(empty)"), ID_INSERTPOINT_SCRIPTMENU, ID_INSERTPOINT_SCRIPTMENU_END)
		, m_DropFavoriteMenu(this, ID_INSERTPOINT_FAVORITEMENU)
		, m_DropFavGroupMenu(this, ID_INSERTPOINT_GROUPMENU)
		, m_DropScriptMenu(ID_INSERTPOINT_SCRIPTMENU, _T("(empty)"), ID_INSERTPOINT_SCRIPTMENU, ID_INSERTPOINT_SCRIPTMENU_END)
		, m_bShow(FALSE)
		, m_hGroupThread(NULL)
		, m_OnUserOpenFile_nCmdShow(0)
		, m_nMenuBarStyle(-1)		//+++
		, m_nBgColor(-1)			//+++
		, m_bTray(0)				//+++
		, m_bFullScreen(0)			//+++
		, m_bOldMaximized(0)		//+++
		//, m_bMinimized(0)			//+++
		, m_strIcon()				//+++
		, m_strIconSm() 			//+++
	{
	}


	~CMainFrame()
	{
		if ( m_wndMDIClient.IsWindow() )
			m_wndMDIClient.UnsubclassWindow();
	}


private:
	// Overrides
	//eEBhE(ɃL[)bZ[W]
	virtual BOOL PreTranslateMessage(MSG *pMsg)
	{
		//R}ho[(j[)
		if ( m_CmdBar.PreTranslateMessage(pMsg) )
			return TRUE;

		//AhXo[
		BYTE ptFlag 	= m_AddressBar.PreTranslateMessage(pMsg);
		if (ptFlag == _MTL_TRANSLATE_HANDLE)
			return TRUE;
		else if (ptFlag == _MTL_TRANSLATE_WANT)
			return FALSE;

		//o[
		ptFlag = m_SearchBar.PreTranslateMessage(pMsg);
		if (ptFlag == _MTL_TRANSLATE_HANDLE)
			return TRUE;
		else if (ptFlag == _MTL_TRANSLATE_WANT)
			return FALSE;

		//GNXv[o[
		//if (m_ExplorerBar.PreTranslateMessage(pMsg)) return TRUE;
		ptFlag = m_ExplorerBar.PreTranslateMessage(pMsg);
		if (ptFlag == _MTL_TRANSLATE_HANDLE)
			return TRUE;
		else if (ptFlag == _MTL_TRANSLATE_WANT)
			return FALSE;

	  #if 1
		//+++ AhXo[orT[`o[ɃtH[JXĂ鎞Ȁŗ]vȂ(L[)Ȃ悤ɃK[hĂ݂
		int	bFocus = false;
		if (::IsWindow(m_AddressBar.m_hWnd))
			bFocus	|= (::GetFocus() == m_AddressBar.GetEditCtrl());
		if (::IsWindow(m_SearchBar.m_hWnd))
			bFocus	|= (::GetFocus() == m_SearchBar.GetEditCtrl());
	  #endif

		// NX
		if (/*bFocus == 0 &&*/ baseClass::PreTranslateMessage(pMsg) )
			return TRUE;

		//ANeBuE`ChEEBhE
		HWND hWnd = MDIGetActive();

	  #if 0	//+++ {^NbÑeXg
		if ( pMsg->message == WM_LBUTTONDOWN) {
			printf("%d,%d\n",pMsg->wParam, pMsg->lParam);
		}
	  #endif

		// {^NbÑ`FbN
		if ( pMsg->message == WM_MBUTTONDOWN && hWnd != NULL && ::IsChild(hWnd, pMsg->hwnd) && OnMButtonHook(pMsg) )
			return TRUE;

		//}EXWFX`[
		if ( pMsg->message == WM_RBUTTONDOWN && OnRButtonHook(pMsg) )
			return TRUE;

		//TCh{^
		if (pMsg->message == WM_XBUTTONUP) {
			if ( OnXButtonUp( GET_KEYSTATE_WPARAM(pMsg->wParam), GET_XBUTTON_WPARAM(pMsg->wParam),
							 CPoint( GET_X_LPARAM(pMsg->lParam), GET_Y_LPARAM(pMsg->lParam) ) ) )
				return TRUE;
		}

		// GNXv[o[ŕ\
		if ( (CMainOption::s_dwExplorerBarStyle & MAIN_EXPLORER_AUTOSHOW) == MAIN_EXPLORER_AUTOSHOW )
			ExplorerBarAutoShow(pMsg);

		//BHO
		if (bFocus == 0 && TranslateMessageToBHO(pMsg) )											//+++ bFocus`FbN
			return TRUE;

		hWnd = MDIGetActive();	//+++ ӖȂƎvAÔߎ蒼...

		if (bFocus == 0 && hWnd != NULL && ::SendMessage(hWnd, WM_FORWARDMSG, 0, (LPARAM) pMsg) )	//+++ bFocus`FbN
			return TRUE;

		return FALSE; // IsDialogMessage(pMsg);
	}


public:
	void UpdateLayout(BOOL bResizeBars = TRUE)
	{
		CRect	  rc;

		GetClientRect(&rc);

		if (bResizeBars) {
			_UpdateReBarPosition(rc);
		}

		CClientDC dc(m_hWnd);
		_DoPaintReBarBorders(dc.m_hDC);
		UpdateBarsPosition(rc, bResizeBars);
		_InflateReBarBordersRect(rc);

		if (m_hWndClient != NULL) {
			::SetWindowPos( m_hWndClient, NULL, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, SWP_NOZORDER | SWP_NOACTIVATE );
		}
	}


private:
	BOOL OnXButtonUp(WORD wKeys, WORD wButton, CPoint point)
	{
		CString 	strKey;

		switch (wButton) {
		case XBUTTON1: strKey = _T("Side1"); break;
		case XBUTTON2: strKey = _T("Side2"); break;
		}

		DWORD		dwCommand = 0;
		{
			CIniFileI pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
			pr.QueryValue(dwCommand, strKey);
		}

		if (dwCommand == 0)
			return FALSE;

		::SendMessage(m_hWnd, WM_COMMAND, dwCommand, 0);
		return TRUE;
	}


	void ExplorerBarAutoShow(MSG *pMsg)
	{
		if (pMsg->message != WM_MOUSEMOVE)
			return;

		if (pMsg->wParam != 0)
			return;

		if (  m_ExplorerBar.IsFavBarVisible()		== false
		   && m_ExplorerBar.IsClipboardBarVisible() == false
		   && m_ExplorerBar.IsPanelBarVisible() 	== false
		   && m_ExplorerBar.IsPluginBarVisible()	== false)
			return;

		CPoint point;
		::GetCursorPos(&point);

		CRect  rcWndCmd;
		::GetWindowRect(m_hWndToolBar, &rcWndCmd);

		if ( rcWndCmd.PtInRect(point) )
			return;

		ScreenToClient(&point);

		CRect  rcWnd;
		GetClientRect(&rcWnd);

		if (m_ExplorerBar.IsExplorerBarHidden() == false) {
			CRect rcWndExp;
			m_ExplorerBar.GetClientRect(&rcWndExp);
			rcWnd.left += rcWndExp.Width() + 5;

			if ( rcWnd.PtInRect(point) )
				m_wndSplit.SetSinglePaneMode(SPLIT_PANE_RIGHT);
		} else {
			if (point.x < 10 && point.x >= 0) {
				m_ExplorerBar.ShowBar(m_ExplorerBar.m_dwExStyle, true);
			}
		}
	}


	BOOL OnMButtonHook(MSG* pMsg)
	{
		DWORD	dwLinkOpenBtnM;
		{
			CIniFileI	 pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
			dwLinkOpenBtnM = pr.GetValue(_T("LinkOpenBtnM"), 0);
		}

		// {^ݒ肳ĂȂAI.
		if (dwLinkOpenBtnM == 0)
			return FALSE;
		//+++ FftHgł dwLinkOpenBtmM = IDM_FOLLOWLINKN
		// ATLASSERT(dwLinkOpenBtnM == IDM_FOLLOWLINKN);

	  #if 0
		//+++ :̏́̕ADonutPDonutRAPT,unDonutłقǃ\[XɈႢ킯łȂ.
		::SendMessage(pMsg->hwnd, WM_LBUTTONDOWN, 0, pMsg->lParam); 	//+++ ܂Ȃ.
		int 	nTabCnt = m_MDITab.GetItemCount();						//+++ NNbNǂ̃`FbNp.
		::SendMessage(pMsg->hwnd, WM_COMMAND, dwLinkOpenBtnM, 0);		//+++ NVɂЂ炭
		if (m_MDITab.GetItemCount() != nTabCnt) 						//+++ ^uĂANNbN̂낤
			return TRUE;												//+++ trueԂĒ{^NbN̏Ƃɂ.
		::SendMessage(pMsg->hwnd, WM_LBUTTONUP, 0, pMsg->lParam);		//+++ NȊONbNꍇ܂Ȃ̍NbNIĂ.
		return FALSE;													//+++ falseԂƂŁAIER|[lgɃEB[NbN̏C.

		//+++ : 炭L̉EɏRĝ悤ȓz肵̂Ǝv.
		//		"܂Ȃ"ÁAWM_COMMAND+IDM_FOLLOWLINKN݂̂𑗂ꍇA
		//		ȂJ1NbN悤ŁA̒날킹Ƃ
		//		NbNƂɂĂ悤(...悭킩ȂǁAԂ).
		//		ANȊỎӏNbNƂ́A͈͑I̊JnƂċ@\Ă܂߁A
		//		̏ꍇ́AU{^NbNI鏈ĂB
		//
		//		́ANbNǂ̔ŁA^ǔIDM_FOLLOWLINKNɂ
		//		(ϓ)ǂĂ̂...
		//		~jbgȑO̊J҂̊ł͗L̂悤Aundonut++mod̊Jł́A
		//		N̗Lɂ炸̎_ł̓^uςȂ͗l... 
		//		FALSEԂɗANbNLZ̏JNbNƓlɍp
		//		܂AʓIɓy[WQJĂ܂AƂoOɉĂ܂Ă.
		//
		//		󋵓Iɂ::SendMessage(pMsg->hwnd, WM_COMMAND, dwLinkOpenBtnM, 0);̎s
		//		V^ułĂ畜AĂmANGXgsĂ߂Ă鏈
		//		ɕςĂ܂AƂƂɎvB
		//
		//		CChildFrameł o[ActivateFrame()̏̒Ń^uւ̒ǉ
		//		̂AWM_COMMAND+dwLinkOpenBtnMCChildFrameꍇA
		//		CChildFrame::OnNewWindow2() Ă΂Ã[głActivateFrame()͒ɂ͌Ă΂ꂸA
		//		ƂActivateFrame()Ă΂悤ɂĂB̏ԂOnNewWindow2͏ÎŁA
		//		SendMessageIĂ^u͕̐ςȂAƂ̏Ԃ́A
		//		\[XIɂ͓RɎv̂... (̂ւ̑؂donutPɂ̂ڂĂ)
		//
		//		ŁAActivateFrameƂŒNĂԂƂ CChildFrame::OnBeforeNavigate2() ŁA
		//		 MtlBrawser.hIWebBrowserEvents2Impl::OnBeforeNavigate2Ă΂Ă
		//		܂A܂ĂJł́ADonut\[XŖIɂ̊֐ĂłȂǁA
		//		SendMessageI܂łɂsAƂƂȂ̂낤.
		//		( ЂƂƁA OnNewWindow2ȊOChildFrameĂ\邩)
		//
		//		OS,IE,PSDK/ATL,WTL, unDonut ̂ǂ̏Ȃ̂낤A悭킩Ȃ
		//		(2007-11-23)
		//		ǂ AtlHost(Ex)łCreateControlLicEx ,Navigate2()܂elsecĂ̂
		//		܂͗lBelse폜璼. (2008-01-01)
	  #else //+++ Nǂ̔ɃXe[^Xo[ɃN悪ݒ肳Ă邩ǂAp悤ɂ.
		HWND			hWnd	= MDIGetActive();
		if ( ::IsWindow(hWnd) == 0 )
			return FALSE;
		CChildFrame*	pChild	= GetChildFrame(hWnd);
		bool			bLink	= 0;
		if (pChild) {																//+++ J[\NĂstatusBarp̃bZ[W邱Ƃ𗘗p.
			const CString& str = pChild->strStatusBar();
			if (str.IsEmpty() == 0 && str != "y[W\܂")				//+++ N̂Ȃy[Wł"y[W\܂"ƂbZ[Wݒ肳Ă̂ŏO.
				bLink = true;
		}
		::SendMessage(pMsg->hwnd, WM_LBUTTONDOWN, 0, pMsg->lParam); 				//+++ ܂Ȃ.
		int 	nTabCnt = m_MDITab.GetItemCount();									//+++ NNbNǂ̃`FbNp.
		::SendMessage(pMsg->hwnd, WM_COMMAND, dwLinkOpenBtnM, 0);					//+++ NVɂЂ炭
		int 	nTabCnt2 = m_MDITab.GetItemCount();
		if (nTabCnt != nTabCnt2 || bLink)											//+++ NbZ[W邩A^uĂANNbNƂ.
			return TRUE;															//+++ trueԂĒ{^NbN̏Ƃɂ.
		::SendMessage(pMsg->hwnd, WM_LBUTTONUP, 0, pMsg->lParam);					//+++ NȊONbNꍇ܂Ȃ̍NbNIĂ.
		return FALSE;																//+++ falseԂƂŁAIER|[lgɃEB[NbN̏C.
	  #endif
	}


	// Mouse Gesture
	BOOL OnRButtonHook(MSG *pMsg)
	{
		HWND		hChildWnd = MDIGetActive();

		if (hChildWnd) {
			BOOL	bUsedMouseGesture = ::SendMessage(hChildWnd, WM_USER_USED_MOUSE_GESTURE, 0, 0) != 0;
			if (bUsedMouseGesture == FALSE)
				return FALSE;
		}

		::SetCapture(m_hWnd);

		CPoint		ptDown;
		ptDown.x = GET_X_LPARAM(pMsg->lParam);
		ptDown.y = GET_Y_LPARAM(pMsg->lParam);
		::ClientToScreen(pMsg->hwnd, &ptDown);

		CPoint		ptBefor   = ptDown;
		CPoint		ptUp	  = ptDown;
		int 		nAng1	  = -1;
		CString 	strMove;
		CString 	strMark1;
		CString 	strMark2;
		DWORD		dwTime	  = -1;
		HWND		hWndHist  = m_hWnd;
		HWND		hWnd	  = NULL;
		BOOL		bNoting   = TRUE;
		MSG 		msg;
		ZeroMemory(&msg, sizeof msg);

		do {
			if (::GetCapture() != hWndHist)
				break;

			if (m_hWnd != hWndHist)
				break;

			if (::GetMessage(&msg, NULL, 0, 0) == FALSE)
				continue;

			int 	nDiff		= 0;
			DWORD	dwCommand	= 0;
			BOOL	bNeedFresh	= FALSE,
					bBreak		= FALSE;

			switch (msg.message) {
			case WM_MOUSEWHEEL:
				dwCommand = GetMouseWheelCmd( (short) HIWORD(msg.wParam) );
				break;

			case WM_LBUTTONUP:
			case WM_MBUTTONUP:
				dwCommand = GetMouseButtonUpCmd(msg.message);
				break;

			case WM_XBUTTONUP:
				dwCommand = GetMouseButtonUpCmd( msg.message, GET_XBUTTON_WPARAM(msg.wParam) );
				break;

			case WM_MOUSEMOVE:
				ptUp.x	  = GET_X_LPARAM(msg.lParam);
				ptUp.y	  = GET_Y_LPARAM(msg.lParam);
				::ClientToScreen(msg.hwnd, &ptUp);

				nDiff	  = (int) ( sqrt( pow(float (ptBefor.x - ptUp.x), 2.0f) + pow(float (ptBefor.y - ptUp.y), 2.0f) ) );
				if (nDiff < 10)
					break;

				nAng1	  = (int) _GetAngle(ptBefor, ptUp);
				ptBefor   = ptUp;

				if		(nAng1 <  45 || nAng1 >  315)
					strMark1 = _T("");
				else if (nAng1 >= 45 && nAng1 <= 135)
					strMark1 = _T("");
				else if (nAng1 > 135 && nAng1 <  225)
					strMark1 = _T("");
				else if (nAng1 >= 225 && nAng1 <= 315)
					strMark1 = _T("");

				if (strMark1 == strMark2) {
					DWORD dwTimeNow = ::GetTickCount();

					if ( (dwTimeNow - dwTime) > 300 ) {
						strMark2 = _T("");
						dwTime	 = dwTimeNow;
					}
				}

				if (strMark1 != strMark2) {
					strMove += strMark1;
					strMark2 = strMark1;

					DWORD	dwCommand = 0;
					CIniFileI	pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
					pr.QueryValue(dwCommand, strMove);
					pr.Close();
					CString strCmdName;

					if (dwCommand != 0) {
						CString strTemp;
						CToolTipManager::LoadToolTipText(dwCommand, strTemp);
						strCmdName.Format("[ %s ]", strTemp);
					}

					CString 	strMsg;
					strMsg.Format("WFX`[ : %s %s", strMove, strCmdName);
					::SetWindowText(m_hWndStatusBar, strMsg);
				}

				dwTime = ::GetTickCount();
				break;

			case WM_KEYDOWN:
				hWnd   = MDIGetActive();
				if (hWnd != NULL)
					SendMessage(hWnd, WM_FORWARDMSG, 0, (LPARAM) &msg);

				break;

			default:
				DispatchMessage(&msg);
				break;
			}

			switch (dwCommand) {
			case ID_FILE_CLOSE:
				hWnd	   = MDIGetActive();
				if (hWnd == NULL)
					break;

				::PostMessage(hWnd, WM_COMMAND, ID_FILE_CLOSE, 0);
				//::PostMessage(hWnd, WM_CLOSE, 0, 0);
				bNoting    = FALSE;
				bNeedFresh = TRUE;
				//goto NEXT;
				break;

			case ID_GET_OUT:				// ޔ
			case ID_VIEW_FULLSCREEN:		// S̕\
			case ID_VIEW_UP:				// 
			case ID_VIEW_BACK:				// Oɖ߂
			case ID_VIEW_FORWARD:			// ɐi
			case ID_VIEW_STOP_ALL:			// ׂĒ~
			case ID_VIEW_REFRESH_ALL:		// ׂčXV
			case ID_WINDOW_CLOSE_ALL:		// ׂĕ
			case ID_WINDOW_CLOSE_EXCEPT:	// ȊO
				::PostMessage(m_hWnd, WM_COMMAND, dwCommand, 0);
				bNoting    = FALSE;
				bBreak	   = TRUE;
				break;

			case 0:
				break;

			default:
				::PostMessage(m_hWnd, WM_COMMAND, dwCommand, 0);
				bNoting    = FALSE;
				bNeedFresh = TRUE;
				break;
			}

			if (bNeedFresh) {
				hWnd = MDIGetActive();
				if (hWnd)
					::RedrawWindow(hWnd, NULL, NULL, RDW_UPDATENOW);
			}

			if (!(GetAsyncKeyState(VK_RBUTTON) & 0x80000000) && msg.message != WM_RBUTTONUP) {
				MSG msgR;
				if (::PeekMessage(&msgR, NULL, 0, 0, PM_NOREMOVE) == 0) {
					break;
				}
			}
		} while (msg.message != WM_RBUTTONUP);

		::ReleaseCapture();

		if (bNoting) {
			ptUp.x = GET_X_LPARAM(msg.lParam);
			ptUp.y = GET_Y_LPARAM(msg.lParam);
			::ClientToScreen(msg.hwnd, &ptUp);

			::SetWindowText( m_hWndStatusBar, _T("") );

			DWORD dwCommand = 0;
			CIniFileI	pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
			pr.QueryValue(dwCommand, strMove);
			pr.Close();

			if (dwCommand != 0) {
				::SendMessage(m_hWnd, WM_COMMAND, dwCommand, 0);
				bNoting = FALSE;
			} else if (dwCommand == -1)
				return TRUE;
		}

		if ( bNoting && strMove.IsEmpty() ) {
			::ScreenToClient(pMsg->hwnd, &ptUp);
			pMsg->lParam = MAKELONG(ptUp.x, ptUp.y);

			::PostMessage(pMsg->hwnd, WM_RBUTTONUP, pMsg->wParam, pMsg->lParam);
		}

		return !bNoting;
	}


	DWORD GetMouseWheelCmd(short nWheel)
	{
		CString 	strKey;
		if (nWheel > 0)
			strKey = _T("WHEEL_UP");
		else
			strKey = _T("WHEEL_DOWN");

		CIniFileI	pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
		DWORD		dwCommand = pr.GetValue(strKey, 0);
		return dwCommand;
	}


	DWORD GetMouseButtonUpCmd(UINT uMsg, UINT nXButton = 0)
	{
		CString 	strKey;
		switch (uMsg) {
		case WM_LBUTTONUP:	strKey = _T("LButtonUp");				break;
		case WM_MBUTTONUP:	strKey = _T("MButtonUp");				break;
		case WM_XBUTTONUP:	strKey.Format("XButtonUp%d", nXButton); break;
		}

		CIniFileI	pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
		DWORD		dwCommand = pr.GetValue(strKey, 0);
		return dwCommand;
	}


	virtual BOOL OnIdle()
	{
		// Note. under 0.01 sec (in dbg-mode on 330mhz cpu)
		CmdUIUpdateToolBars();
		CmdUIUpdateStatusBar	(m_hWndStatusBar, ID_DEFAULT_PANE	);
		CmdUIUpdateStatusBar	(m_hWndStatusBar, ID_SECURE_PANE	);
		CmdUIUpdateStatusBar	(m_hWndStatusBar, ID_PRIVACY_PANE	);
		CmdUIUpdateChildWindow	(m_hWndStatusBar, IDC_PROGRESS		);
		m_mcCmdBar.UpdateMDIMenuControl();
		_FocusChecker();

		if ( _check_flag(MAIN_EX_KILLDIALOG, CMainOption::s_dwMainExtendedStyle) )
			CDialogKiller2::KillDialog();

		return FALSE;
	}


	void _OnIdleCritical()
	{
		if ( MtlIsApplicationActive(m_hWnd) ) {
			CmdUIUpdateToolBars();
			CmdUIUpdateChildWindow(m_hWndStatusBar, IDC_PROGRESS);
		}

		_FocusChecker();

		if ( _check_flag(MAIN_EX_KILLDIALOG, CMainOption::s_dwMainExtendedStyle) )
			CDialogKiller2::KillDialog();
	}


public:
	bool OnDDEOpenFile(const CString &strFileName)
	{
		dmfTRACE(_T("CMainFrame::OnDDEOpenFile(%s)\n"), strFileName);
	  #if 1 //+++ gCԂ̕Ał̃oO΍.
		if (m_bTray)
			OnGetOut(0, 0, 0);	//̓_~[
		DWORD flags = DonutGetStdOpenFlag();
		OnUserOpenFile( strFileName, flags );
		if (CStartUpOption::s_dwActivate) {
			MtlSetForegroundWindow(m_hWnd);
		}
	  #else
		OnUserOpenFile( strFileName, DonutGetStdOpenFlag() );
		if (CStartUpOption::s_dwActivate) {
			//+++ OnUserOpenFile()̎_ōő剻/tXN[ꍇ̑΍nCmdShownčl悤ɕύX.
			MtlSetForegroundWindow(m_hWnd, m_OnUserOpenFile_nCmdShow);	//+++ ͂nCmdShow͈ӖႤ̂ĂĂ悤ȋC...Ƃ܂킵.
		}
	  #endif
		// UDT DGSTR ( added by dai
		return true;
	}


private:
	#define RELECT_STATUSBAR_DRAWITEM_MESSAGE() 							   \
	{																		   \
		LPDRAWITEMSTRUCT lpdis = (LPDRAWITEMSTRUCT) lParam; 				   \
		if (uMsg == WM_DRAWITEM && lpdis->hwndItem == m_wndStatusBar.m_hWnd) { \
			bHandled = TRUE;												   \
			lResult  = ReflectNotifications(uMsg, wParam, lParam, bHandled);   \
			if (bHandled)													   \
				return TRUE;												   \
		}																	   \
	}

public:
	// Message map
	BEGIN_MSG_MAP( CMainFrame )
		COMMAND_EXMENU_RANGE( EXMENU_FIRST, EXMENU_LAST )
		RELECT_STATUSBAR_DRAWITEM_MESSAGE( )

		PASS_MSG_MAP_MENUOWNER_TO_EXPMENU_DEFAULT( m_FavGroupMenu	)
		PASS_MSG_MAP_MENUOWNER_TO_EXPMENU_DEFAULT( m_FavoriteMenu	)
		PASS_MSG_MAP_MENUOWNER_TO_EXPMENU_DEFAULT( m_styleSheetMenu )
		PASS_MSG_MAP_MENUOWNER_TO_EXPMENU_DEFAULT( m_ScriptMenu 	)

		PASS_MSG_MAP_MENUOWNER_TO_EXPMENU( m_DropFavGroupMenu )
		PASS_MSG_MAP_MENUOWNER_TO_EXPMENU( m_DropFavoriteMenu )
		PASS_MSG_MAP_MENUOWNER_TO_EXPMENU( m_DropScriptMenu   )

		CHAIN_MSG_MAP_MEMBER	( m_MenuEncode		)
		CHAIN_MSG_MAP			( CUpdateCmdUI<CMainFrame> )

		//x MESSAGE_HANDLER		( WM_SIZE  , OnSize   )			//+++ s
		MESSAGE_HANDLER 		( WM_CREATE, OnCreate )
		MSG_WM_CLOSE			( OnClose			)
		MSG_WM_DESTROY			( OnDestroy 		)
		MSG_WM_ENDSESSION		( OnEndSession		)
		USER_MSG_WM_NEWINSTANCE ( OnNewInstance 	)
		MSG_WM_USER_MDICHILD	( OnMDIChild		)

		MSG_WM_USER_OPENFILE	( OnUserOpenFile	)
		MSG_WM_USER_GET_ACTIVE_IWEBBROWSER( )

		USER_MSG_WM_UPDATE_TITLEBAR( UpdateTitleBar )						// UDT DGSTR

		MESSAGE_HANDLER 		 ( MYWM_NOTIFYICON , OnMyNotifyIcon  )		// UDT DGSTR ( SystemTrayIcon Handler )
		COMMAND_ID_HANDLER_EX	 ( ID_GET_OUT	   , OnGetOut		 )		// UDT DGSTR
		USER_MSG_WM_UPDATE_EXPBAR( UpdateExpBar )							// UDT DGSTR

		MSG_WM_USER_GET_ACTIVE_WINDOW( )
		MSG_WM_USER_BROWSER_CAN_SETFOCUS( OnBrowserCanSetFocus )
		MSG_WM_ACTIVATE 	 ( OnActivate )

		MESSAGE_HANDLER 	 ( WM_MENUDRAG	   , OnMenuDrag 	 )
		MESSAGE_HANDLER 	 ( WM_MENUGETOBJECT, OnMenuGetObject )

		// map custom draw notifycation to addressbar
		MESSAGE_HANDLER 	 ( WM_NOTIFY	   , OnNotify		 )

		HANDLE_MESSAGE		 ( WM_MDISETMENU		)
		HANDLE_MESSAGE		 ( WM_SETFOCUS			)				// default handler will set focus to server window

		MSG_WM_TIMER		 ( OnTimer				)
		MSG_WM_MOUSEWHEEL	 ( OnMouseWheel 		)
		DEBUG_CHECK_FOCUS_COMMAND_ID_HANDLER_EX()

		COMMAND_ID_HANDLER	 ( ID_APP_ABOUT 			, OnAppAbout			)
		COMMAND_RANGE_HANDLER( ID_RECENTDOCUMENT_FIRST, ID_RECENTDOCUMENT_LAST, OnFileRecent )
		COMMAND_RANGE_HANDLER( ID_FILE_MRU_FIRST	  , ID_FILE_MRU_LAST	  , OnFileRecent )
		COMMAND_ID_HANDLER	 ( ID_FILE_NEW				, OnFileNew 			)
		COMMAND_ID_HANDLER	 ( ID_FILE_OPEN 			, OnFileOpen			)
		COMMAND_ID_HANDLER_EX( ID_FILE_NEW_HOME 		, OnFileNewHome 		)
		COMMAND_ID_HANDLER_EX( ID_FILE_NEW_CLIPBOARD	, OnFileNewClipBoard	)
		COMMAND_ID_HANDLER_EX( ID_FILE_NEW_CLIPBOARD2	, OnFileNewClipBoard2	)
		COMMAND_ID_HANDLER_EX( ID_FILE_NEW_CLIPBOARD_EX , OnFileNewClipBoardEx	)
		COMMAND_ID_HANDLER_EX( ID_FILE_NEW_BLANK		, OnFileNewBlank		)
		COMMAND_ID_HANDLER_EX( ID_FILE_NEW_COPY 		, OnFileNewCopy 		)
		COMMAND_ID_HANDLER_EX( ID_FILE_WORKOFFLINE		, OnFileWorkOffline 	)

		COMMAND_ID_HANDLER_EX( ID_EDIT_CUT				, OnEditCut 			)
		COMMAND_ID_HANDLER_EX( ID_EDIT_COPY 			, OnEditCopy			)
		COMMAND_ID_HANDLER_EX( ID_EDIT_PASTE			, OnEditPaste			)
		COMMAND_ID_HANDLER_EX( ID_EDIT_SELECT_ALL		, OnEditSelectAll		)

		COMMAND_ID_HANDLER_EX( ID_FAVORITE_GROUP_SAVE	, OnFavoriteGroupSave	)
		COMMAND_ID_HANDLER_EX( ID_FAVORITE_GROUP_ADD	, OnFavoriteGroupAdd	)	//+++ ǉ
		COMMAND_ID_HANDLER_EX( ID_FAVORITE_GROUP_ORGANIZE, OnFavoriteGroupOrganize )

		COMMAND_ID_HANDLER_EX( ID_VIEW_REFRESH_ALL		, OnViewRefreshAll		)
		COMMAND_ID_HANDLER_EX( ID_VIEW_STOP_ALL 		, OnViewStopAll 		)
		COMMAND_ID_HANDLER_EX( ID_VIEW_FULLSCREEN		, OnViewFullScreen		)

		COMMAND_ID_HANDLER_EX( ID_BACKUPOPTION_CHANGED	, OnBackUpOptionChanged )

		COMMAND_ID_HANDLER_EX( ID_TAB_LEFT				, OnTabLeft 			)
		COMMAND_ID_HANDLER_EX( ID_TAB_RIGHT 			, OnTabRight			)
		COMMAND_RANGE_HANDLER( ID_TAB_IDX_1				, ID_TAB_IDX_LAST, OnTabIdx )	//+++ 擪^u1..8I. 9͍Ō̃^uI

		COMMAND_ID_HANDLER	 ( ID_VIEW_SEARCHBAR		, OnViewSearchBar		)	// U.H
		COMMAND_ID_HANDLER	 ( ID_VIEW_COMMANDBAR		, OnViewCommandBar		)	// U.H
		COMMAND_ID_HANDLER	 ( ID_VIEW_TOOLBAR			, OnViewToolBar 		)
		COMMAND_ID_HANDLER	 ( ID_VIEW_ADDRESSBAR		, OnViewAddressBar		)
		COMMAND_ID_HANDLER	 ( ID_VIEW_LINKBAR			, OnViewLinkBar 		)
		COMMAND_ID_HANDLER	 ( ID_VIEW_TABBAR			, OnViewTabBar			)
		COMMAND_ID_HANDLER	 ( ID_VIEW_STATUS_BAR		, OnViewStatusBar		)

		COMMAND_ID_HANDLER	 ( ID_VIEW_GOBUTTON 		, OnViewGoButton		)
		COMMAND_ID_HANDLER	 ( ID_VIEW_TOOLBAR_CUST 	, OnViewToolBarCust 	)
		COMMAND_ID_HANDLER	 ( ID_VIEW_TABBAR_MULTI 	, OnViewTabBarMulti 	)
		COMMAND_ID_HANDLER	 ( ID_VIEW_ADDBAR_DROPDOWN	, OnViewAddBarDropDown	)
		COMMAND_ID_HANDLER	 ( ID_VIEW_TOOLBAR_LOCK 	, OnViewToolBarLock 	)	// minit
		COMMAND_ID_HANDLER	 ( ID_VIEW_SEARCHBUTTON 	, OnViewSearchButton	)	// minit
		COMMAND_ID_HANDLER_EX( ID_EXPLORERBAR_AUTOSHOW	, OnExplorerBarAutoShow )

		COMMAND_ID_HANDLER_EX( ID_VIEW_OPTION_DONUT 	, OnViewOptionDonut 	)

		COMMAND_ID_HANDLER_EX( ID_FAVORITE_ADD			, OnFavoriteAdd 		)
		COMMAND_ID_HANDLER_EX( ID_FAVORITE_ORGANIZE 	, OnFavoriteOrganize	)

		COMMAND_ID_HANDLER_EX( ID_SETFOCUS_ADDRESSBAR	, OnSetFocusAddressBar	)
		COMMAND_ID_HANDLER_EX( ID_SETFOCUS_SEARCHBAR	, OnSetFocusSearchBar	)

		COMMAND_ID_HANDLER	 ( ID_WINDOW_CLOSE_ALL		, OnWindowCloseAll		)

		COMMAND_ID_HANDLER	 ( ID_VIEW_REFRESH_FAVBAR	, OnViewRefreshFavBar	)
		COMMAND_ID_HANDLER	 ( ID_VIEW_IDLE 			, OnViewIdle			)
		COMMAND_ID_HANDLER_EX( ID_VIEW_HOME 			, OnViewHome			)

		// UH
		USER_MEG_WM_MENU_GET_FAV		( OnMenuGetFav		)
		USER_MEG_WM_MENU_GET_FAV_GROUP	( OnMenuGetFavGroup )
		USER_MEG_WM_MENU_GET_SCRIPT 	( OnMenuGetScript	)
		USER_MSG_WM_MENU_GOBACK 		( OnMenuGoBack		)
		USER_MSG_WM_MENU_GOFORWARD		( OnMenuGoForward	)

		COMMAND_ID_HANDLER_EX( ID_RESIZED				, OnResized 			);
		COMMAND_ID_HANDLER_EX( ID_FILE_NEW_SELECTED 	, OnFileNewSelectText	)

		MSG_WM_USER_SHOW_TEXT_CHG		( OnShowTextChg  )

		COMMAND_ID_HANDLER_EX( ID_GO_ADDRESSBAR 		, OnGoAddressBar )

		MSG_WM_SYSCOMMAND				( OnSysCommand	  )
		MSG_WM_INITMENUPOPUP			( OnInitMenuPopup )

		COMMAND_ID_HANDLER_EX( ID_POPUP_CLOSE			 , OnPopupClose  )
		COMMAND_ID_HANDLER_EX( ID_TITLE_CLOSE			 , OnTitleClose  )
		COMMAND_ID_HANDLER_EX( ID_DOUBLE_CLOSE			 , OnDoubleClose )
		COMMAND_ID_HANDLER_EX( ID_URLACTION_COOKIES_BLOCK, OnCookiesIE6  )
		COMMAND_ID_HANDLER_EX( ID_URLACTION_COOKIES_HI	 , OnCookiesIE6  )
		COMMAND_ID_HANDLER_EX( ID_URLACTION_COOKIES_MIDHI, OnCookiesIE6  )
		COMMAND_ID_HANDLER_EX( ID_URLACTION_COOKIES_MID  , OnCookiesIE6  )
		COMMAND_ID_HANDLER_EX( ID_URLACTION_COOKIES_LOW  , OnCookiesIE6  )
		COMMAND_ID_HANDLER_EX( ID_URLACTION_COOKIES_ALL  , OnCookiesIE6  )

		MSG_WM_USER_HILIGHT 			( OnHilight 	   );
		MSG_WM_USER_FIND_KEYWORD		( OnFindKeyWord    );
		MSG_WM_USER_WINDOWS_CLOSE_CMP	( OnWindowCloseCmp );

		COMMAND_ID_HANDLER( ID_SEARCHBAR_SEL_DOWN, OnSearchBarCmd )
		COMMAND_ID_HANDLER( ID_SEARCHBAR_SEL_UP  , OnSearchBarCmd )
		COMMAND_ID_HANDLER( ID_SEARCHBAR_HILIGHT , OnSearchBarCmd )

		MSG_WM_USER_CHANGE_CSS			( OnChangeCSS )
		COMMAND_ID_HANDLER( ID_PRIVACYREPORT, OnPrivacyReport )
		// ^^^

		//minit
		COMMAND_ID_HANDLER( ID_SPECIAL_HOME 	, OnSpecialKeys    )
		COMMAND_ID_HANDLER( ID_SPECIAL_END		, OnSpecialKeys    )
		COMMAND_ID_HANDLER( ID_SPECIAL_PAGEUP	, OnSpecialKeys    )
		COMMAND_ID_HANDLER( ID_SPECIAL_PAGEDOWN , OnSpecialKeys    )
		COMMAND_ID_HANDLER( ID_SPECIAL_UP		, OnSpecialKeys    )
		COMMAND_ID_HANDLER( ID_SPECIAL_DOWN 	, OnSpecialKeys    )
		COMMAND_ID_HANDLER( ID_SECURITYREPORT	, OnSecurityReport )
		COMMAND_ID_HANDLER_EX( ID_SETFOCUS_SEARCHBAR_ENGINE, OnSetFocusSearchBarEngine )

		USER_MEG_WM_MENU_REFRESH_FAV		( OnMenuRefreshFav		)
		USER_MEG_WM_MENU_REFRESH_FAV_GROUP	( OnMenuRefreshFavGroup )
		USER_MEG_WM_MENU_REFRESH_SCRIPT 	( OnMenuRefreshScript	)
		USER_MSG_WM_MENU_RESTRICT_MESSAGE	( OnRestrictMessage 	)

		COMMAND_ID_HANDLER( ID_WINDOW_THUMBNAIL 		  , OnWindowThumbnail			)
		COMMAND_ID_HANDLER( ID_SPECIAL_REFRESH_SEARCHENGIN, OnSpecialRefreshSearchEngine) 	//Ȃ
		COMMAND_ID_HANDLER( ID_RECENT_DOCUMENT			  , OnMenuRecentLast			)

		COMMAND_ID_HANDLER( ID_SEARCHENGINE_MENU		  , OnSearchEngineMenu 			)	//+++
		COMMAND_RANGE_HANDLER_EX(ID_INSERTPOINT_SEARCHENGINE, ID_INSERTPOINT_SEARCHENGINE_END, OnSearchWeb_engineId)	//+++


		USER_MSG_WM_MENU_RECENTDOCUMENT( OnMenuRecentDocument )

		COMMAND_ID_HANDLER( ID_STYLESHEET_USE_USERS, OnUseUserStyleSheet )
		COMMAND_ID_HANDLER( ID_STYLESHEET_SET_USERS, OnSetUserStyleSheet )

		USER_MSG_WM_CHANGE_SKIN 		( OnSkinChange		 )
		USER_MSG_WM_COMMAND_DIRECT		( OnCommandDirect	 )
		USER_MSG_WM_REFRESH_EXPBAR		( OnRefreshExpBar	 )
		USER_MSG_WM_SEARCH_WEB_SELTEXT	( OnSearchWebSelText )
		USER_MSG_WM_SET_EXPROPERTY		( OnSetExProperty	 )

		COMMAND_ID_HANDLER( ID_TABLIST_DEFAULT, 	OnTabListDefault	)
		COMMAND_ID_HANDLER( ID_TABLIST_VISIBLE, 	OnTabListVisible	)
		COMMAND_ID_HANDLER( ID_TABLIST_ALPHABET,	OnTabListAlphabet	)
		COMMAND_ID_HANDLER( ID_MAINFRAME_MINIMIZE,	OnMainFrameMinimize )
		COMMAND_ID_HANDLER( ID_MAINFRAME_MAXIMIZE,	OnMainFrameMaximize )
		COMMAND_ID_HANDLER( ID_MAINFRAME_NORM_MAX_SIZE,OnMainFrameNormMaxSize )
		COMMAND_ID_HANDLER( ID_SHOW_EXMENU, 		OnShowExMenu		)
		COMMAND_ID_HANDLER( ID_SELECT_USERFOLDER,	OnSelectUserFolder	)
		COMMAND_ID_HANDLER( ID_SEARCH_HISTORY,		OnSearchHistory 	)
		COMMAND_ID_HANDLER( ID_JUMP_WEBSITE,		OnJumpToWebSite 	)

		#define WM_PLUGIN_COMMAND	ID_PLUGIN_COMMAND
		MESSAGE_HANDLER 			( WM_PLUGIN_COMMAND, OnPluginCommand )
		USER_MSG_WM_OPEN_WITHEXPROP ( OnOpenWithExProp	)
		USER_MSG_WM_GET_SEARCHBAR	( OnGetSearchBar	)
		USER_MSG_WM_SHOW_TOOLBARMENU( OnShowToolBarMenu )
		COMMAND_ID_HANDLER			( ID_SHOW_ACTIVEMENU, OnShowActiveMenu )

		// UDT DGSTR //Ȃ̂ň̊֐ɂ܂Ƃ߂܂( minit )
		COMMAND_ID_HANDLER( ID_FAVTREE_BAR_STANDARD  , OnFavoriteExpBar )
		COMMAND_ID_HANDLER( ID_FAVTREE_BAR_GROUP	 , OnFavoriteExpBar )
		COMMAND_ID_HANDLER( ID_FAVTREE_BAR_SCRIPT	 , OnFavoriteExpBar )
		COMMAND_ID_HANDLER( ID_FAVTREE_BAR_USER 	 , OnFavoriteExpBar )
		COMMAND_ID_HANDLER( ID_FAVTREE_BAR_MYCOMPUTER, OnFavoriteExpBar )
		COMMAND_ID_HANDLER( ID_FAVTREE_BAR_HISTORY	 , OnFavoriteExpBar )

		COMMAND_ID_HANDLER( ID_FILE_OPEN_DEF		 , OnFileOpenDef	)

		// UDT DGSTR
		COMMAND_ID_HANDLER_EX( ID_REGISTER_AS_BROWSER, OnRegisterAsBrowser )

		CHAIN_COMMANDS_MEMBER	( m_ReBar		)
		CHAIN_COMMANDS_MEMBER	( m_MainOption	)
		CHAIN_COMMANDS_MEMBER	( m_secZone 	)
		CHAIN_COMMANDS			( CWindowMenuCommandHandler<CMainFrame> )
		CHAIN_COMMANDS			( CAppCommandHandler<CMainFrame>		)
		CHAIN_COMMANDS_TO_EXPLORERBAR( m_ExplorerBar		)

		CHAIN_MDI_CHILD_COMMANDS( )
		COMMAND_ID_HANDLER_EX	( ID_VIEW_OPTION, OnViewOption	)

		CHAIN_MSG_MAP	( CDDEMessageHandler<CMainFrame>			)
		CHAIN_MSG_MAP	( CMDIFrameTitleUpsideDownMessageHandlerWeb<CMainFrame> )
		CHAIN_MSG_MAP	( CHelpMessageLine<CMainFrame>				)
		CHAIN_MSG_MAP	( CMSMouseWheelMessageHandler<CMainFrame>	)
		CHAIN_MSG_MAP	( CReBarVerticalBorder<CMainFrame>			)

		REFLECT_CHEVRONPUSHED_NOTIFICATION( )
		CHAIN_MSG_MAP	(baseClass )
		REFLECT_NOTIFICATIONS( )	// must be last

	ALT_MSG_MAP(1 )
		MESSAGE_HANDLER( WM_ERASEBKGND	, OnMDIClientEraseBkgnd )
		MESSAGE_HANDLER( WM_SIZE		, OnMDIClientSize		)
	END_MSG_MAP()


private:
  #if 0	//+++	s
	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
	  #if 1	//+++ 
		m_bMinimized	= (wParam == SIZE_MINIMIZED);
		if (m_bFullScreen == 0 && m_bMinimized == 0)		//+++ tXN[kȊȌꍇ
			m_bOldMaximized = (wParam == SIZE_MAXIMIZED);	//+++ ő剻Ă邩ǂ`FbN
	  #endif
		return CMDIFrameWindowImpl< CMainFrame >::OnSize(uMsg, wParam, lParam, bHandled);
	}
  #endif

  #if 1	//+++
   #if 1	//+++ ŝ܂
	void ShowWindow_Restore(bool flag)
	{
		int nShow = flag ? SW_RESTORE : SW_SHOW;
		ShowWindow( nShow );
	}
   #else	//s
	void ShowWindow_Restore(bool)
	{
		int nShow = SW_SHOWNORMAL;	//SW_RESTORE;
		if (m_bMinimized)
			nShow = SW_SHOWMINIMIZED;
		if (m_bOldMaximized)		//+++ m_bFullScreen,m_bOldMaximizedݒ肳ĂƂď.
			nShow = SW_SHOWMAXIMIZED;
		ShowWindow( nShow );
	}
   #endif
  #endif

	// UDT DGSTR
	LRESULT UpdateTitleBar(LPCTSTR lpszStatusBar, DWORD dwReserved)
	{
		if ( !::IsWindowVisible(m_hWndStatusBar) )
			UpdateTitleBarUpsideDown(lpszStatusBar);

		return 0;
	}
	// ENDE


	// UH -  minit
	LRESULT OnMenuGetFav()
	{
		if ( !m_DropFavoriteMenu.m_menu.IsMenu() ) {
			CMenuHandle menu;
			menu.LoadMenu(IDR_DROPDOWN_FAV);
			m_DropFavoriteMenu.InstallExplorerMenu(menu);
			ATLTRACE("menu loaded\n");
		}

		return (LRESULT) m_DropFavoriteMenu.m_menu.m_hMenu;
	}


	LRESULT OnMenuGetFavGroup()
	{
		if ( !m_DropFavGroupMenu.m_menu.IsMenu() ) {
			CMenuHandle menu;
			menu.LoadMenu(IDR_DROPDOWN_FAVGROUP);
			m_DropFavGroupMenu.InstallExplorerMenu(menu);
		}

		return (LRESULT) m_DropFavGroupMenu.m_menu.m_hMenu;
	}


	LRESULT OnMenuGetScript()
	{
		if ( !m_DropScriptMenu.m_menu.IsMenu() ) {
			CMenuHandle menu;
			menu.LoadMenu(IDR_DROPDOWN_SCRIPT);
			m_DropScriptMenu.SetRootDirectoryPath( GetExeDirectory() + _T("Script") );
			m_DropScriptMenu.SetTargetWindow(m_hWnd);
			m_DropScriptMenu.ResetIDCount(TRUE);
			m_DropScriptMenu.InstallExplorerMenu(menu);
		}

		return (LRESULT) m_DropScriptMenu.m_menu.m_hMenu;
	}


	LRESULT OnMenuGoBack(HMENU hMenu)
	{
		HWND hMDIActive = MDIGetActive();

		return ::SendMessage(hMDIActive, WM_MENU_GOBACK, (WPARAM) (HMENU) hMenu, (LPARAM) 0);
	}


	LRESULT OnMenuGoForward(HMENU hMenu)
	{
		HWND hMDIActive = MDIGetActive();

		return ::SendMessage(hMDIActive, WM_MENU_GOFORWARD, (WPARAM) (HMENU) hMenu, (LPARAM) 0);
	}


	LRESULT OnMenuRefreshFav(BOOL bInit)
	{
		ATLTRACE("menu refreshed\n");

		if ( m_DropFavoriteMenu.m_menu.IsMenu() ) {
			if (bInit == FALSE) {
				ATLTRACE("menu terminated\n");
				m_DropFavoriteMenu.m_menu.DestroyMenu();
				m_bShow = FALSE;
			} else {
				ATLTRACE("menu initialized\n");
				m_bShow = TRUE;
			}
		}

		return S_OK;
	}


	LRESULT OnMenuRefreshFavGroup(BOOL bInit)
	{
		if ( m_DropFavGroupMenu.m_menu.IsMenu() ) {
			if (bInit == FALSE) {
				m_DropFavGroupMenu.m_menu.DestroyMenu();
				m_bShow = FALSE;
			} else {
				m_bShow = TRUE;
			}
		}

		return S_OK;
	}


	LRESULT OnMenuRefreshScript(BOOL bInit)
	{
		if ( m_DropScriptMenu.m_menu.IsMenu() ) {
			if (bInit == FALSE) {
				m_DropScriptMenu.m_menu.DestroyMenu();
				m_bShow = FALSE;
			} else {
				m_bShow = TRUE;
			}
		}

		return S_OK;
	}


	LRESULT OnRestrictMessage(BOOL bOn)
	{
		m_bShow = bOn;
		return S_OK;
	}


	void DestroyCustomDropDownMenu()
	{
		OnMenuRefreshFav(FALSE);
		OnMenuRefreshFavGroup(FALSE);
		OnMenuRefreshScript(FALSE);
	}


	// UDT DGSTR
	void OnGetOut(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		static int nShow = SW_SHOWNORMAL;

		if ( IsWindowVisible() ) {
			//+++ :Ԃ̂Ƃ̓gC
			m_bTray = true; 		//+++
			WINDOWPLACEMENT wp;
			wp.length = sizeof (WINDOWPLACEMENT);
			::GetWindowPlacement(m_hWnd, &wp);
			nShow		  = wp.showCmd;
		  #if 1 //+++ tXN[ȊOȂ獡ő傩ǂT
			if (m_bFullScreen == 0)
				m_bOldMaximized = (nShow == SW_MAXIMIZE);
		  #endif
			SetHideTrayIcon();	//+++ gCACR
			Sleep(100); 		// UDT TODO
		} else {				// just db F9 press , come here :p
			m_bTray      = false;	//+++
			//m_bMinimized = 0;
			ShowWindow_Restore(0);	//x ShowWindow( SW_SHOW /*nShow*/ );

			//+++ TrayMessage(m_hWnd, NIM_DELETE, TM_TRAY, 0, NULL);
			DeleteTrayIcon();	//+++ gCACR폜
		}
	}
	// ENDE



	// UDT DGSTR ( hide window & display icon )
	LRESULT OnMyNotifyIcon(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL & /*bHandled*/)
	{
		if ( IsWindowVisible() ) {
			return -1;
		} else {
			switch (lParam) {
			case WM_LBUTTONUP:
				ShowWindow_Restore(0);	//ShowWindow(SW_SHOW);
				DeleteTrayIcon();	//+++
				return 0;
				break;

			case WM_RBUTTONUP:
			  #if 1	//+++
				{
					::SetForegroundWindow(m_hWnd);
					CMenu/*Handle*/ 	menu0;
					menu0.LoadMenu(IDR_TRAYICON_MENU);
					if (menu0.m_hMenu == NULL)
						return 0;
					CMenuHandle menu = menu0.GetSubMenu(0);
					if (menu.m_hMenu == NULL)
						return 0;

					// |bvAbvj[J.
					POINT 	pt;
					::GetCursorPos(&pt);
					HRESULT hr = menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON| TPM_RETURNCMD, pt.x, pt.y, m_hWnd, NULL);
					if (hr == 57666/*A*/) {
						ShowWindow_Restore(0);	//ShowWindow(SW_SHOW);
						DeleteTrayIcon();	//+++
						return 0;
					}
					if (hr == 57665/*I*/) {
						DeleteTrayIcon();	//+++
						PostMessage(WM_CLOSE, 0, 0);
						break;
					}
				}
			  #else
				DeleteTrayIcon();	//+++
				PostMessage(WM_CLOSE, 0, 0);
				break;
			  #endif
			}

			return -1;
		}
	}
	// ENDE


	// UDT DGSTR
	LRESULT UpdateExpBar(LPCTSTR lpszExpBar, DWORD dwReserved)
	{
		//if(lpszExpBar == NULL) return 0;
		m_ExplorerBar.SetTitle(lpszExpBar);
		return 0;
	}
	// ENDE


	//minit
	LRESULT OnRefreshExpBar(int nType)
	{
		m_ExplorerBar.RefreshExpBar(nType);
		return 0;
	}


public:
	// Message handlers
	// alternates OpenFile
	HWND OnUserOpenFile(LPCTSTR lpszFile, DWORD openFlag)
	{
		CString 	 strFile(lpszFile);

		MtlRemoveStringHeaderAndFooter(strFile);

		if ( MtlIsExt( strFile, _T(".url") ) ) {
			return OpenInternetShortcut(strFile, openFlag);
		}

		if (  !MtlIsProtocol( strFile, _T("http") )
		   && !MtlIsProtocol( strFile, _T("https") ) )
		{
			if ( MtlPreOpenFile(strFile) )
				return NULL;	// handled
		  #if 1	//+++	^uƂ
			if (m_MDITab.GetItemCount() > 0) {
				if (strFile.Find(':') < 0 && strFile.Left(1) != _T("/") && strFile.Left(1) != _T("\\")) {	// łɋ̓IȃpXłȂƂA
					HWND			hWndChild 	= m_MDITab.GetTabHwnd(m_MDITab.GetCurSel());
					CChildFrame*	pChild 		= GetChildFrame(hWndChild);
					if (pChild) {		// ANeBuy[W݂
						CString strBase  = pChild->GetLocationURL();
						CString str7     = strBase.Left(7);
						if (str7 == "file://") {	// file://΁A[Jł̃fBNgړ낤Ƃ݂Ȃ
							strFile = MakeFullPath( strBase, strFile );	// tpX
						}
					}
				}
			}
		  #endif
		}

		if (strFile.GetLength() > INTERNET_MAX_PATH_LENGTH)
			return NULL;

		if ( strFile == _T("javascript:location.reload()") )
			return NULL;

		// UH (JavaScript dont create window)
		CString 	 strJava = strFile.Left(11);
		strJava.MakeUpper();

		if ( strJava == _T("JAVASCRIPT:") )
			openFlag |= D_OPENFILE_NOCREATE;

		// dfg files
		if ( MtlIsExt( strFile, _T(".dfg") ) ) {
			if ( !(CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOCLOSEDFG) )
				_LoadGroupOption(strFile, true);
			else
				_LoadGroupOption(strFile, false);

			return NULL;
		}

	  #if 1 //+++	TC^}(about:blank̕sCŌăRgAEg...
			//+++	unDonut+AƋ@\ĂȂ悤?A킴킴KvȂȁA)
			//+++   ƋCς̂ŏt̎b蕜
		// minit(about:* pages)
		{
			CString strAbout = strFile.Left(6);
			if ( strAbout == _T("about:") && strFile != _T("about:blank") ) {
				HWND hWndAbout =  _OpenAboutFile(strFile);
				if (hWndAbout)
					return hWndAbout;
			}
		}
	  #endif

		HWND	hWndActive = MDIGetActive();

		int 	nCmdShow   = _check_flag(D_OPENFILE_ACTIVATE, openFlag) ? -1 : SW_SHOWNOACTIVATE;
		if (hWndActive == NULL) {					// no window yet
			nCmdShow = -1;							// always default
		}

		if ( hWndActive != NULL && _check_flag(D_OPENFILE_NOCREATE, openFlag) ) {
			CWebBrowser2 browser = DonutGetIWebBrowser2(hWndActive);

			if ( !browser.IsBrowserNull() ) {
				browser.Navigate2(strFile);

				if ( !_check_flag(D_OPENFILE_NOSETFOCUS, openFlag) ) {
					// reset focus
					::SetFocus(NULL);
					MtlSendCommand(hWndActive, ID_VIEW_SETFOCUS);
				}

				return NULL;
				//return hWndActive;
			}
		}

	 	//+++
		//x if (CMainOption::s_dwMainExtendedStyle & (/*MAIN_EX_NOACTIVATE_NEWWIN|*/MAIN_EX_NEWWINDOW))
		{
			CChildFrame* pChild 	  = CChildFrame::NewWindow(m_hWndMDIClient, m_MDITab, m_AddressBar, false/*true*/);
			if (pChild == NULL)
				return NULL;

			if ( !strFile.IsEmpty() ) {
				pChild->SetWaitBeforeNavigate2Flag();			//+++ ABeforeNavigate2()s܂ł̊ԃAhXo[XVȂ悤ɂtOon... sv낤...
				m_OnUserOpenFile_nCmdShow = pChild->ActivateFrame(nCmdShow);
				pChild->Navigate2(strFile);
pChild->ForceMessageLoop(); 		//+++ sv̂͂AĂȂ̂ȂAÔߎcĂ...
			} else {
				m_OnUserOpenFile_nCmdShow = pChild->ActivateFrame(nCmdShow);
			}

			if ( !_check_flag(D_OPENFILE_NOSETFOCUS, openFlag) ) {
				if (MDIGetActive() == pChild->m_hWnd) { // a new window activated, so automatically set focus
					// reset focus
					::SetFocus(NULL);
					MtlSendCommand(pChild->m_hWnd, ID_VIEW_SETFOCUS);
				} else {
					// It's reasonable not to touch a current focus.
				}
			}

			return pChild->m_hWnd;
		}
	}


private:
	LRESULT OnGetSearchBar()
	{
		return (LRESULT) &m_SearchBar;
	}


	LRESULT OnOpenWithExProp(_EXPROP_ARGS *pArgs)
	{
		if (!pArgs)
			return 0;

		HWND		 hWndNew = OpenUrlWithExProp(pArgs->strUrl, pArgs->dwOpenFlag, pArgs->strIniFile, pArgs->strSection);
		if (!hWndNew)
			hWndNew = MDIGetActive();

		CChildFrame *pChild  = GetChildFrame(hWndNew);

		if (pChild) {
			// IvV擾
			DWORD		dwStatus;
			{
				CIniFileI pr( g_szIniFileName, _T("Search") );
				dwStatus  = pr.GetValue( _T("Status"), 0 );
			}

			CString 	str 	 = pArgs->strSearchWord;

			// uSp𔼊pɒuv`FbNĂϊĎqEBhEɕnB
			if (dwStatus & STS_TEXT_FILTER)
				m_SearchBar.FilterString(str);

		  	//+++ qɌݒ𔽉f (֐)
		   #if defined USE_UNDONUT_G_SRC
			if (dwStatus & STS_AUTOHILIGHT)
				pChild->SetSearchWordAutoHilight( str, 1 );
		   #else
			pChild->SetSearchWordAutoHilight( str, (dwStatus & STS_AUTOHILIGHT) != 0 );
		   #endif
		}

		return (LRESULT) hWndNew;
	}


	HWND OpenInternetShortcut(CString strUrlFile, DWORD dwOpenFlag)
	{
		CString strUrl = strUrlFile;

		if ( !MTL::ParseInternetShortcutFile(strUrl) )
			return NULL;

		return OpenUrlWithExProp(strUrl, dwOpenFlag, strUrlFile);
	}


	HWND OpenUrlWithExProp(CString strUrl, DWORD dwOpenFlag, DWORD dwExProp)
	{
		if ( _check_flag(D_OPENFILE_NOCREATE, dwOpenFlag) ) {
			return OpenExPropertyActive(strUrl, dwExProp, dwOpenFlag);		//̃^uŊJ
		} else {
			return OpenExPropertyNew(strUrl, dwExProp, dwOpenFlag); 		//VKɊJ
		}
	}


	HWND OpenUrlWithExProp(CString strUrl, DWORD dwOpenFlag, CString strIniFile, CString strSection = DONUT_SECTION)
	{
		DWORD dwExProp;

		if ( CExProperty::CheckExPropertyFlag(dwExProp, strIniFile, strSection) ) {
			if ( _check_flag(D_OPENFILE_NOCREATE, dwOpenFlag) ) {
				return OpenExPropertyActive(strUrl, dwExProp, dwOpenFlag);	//̃^uŊJ
			} else {
				return OpenExPropertyNew(strUrl, dwExProp, dwOpenFlag); 	//VKɊJ
			}
		} else {
			return OpenExPropertyNot(strUrl, dwOpenFlag);					//WIvVŊJ
		}
	}


	//^uɃirQ[ĝɊgݒKp
	HWND OpenExPropertyActive(CString &strUrl, DWORD dwExProp, DWORD dwOpenFlag)
	{
		dwOpenFlag |= D_OPENFILE_NOCREATE;

		//ANeBuȃ^uirQ[gbNĂ邩mF
		HWND		 hWndActive = MDIGetActive();

		if ( ::IsWindow(hWndActive) ) {
			CChildFrame *pChild = GetChildFrame(hWndActive);

			if (pChild) {
				DWORD dwExFlag = pChild->m_view.m_ViewOption.m_dwExStyle;

				if (dwExFlag & DVS_EX_OPENNEWWIN)
					return OpenExPropertyNew(strUrl, dwExProp, dwOpenFlag);
			}
		}

		//擾URLANeBuȃ^uŊJiWɔCj
		BOOL		 bOpened	= FALSE;
		HWND		 hWndNew	= OnUserOpenFile(strUrl, dwOpenFlag);

		if (hWndNew && !hWndActive) {
			hWndActive = hWndNew;											//EBhÊŐVKɊJ
			bOpened    = TRUE;
		}

		//gvpeBKp
		CChildFrame *pChild 	= GetChildFrame(hWndActive);

		if (!pChild)
			return NULL;

		CExProperty  ExProp(CDLControlOption::s_dwDLControlFlags, CDLControlOption::s_dwExtendedStyleFlags, 0, dwExProp);

		pChild->m_view.PutDLControlFlags( ExProp.GetDLControlFlags() );
		pChild->SetViewExStyle(ExProp.GetExtendedStyleFlags(), TRUE);
		pChild->m_view.m_ViewOption.SetAutoRefreshStyle( ExProp.GetAutoRefreshFlag() );

		if (bOpened)
			return hWndActive;

		return NULL;
	}


	//VK^uĴgݒKp
	HWND OpenExPropertyNew(CString &strUrl, DWORD dwExProp, DWORD dwOpenFlag)
	{
		dwOpenFlag &= ~D_OPENFILE_NOCREATE;

		//URLŐVK^uJ
		HWND		 hWndNew = OnUserOpenFile(strUrl, dwOpenFlag);

		if ( !::IsWindow(hWndNew) )
			return NULL;

		//gvpeBKp
		CChildFrame *pChild  = GetChildFrame(hWndNew);

		if (!pChild)
			return NULL;

		CExProperty  ExProp(CDLControlOption::s_dwDLControlFlags, CDLControlOption::s_dwExtendedStyleFlags, 0, dwExProp);

		pChild->m_view.PutDLControlFlags( ExProp.GetDLControlFlags() );
		pChild->SetViewExStyle(ExProp.GetExtendedStyleFlags(), TRUE);
		pChild->m_view.m_ViewOption.SetAutoRefreshStyle( ExProp.GetAutoRefreshFlag() );

		return hWndNew;
	}


	//^uĴAW̐ݒKp
	HWND OpenExPropertyNot(CString &strUrl, DWORD dwOpenFlag)
	{
		//ANeBuȃ^uirQ[gbNĂ邩mF
		HWND hWndActive = MDIGetActive();

		if ( ::IsWindow(hWndActive) ) {
			CChildFrame *pChild = GetChildFrame(hWndActive);

			if (pChild) {
				DWORD dwExFlag = pChild->m_view.m_ViewOption.m_dwExStyle;

				if (dwExFlag & DVS_EX_OPENNEWWIN)
					dwOpenFlag &= ~D_OPENFILE_NOCREATE; 			//VK^uŊJ悤
			}
		}

		//擾URLJ
		HWND hWndNew	= OnUserOpenFile(strUrl, dwOpenFlag);

		if (hWndNew) {
			//VKɊJ^uȂ̂ŉȂĂ悢
			return hWndNew;
		} else {
			//IvVŴ̂ŏ㏑
			CChildFrame *pChild = GetChildFrame( MDIGetActive() );

			if (!pChild)
				return NULL;

			pChild->m_view.PutDLControlFlags(CDLControlOption::s_dwDLControlFlags);
			pChild->SetViewExStyle(CDLControlOption::s_dwExtendedStyleFlags, TRUE);
			pChild->m_view.m_ViewOption.SetAutoRefreshStyle(0);
		}

		return NULL;
	}


	LRESULT OnMenuDrag(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
	{
		return m_wndMenuDropTarget.OnMenuDrag(uMsg, wParam, lParam, bHandled);
	}


	LRESULT OnMenuGetObject(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
	{
		return m_wndMenuDropTarget.OnMenuGetObject(uMsg, wParam, lParam, bHandled);
	}


	//////////////////////////////////////////////////////////////////
	// to avoid the flicker on resizing
	LRESULT OnMDIClientEraseBkgnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
	{
	  #if 0 //+++ `͈͂̍XVƐłĂȂ̂őʖ
		BOOL	bMaximized = 0;
		HWND	hWndActive = MDIGetActive(&bMaximized);
		if (hWndActive != NULL && (CMainOption::s_bTabMode || bMaximized))
			return 1;
	  #else
		HWND	hWndActive = MDIGetActive();
		if (hWndActive != NULL && CMainOption::s_bTabMode)
			return 1;
	  #endif

	  #if 1 //*+++ BG`w.
		if (drawMainFrameBg((HDC)wParam))
			return 1;
	  #endif

		// no need to erase it
		bHandled = FALSE;
		return 0;
	}


	LRESULT OnMDIClientSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
	{
		PostMessage(WM_COMMAND, MAKEWPARAM(ID_RESIZED, 0), 0);

		BOOL	bMaximized = FALSE;
		HWND	hWndActive = MDIGetActive(&bMaximized);

		if (CMainOption::s_bTabMode || hWndActive == NULL || bMaximized == FALSE) { // pass to default
			bHandled = FALSE;
			return 1;
		}

		// NOTE. If you do the following, you can avoid the flicker on resizing.
		//		 I can't understand why it is effective...
		//
		//		 But still you can get a glimpse of other mdi child window's frames.
		//		 I guess it's MDI's bug, but I can't get the way MFC fixed.
		CWindow wndActive(hWndActive);
		CWindow wndView    = wndActive.GetDlgItem(ID_DONUTVIEW);
		wndActive.ModifyStyle(0, WS_CLIPCHILDREN);									// add WS_CLIPCHILDREN
		wndView.ModifyStyle(0, WS_CLIPCHILDREN);
		LRESULT lRet	   = m_wndMDIClient.DefWindowProc(uMsg, wParam, lParam);
		m_wndMDIClient.UpdateWindow();
		wndActive.ModifyStyle(WS_CLIPCHILDREN, 0);
		wndView.ModifyStyle(WS_CLIPCHILDREN, 0);

		bHandled = FALSE;
		return lRet;
	}


	//////////////////////////////////////////////////////////////////
	// custom draw of addressbar
	LRESULT OnNotify(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
	{
		bHandled = FALSE;

		LPNMHDR lpnmh = (LPNMHDR) lParam;
		LRESULT lRet  = 0;

		if (lpnmh->code == NM_CUSTOMDRAW && lpnmh->hwndFrom == m_hWndToolBar) { 	// from rebar
			lRet = m_AddressBar.OnCustomDraw(0, lpnmh, bHandled);
		}

		if (lpnmh->code == TBN_DROPDOWN) {
			int nCount = CPluginManager::GetCount(PLT_TOOLBAR);

			for (int nIndex = 0; nIndex < nCount; nIndex++) {
				HWND	hWndBar = CPluginManager::GetHWND(PLT_TOOLBAR, nIndex);

				if (lpnmh->hwndFrom != hWndBar)
					continue;

				CPluginManager::Call_ShowToolBarMenu(PLT_TOOLBAR, nIndex, ( (LPNMTOOLBAR) lpnmh )->iItem);

				bHandled = TRUE;
				break;
			}
		}

		return lRet;
	}


	//////////////////////////////////////////////////////////////////
	// the custom message from MDI child
	void OnMDIChild(HWND hWnd, UINT nCode)
	{
		SetMsgHandled(FALSE);

		if (nCode == MDICHILD_USER_ALLCLOSED) {
			m_AddressBar.SetWindowText( _T("") );
			::SetWindowText( m_hWndStatusBar, _T("fB") );
			m_CmdBar.EnableButton(_nPosWindowMenu, false);
		} else if (nCode == MDICHILD_USER_FIRSTCREATED) {
			m_CmdBar.EnableButton(_nPosWindowMenu, true);
		} else if (nCode == MDICHILD_USER_ACTIVATED) {
			_OnMDIActivate(hWnd);
			OnIdle();						// make sure when cpu is busy
		} else if (nCode == MDICHILD_USER_TITLECHANGED) {
			//OnTitleChanged();
		}
	}


	BOOL OnBrowserCanSetFocus()
	{										// asked by browser
		HWND hWndFocus = ::GetFocus();

		if (hWndFocus == NULL)
			return TRUE;

		if ( ::IsChild(m_hWndToolBar, hWndFocus) )
			return FALSE;

		if ( m_ExplorerBar.IsChild(hWndFocus) )
			return FALSE;

		return TRUE;
	}


	void OnParentNotify(UINT fwEvent, UINT idChild, LPARAM lParam)
	{
		if (fwEvent != WM_RBUTTONDOWN)
			return;

		CPoint		pt( GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) );
		ClientToScreen(&pt);

		CRect		rc;
		::GetClientRect(m_hWndToolBar, &rc);
		CPoint		ptRebar  = pt;
		::ScreenToClient(m_hWndToolBar, &ptRebar);

		if ( !rc.PtInRect(ptRebar) )		// not on rebar
			return;

		HWND		hWnd	 = ::WindowFromPoint(pt);

		if (hWnd == m_MDITab.m_hWnd) {		// on tab bar
			CPoint ptTab = pt;
			m_MDITab.ScreenToClient(&ptTab);

			if (m_MDITab.HitTest(ptTab) != -1)
				return;
		}

		CMenuHandle menuView = ::GetSubMenu(m_CmdBar.GetMenu(), _nPosViewMenu);
		CMenuHandle menu	 = menuView.GetSubMenu(0);
		menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, pt.x, pt.y, m_hWnd, NULL);
	}


	void OnDestroy()
	{
		SetMsgHandled(FALSE);
		MtlSendCommand(m_hWnd, ID_VIEW_STOP_ALL);									// added by DOGSTORE

		//CSearchBoxHook::UninstallSearchHook();
		CDialogHook::UninstallHook();

		//fobOEBhE폜
		m_wndDebug.Destroy();

		//SvOC
		CPluginManager::Term();

		m_ReBar.UnsubclassWindow();

		//obNAbvXbh̊J
		if (m_hGroupThread) {
			DWORD dwResult = ::WaitForSingleObject(m_hGroupThread, DONUT_BACKUP_THREADWAIT);

			if (dwResult == WAIT_TIMEOUT) {
				ErrorLogPrintf("MainFrame::OnDestroyɂāAXVXbh̏IoȂ͗l\n");
				::TerminateThread(m_hGroupThread, 1);
			}

			CloseHandle(m_hGroupThread);
			m_hGroupThread = NULL;			//+++ ŌƂ͂Aꉞ NULLƂ.
		}

		// Note. The script error dialog makes the app hung up.
		//		 I can't find the reason, but I can avoid it by closing
		//		 windows explicitly.
		MtlCloseAllMDIChildren(m_hWndMDIClient);

		CCriticalIdleTimer::UninstallCriticalIdleTimer();

		// what can I trust?
		ATLASSERT( ::IsMenu(m_hMenu) );
		::DestroyMenu(m_hMenu);

		_RemoveTmpDirectory();
		DestroyCustomDropDownMenu();

		RevokeDragDrop();
	}


	void OnEndSession(BOOL wParam, UINT lParam) 									//ShutDown minit
	{
		if (wParam == TRUE) {
			OnDestroy();
			_PrivateTerm();
		}
	}


	void OnActivate(UINT nState, BOOL bMinimized, HWND hWndOther)
	{
		if (nState == WA_INACTIVE) {
			m_hWndFocus = ::GetFocus();
		} else {
			if (m_hWndFocus)
				::SetFocus(m_hWndFocus);
		}
	}


	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL & /*bHandled*/)
	{
		CFavoritesMenuOption::Add(m_hWnd);

		//////////////////////////////////////////////////////////////////
		// tHg
		{
			CIniFileI		prFont( g_szIniFileName, _T("Main") );
			MTL::CLogFont	lf;
			lf.InitDefault();
			if ( lf.GetProfile(prFont) ) {
				CFontHandle 	font;
				MTLVERIFY( font.CreateFontIndirect(&lf) );
				if (font.m_hFont) {
					if (m_font.m_hFont != NULL)
						m_font.DeleteObject();
					m_font.Attach(font.m_hFont);
					SetFont(m_font);
				}
			}
		}

		//////////////////////////////////////////////////////////////////
		//fobOEBhE̍쐬
		m_wndDebug.Create();

		//////////////////////////////////////////////////////////////////
		// initialize menus' infomation
		CMenuHandle 	   menu 		  = m_hMenu;
		CMenuHandle 	   menuFav		  = menu.GetSubMenu(_nPosFavoriteMenu);
		m_FavoriteMenu.InstallExplorerMenu(menuFav);
		m_FavoriteMenu.SetTargetWindow(m_hWnd);

		CMenuHandle 	   menuGroup	  = menuFav.GetSubMenu(_nPosFavGroupMenu);
		m_FavGroupMenu.InstallExplorerMenu(menuGroup);
		m_FavGroupMenu.SetTargetWindow(m_hWnd);

		CMenuHandle 	   menuCss		  = menu.GetSubMenu(_nPosCssMenu);
		CMenuHandle 	   menuCssSub	  = menuCss.GetSubMenu(_nPosSubCssMenu);
		m_styleSheetMenu.SetRootDirectoryPath( GetExeDirectory() + _T("CSS") );
		m_styleSheetMenu.SetTargetWindow(m_hWnd);
		m_styleSheetMenu.ResetIDCount(TRUE);
		m_styleSheetMenu.InstallExplorerMenu(menuCssSub);

		m_ScriptMenuMst.LoadMenu(IDR_SCRIPT);
		m_ScriptMenu.SetRootDirectoryPath( GetExeDirectory() + _T("Script") );
		m_ScriptMenu.SetTargetWindow(m_hWnd);
		m_ScriptMenu.ResetIDCount(TRUE);
		m_ScriptMenu.InstallExplorerMenu(m_ScriptMenuMst);

		OnMenuGetFav(); 	//initialize custom context dropdown
		OnMenuGetFavGroup();
		OnMenuGetScript();

		CMenuHandle 	   menuEncode	  = menu.GetSubMenu(_nPosEncodeMenu);
		m_MenuEncode.Init(menuEncode, m_hWnd, _nPosEncodeMenuSub);

		// MRU list
		CMainOption::SetMRUMenuHandle(menu, _nPosMRU);

		//MenuDropTaget
		m_wndMenuDropTarget.Create(m_hWnd, rcDefault, _T("MenuDropTargetWindow"), WS_POPUP, 0);
		m_wndMenuDropTarget.SetTargetMenu(menu);

		//////////////////////////////////////////////////////////////////
		// create command bar window
		SetMenu(NULL);		// remove menu
		HWND	hWndCmdBar	  = m_CmdBar.Create(m_hWnd,rcDefault,NULL,MTL_SIMPLE_CMDBAR2_PANE_STYLE,0,ATL_IDW_COMMAND_BAR);
		if (m_font.m_hFont) {
			LOGFONT lf;
			m_font.GetLogFont(lf);
			m_CmdBar.SetMenuLogFont(lf);
		}

		m_CmdBar.AttachMenu(m_hMenu);
		m_CmdBar.EnableButton(_nPosWindowMenu, false);

		//////////////////////////////////////////////////////////////////
		// create toolbar
		HWND	hWndToolBar   = m_ToolBar.DonutToolBar_Create(m_hWnd);
		ATLASSERT( ::IsWindow(hWndToolBar) );
		m_ToolBar.DonutToolBar_SetFavoritesMenu(menuFav, menuGroup, menuCssSub);

		if (m_CmdBar.m_fontMenu.m_hFont)
			m_ToolBar.SetFont(m_CmdBar.m_fontMenu.m_hFont);

		//////////////////////////////////////////////////////////////////
		// create addressbar
		HWND	hWndAddressBar = m_AddressBar.Create( m_hWnd, IDC_ADDRESSBAR, ID_VIEW_GO,
													/*+++ IDB_GOBUTTON, IDB_GOBUTTON_HOT,*/ 16, 16, RGB(255, 0, 255) );
		ATLASSERT( ::IsWindow(hWndAddressBar) );

		if (m_CmdBar.m_fontMenu.m_hFont)
			m_AddressBar.SetFont(m_CmdBar.m_fontMenu.m_hFont);

		m_AddressBar.m_comboFlat.SetDrawStyle(CSkinOption::s_nComboStyle);

		//////////////////////////////////////////////////////////////////
		// create searchbar
		HWND	hWndSearchBar  = m_SearchBar.Create(m_hWnd);

		if (m_CmdBar.m_fontMenu.m_hFont)
			m_SearchBar.SetFont(m_CmdBar.m_fontMenu.m_hFont);

		m_SearchBar.SetDlgCtrlID(IDC_SEARCHBAR);
		m_SearchBar.SetComboStyle(CSkinOption::s_nComboStyle);

		//////////////////////////////////////////////////////////////////
		// create tabctrl
		HWND	hWndMDITab	  = m_MDITab.Create(m_hWnd, CRect(0, 0, 200, 20), _T("Donut MDITab"),
													WS_CHILD | WS_VISIBLE, NULL, IDC_MDITAB);
		m_MDITab.LoadMenu(IDR_MENU_TAB);
		m_MDITab.LoadConnectingAndDownloadingImageList( IDB_MDITAB, 6, 6, RGB(255, 0, 255) );

		//////////////////////////////////////////////////////////////////
		// create link bar
		{
			DWORD		dwStyle = 0;
			CIniFileI prLnk( g_szIniFileName, _T("LinkBar") );
			prLnk.QueryValue( dwStyle, _T("ExtendedStyle") );
			m_LinkBar.SetOptionalStyle(dwStyle);
		}
		HWND	hWndLinkBar   = m_LinkBar.Create(m_hWnd, rcDefault, NULL, ATL_SIMPLE_TOOLBAR_PANE_STYLE, 0, IDC_LINKBAR);

		//////////////////////////////////////////////////////////////////
		// create rebar
		DWORD			   dwNoBoader	  = 0;
		DWORD			   dwRebarStyle   = MTL_SIMPLE_REBAR_STYLE | RBS_DBLCLKTOGGLE;
		{
			CIniFileI	   pr( g_szIniFileName, _T("ReBar") );
			pr.QueryValue( dwNoBoader, _T("NoBoader") );
		}
		if (dwNoBoader)
			dwRebarStyle &= ~RBS_BANDBORDERS;

		CreateSimpleReBar(dwRebarStyle);
		m_ReBar.SubclassWindow(m_hWndToolBar);

		//CreateSimpleReBar(MTL_SIMPLE_REBAR_STYLE | RBS_DBLCLKTOGGLE);

		if (m_CmdBar.m_fontMenu.m_hFont) {
			::SendMessage( m_hWndToolBar, WM_SETFONT, (WPARAM) m_CmdBar.m_fontMenu.m_hFont, MAKELPARAM(TRUE, 0) );
			m_LinkBar.SetFont(m_CmdBar.m_fontMenu.m_hFont);
		}

		//////////////////////////////////////////////////////////////////
		// create statusbar
		//CreateSimpleStatusBar();
		m_wndStatusBar.Create(m_hWnd, ATL_IDS_IDLEMESSAGE,
								 WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | SBARS_SIZEGRIP | SBT_TOOLTIPS);

		m_hWndStatusBar = m_wndStatusBar.m_hWnd;
		//		int nPanes[] = { ID_DEFAULT_PANE, ID_PROGRESS_PANE, ID_COMBOBOX_PANE};
		static const int   nPanes[] = { ID_DEFAULT_PANE, ID_PROGRESS_PANE, ID_PRIVACY_PANE, ID_SECURE_PANE, ID_COMBOBOX_PANE };
		m_wndStatusBar.SetPanes( (int *) nPanes, 5, false );
		m_wndStatusBar.SetCommand( ID_PRIVACY_PANE, ID_PRIVACYREPORT );
		m_wndStatusBar.SetCommand( ID_SECURE_PANE, ID_SECURITYREPORT);
		m_wndStatusBar.SetIcon( ID_PRIVACY_PANE, 1 );				//minit
		m_wndStatusBar.SetIcon( ID_SECURE_PANE, 0 );				//minit
		m_wndStatusBar.SetOwnerDraw( m_wndStatusBar.IsValidBmp() );

		// UH
		InitStatusBar();

		//////////////////////////////////////////////////////////////////
		// create prgress bar
		RECT			   rect;
		m_wndProgress.Create(m_hWndStatusBar, NULL, NULL, WS_CHILD | WS_CLIPSIBLINGS | PBS_SMOOTH, 0, IDC_PROGRESS);
		m_wndProgress.ModifyStyleEx(WS_EX_STATICEDGE, 0);

		// ProxyR{{bNX
		// IEProxygꍇAR{{bNXƃXe[^Xo[ProxyyC폜
		m_cmbBox.Create(m_hWndStatusBar, rect, NULL,
						 WS_CHILD | WS_CLIPSIBLINGS | PBS_SMOOTH | CBS_DROPDOWNLIST | WS_VSCROLL | WS_TABSTOP, 0, IDC_COMBBOX);

		m_cmbBox.SetFont( m_wndStatusBar.GetFont() );
		m_cmbBox.SetDrawStyle(CSkinOption::s_nComboStyle);
		m_cmbBox.IsUseIE() ? m_cmbBox.ShowWindow(SW_HIDE)
						   : m_cmbBox.ShowWindow(SW_SHOWNORMAL);
		m_cmbBox.ResetProxyList();

		//////////////////////////////////////////////////////////////////
		// Plugin Toolbar Load
		CPluginManager::Init();
		CPluginManager::ReadPluginData(PLT_TOOLBAR, m_hWnd);
		CPluginManager::LoadAllPlugin(PLT_TOOLBAR, m_hWnd, true);	//c[o[vOCS[h

		{
			int nCount = CPluginManager::GetCount(PLT_TOOLBAR);
			for (int i = 0; i < nCount; i++) {
				HWND hWnd = CPluginManager::GetHWND(PLT_TOOLBAR, i);

				if ( ::IsWindow(hWnd) )
					::SetProp( hWnd, _T("Donut_Plugin_ID"), HANDLE( IDC_PLUGIN_TOOLBAR + i) );
			}
		}
		//LoadPluginToolbars();

		//////////////////////////////////////////////////////////////////
		// load band position
		int 			   nToolbarPluginCount = CPluginManager::GetCount(PLT_TOOLBAR);
		CReBarBandInfo *   pRbis			   = new CReBarBandInfo[STDBAR_COUNT + nToolbarPluginCount];

		CSimpleArray<HWND> aryHWnd;
		aryHWnd.Add( hWndCmdBar 	);								// Menubar
		aryHWnd.Add( hWndToolBar	);								// Toolbar
		aryHWnd.Add( hWndAddressBar );								// Addressbar
		aryHWnd.Add( hWndMDITab 	);								// Tabbar
		aryHWnd.Add( hWndLinkBar	);								// Linkbar
		aryHWnd.Add( hWndSearchBar	);								// Searchbar

		int 			   nIndex;

		for (nIndex = 0; nIndex < aryHWnd.GetSize(); nIndex++) {
			pRbis[nIndex].nIndex	= nIndex;
			pRbis[nIndex].hWnd		= aryHWnd	  [ nIndex ];
			pRbis[nIndex].nID		= STDBAR_ID   [ nIndex ];
			pRbis[nIndex].fStyle	= STDBAR_STYLE[ nIndex ];
			pRbis[nIndex].lpText	= STDBAR_TEXT [ nIndex ];
			pRbis[nIndex].cx		= 0;
		}

		for (nIndex = 0; nIndex < nToolbarPluginCount; nIndex++) {
			pRbis[STDBAR_COUNT + nIndex].nIndex   = STDBAR_COUNT + nIndex;
			pRbis[STDBAR_COUNT + nIndex].hWnd	  = CPluginManager::GetHWND(PLT_TOOLBAR, nIndex);
			pRbis[STDBAR_COUNT + nIndex].nID	  = IDC_PLUGIN_TOOLBAR + nIndex;
			pRbis[STDBAR_COUNT + nIndex].fStyle   = RBBS_BREAK;
			pRbis[STDBAR_COUNT + nIndex].lpText   = NULL;
			pRbis[STDBAR_COUNT + nIndex].cx 	  = 0;
		}

		{
			CIniFileI pr( g_szIniFileName, _T("ReBar") );
			MtlGetProfileReBarBandsState( pRbis, pRbis + STDBAR_COUNT + nToolbarPluginCount, pr, *this);
			//x pr.Close(); 	//+++
		}

		delete[] pRbis; 											//memory leak bug Fix  minit

		m_CmdBar.RefreshBandIdealSize(m_hWndToolBar);
		m_AddressBar.InitReBarBandInfo(m_hWndToolBar);				// if you dislike a header, remove this.
		ShowLinkText( (m_AddressBar.m_dwAddressBarExtendedStyle & ABR_EX_TEXTVISIBLE) != 0 );

		//////////////////////////////////////////////////////////////////
		// load status bar state
		{
			CIniFileI pr( g_szIniFileName, _T("Main") );
			BOOL	bStatusBarVisible = TRUE;
			MtlGetProfileStatusBarState(pr, m_hWndStatusBar, bStatusBarVisible);
			m_bStatusBarVisibleUnlessFullScreen = bStatusBarVisible;
			//x pr.Close();
		}

		//////////////////////////////////////////////////////////////////
		// create mdi client window
		m_menuWindow	= ::GetSubMenu(m_hMenu, _nPosWindowMenu);
		CreateMDIClient(m_menuWindow.m_hMenu);
		m_wndMDIClient.SubclassWindow(m_hWndMDIClient);

		// NOTE: If WS_CLIPCHILDREN not set, MDI Client will try erase background over MDI child window,
		//		 but as OnEraseBkgnd does nothing, it goes well.
		if (CMainOption::s_bTabMode)
			m_wndMDIClient.ModifyStyle(WS_CLIPCHILDREN, 0); 		// to avoid flicker, but scary

		//////////////////////////////////////////////////////////////////
		// splitter window
		m_hWndClient	= m_wndSplit.Create(m_hWnd, rcDefault, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN);

		m_wndSplit.SetSplitterExtendedStyle(0);

		//////////////////////////////////////////////////////////////////
		// pane container
		m_ExplorerBar.Create(m_hWndClient);
		m_ExplorerBar.Init(m_hWndMDIClient);


		//////////////////////////////////////////////////////////////////
		// MDIClient misc
		m_mcCmdBar.InstallAsMDICmdBar(hWndCmdBar, m_hWndMDIClient, CMainOption::s_bTabMode);
		m_mcToolBar.InstallAsStandard(hWndToolBar, m_hWnd, true, ID_VIEW_FULLSCREEN);
		DWORD		  dwNoButton = 0;
		{
			CIniFileI pr( _GetFilePath( _T("Menu.ini") ), _T("Option") );
			pr.QueryValue( dwNoButton, _T("NoButton") );
		}
		bool		  bNoButton  = dwNoButton != 0/*? true : false*/;
		m_mcCmdBar.ShowButton(!bNoButton);
		//m_mcToolBar.ShowButton(!bNoButton);
		m_MDITab.SetMDIClient(m_hWndMDIClient);


		//////////////////////////////////////////////////////////////////
		// set up UI
		CmdUIAddToolBar(hWndToolBar);
		CmdUIAddToolBar(m_SearchBar.m_wndToolBar);

		// UDT DGSTR ( set User Agent )
		::UrlMkSetSessionOption(URLMON_OPTION_USERAGENT , (void *) CDLControlOption::s_szUserAgent , lstrlen(CDLControlOption::s_szUserAgent) , 0);
		// ENDE

		// message loop
		CMessageLoop *pLoop 	 = _Module.GetMessageLoop();
		pLoop->AddMessageFilter(this);
		pLoop->AddIdleHandler(this);

		// read general settings
		_ReadProfile();
		// for dragging files
		RegisterDragDrop(); 										//DragAcceptFiles();

		CCriticalIdleTimer::InstallCriticalIdleTimer(m_hWnd, ID_VIEW_IDLE);

		// VXej[ɒǉ
		HMENU		  hSysMenu	 = ::GetSystemMenu(m_hWnd, FALSE);
		//		::AppendMenu(hSysMenu, MF_ENABLED|MF_STRING, ID_VIEW_COMMANDBAR, _T("j[\"));

		char		  cText[]	 = "j[\";
		MENUITEMINFO  menuInfo;
		memset( &menuInfo, 0, sizeof (MENUITEMINFO) );
		menuInfo.cbSize 	= sizeof (MENUITEMINFO);
		menuInfo.fMask		= MIIM_ID | MIIM_TYPE;
		menuInfo.fType		= MFT_STRING;
		menuInfo.wID		= ID_VIEW_COMMANDBAR;
		menuInfo.dwTypeData = cText;
		menuInfo.cch		= sizeof (cText);

		::InsertMenuItem(hSysMenu, 0, MF_BYPOSITION, &menuInfo);
		::SetTimer(m_hWnd, ENT_READ_ACCEL, 200, NULL);

		//XL
		InitSkin();

		CDonutSimpleEventManager::RaiseEvent(EVENT_INITIALIZE_COMPLETE);

		//Hook InputDialogMessage (javascript prompt())
		CDialogHook::InstallHook(m_hWnd);
		//CSearchBoxHook::InstallSearchHook(m_hWnd);

		//vOC̃A[[[fBO
		CPluginManager::LoadAllPlugin(PLT_EXPLORERBAR, m_ExplorerBar.m_PluginBar);

		//Iy[VvOC̃[h
		CPluginManager::ReadPluginData(PLT_OPERATION);

		CPluginManager::LoadAllPlugin(PLT_DOCKINGBAR, m_hWnd);

		UpdateLayout();

		return 0;
		//return lRet;
	}


	//minit
	BOOL _IsRebarBandLocked()
	{
		CReBarCtrl	  rebar(m_hWndToolBar);
		REBARBANDINFO rbbi = { 0 };

		rbbi.cbSize = sizeof (REBARBANDINFO);
		rbbi.fMask	= RBBIM_STYLE;

		if ( !rebar.GetBandInfo(0, &rbbi) )
			return FALSE;

		return (rbbi.fStyle & RBBS_NOGRIPPER) != 0;
	}


	LRESULT OnViewToolBarLock(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		CReBarSupport RebarSup(m_hWndToolBar);

		RebarSup.SetBandsLock( !_IsRebarBandLocked() );

		return 0;
	}


	//minit
	LRESULT OnViewSearchButton(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		m_SearchBar.ShowToolBarIcon( !m_SearchBar.GetToolIconState() );
		return 0;
	}


	void OnExplorerBarAutoShow(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		if (CMainOption::s_dwExplorerBarStyle & MAIN_EXPLORER_AUTOSHOW)
			CMainOption::s_dwExplorerBarStyle &= ~MAIN_EXPLORER_AUTOSHOW;
		else
			CMainOption::s_dwExplorerBarStyle |= MAIN_EXPLORER_AUTOSHOW;
	}


	LRESULT OnMouseWheel(UINT fwKeys, short zDelta, CPoint point)
	{
		// I don't have a wheel mouse...
		if ( (m_MDITab.GetMDITabExtendedStyle() & MTB_EX_WHEEL)
		   && MtlIsBandVisible(m_hWndToolBar, IDC_MDITAB) )
		{
			CRect rcTab;
			m_MDITab.GetWindowRect(&rcTab);

			if ( rcTab.PtInRect(point) ) {
				if (zDelta > 0) {
					m_MDITab.LeftTab();
				} else {
					m_MDITab.RightTab();
				}

				SetMsgHandled(TRUE);
				return 0;
			}
		}

		// ENbNĂ - XN[̂r[ゾƃr[XN[oO
		if (fwKeys == VK_RBUTTON) {
			if (zDelta > 0) {
				m_MDITab.LeftTab();
			} else {
				m_MDITab.RightTab();
			}

			SetMsgHandled(TRUE);
			return 0;
		}

		SetMsgHandled(FALSE);
		return 1;
	}


	LRESULT OnFileRecent(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		// get file name from the MRU list
		if (ID_FILE_MRU_FIRST <= wID && wID <= ID_FILE_MRU_LAST)						//͈IDV͈ID֕ϊ
			wID = wID - ID_FILE_MRU_FIRST + ID_RECENTDOCUMENT_FIRST;

		CRecentDocumentListFixed::RecentDocEntry Entry;

		if ( CMainOption::s_pMru->GetFromList(wID, &Entry) ) {
			DWORD dwOpenFlag = DonutGetStdOpenCreateFlag(); /*DonutGetStdOpenFlag()*/	// Force New Window // UDT DGSTR
			HWND  hWndNew	 = OnUserOpenFile(Entry.szDocName, dwOpenFlag);

			if ( ::IsWindow(hWndNew) ) {
				if (CMainOption::s_bTravelLogClose) {
					CChildFrame *pChild = GetChildFrame(hWndNew);

					if (pChild) {
						_Load_OptionalData2(pChild, Entry.arrFore, Entry.arrBack);
					}
				}
			}

			CMainOption::s_pMru->RemoveFromList(wID);									// UDT DGSTR
		} else {
			::MessageBeep(MB_ICONERROR);
		}

		return 0;
	}


	LRESULT OnViewRefreshFavBar(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		m_FavoriteMenu.RefreshMenu();
		m_FavGroupMenu.RefreshMenu();
		m_styleSheetMenu.RefreshMenu();

		return 0;
	}


	LRESULT OnViewIdle(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		_OnIdleCritical();

		return 0;
	}


	void OnClose()
	{
		SetMsgHandled(FALSE);

		if ( !CDonutConfirmOption::OnDonutExit(m_hWnd) ) {
			SetMsgHandled(TRUE);
			if (IsWindowVisible() == FALSE) {
				SetHideTrayIcon();
				Sleep(100);
			}
			return;
		}

		// ^C}[Ƃ߂.
		if (m_nBackUpTimerID != 0) {
			KillTimer(m_nBackUpTimerID);
			m_nBackUpTimerID	= 0;			//+++ ꉞ 0NAƂ.
		}

	  #if 0 //+++ _WriteProfile()obNAbv̏Ɉڂ(ɍs) ... ς
		_SaveGroupOption( CStartUpOption::GetDefaultDFGFilePath() );
	  #endif

		CChildFrame::SetMainframeCloseFlag();	//+++ mainfrmclose邱ƂChildFrameɋ(irbNcloses߂邽)


		if ( _IsFullScreen() ) {
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_FULLSCREEN;	// save style
			_ShowBandsFullScreen(FALSE);								// restore bands position
		} else {
			CMainOption::s_dwMainExtendedStyle &= ~MAIN_EX_FULLSCREEN;
		}

		m_mcCmdBar.Uninstall();
		m_mcToolBar.Uninstall();

		_WriteProfile();

		CMainOption::s_bAppClosing = true;

		// delete cash
		DelTempFiles();
		// delete history
		DelHistory();
	}


  #if 1 //+++ gCACR̐ݒ.
	void SetHideTrayIcon()
	{
	  #if 1 //+++
		HICON hIcon = 0;
		if (IsExistFile(m_strIconSm))
			hIcon	= (HICON)::LoadImage(ModuleHelper::GetResourceInstance(), m_strIconSm, IMAGE_ICON, 16, 16, LR_SHARED|LR_LOADFROMFILE);
		if (hIcon == 0)
			hIcon = LoadIcon( _Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME) );
		TrayMessage( m_hWnd, NIM_ADD, TM_TRAY, hIcon, DONUT_NAME/*_T("unDonut")*/ );		//+++
	  #else //
		//x TrayMessage( m_hWnd, NIM_ADD, TM_TRAY, IDR_MAINFRAME, DONUT_NAME/*_T("unDonut")*/ );
	  #endif
		ShowWindow(SW_HIDE);
	}
  #endif


	//+++ gC̏I/gCACR̍폜.
	void DeleteTrayIcon()
	{
		TrayMessage(m_hWnd, NIM_DELETE, TM_TRAY, 0, NULL);
		//x m_bTrayFlag = false;
	}


	void DelTempFiles()
	{
		bool						bDelCash	 = (CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_DEL_CASH  ) != 0;	//+++ ? TRUE : FALSE;
		bool						bDelCookie	 = (CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_DEL_COOKIE) != 0;	//+++ ? TRUE : FALSE;

		if (bDelCash == FALSE && bDelCookie == FALSE)
			return;

		bool						bDone		 = FALSE;
		LPINTERNET_CACHE_ENTRY_INFO lpCacheEntry = NULL;

		DWORD						dwTrySize;
		DWORD						dwEntrySize  = 4096;				// start buffer size
		HANDLE						hCacheDir	 = NULL;
		DWORD						dwError 	 = ERROR_INSUFFICIENT_BUFFER;

		do {
			switch (dwError) {
				// need a bigger buffer
			case ERROR_INSUFFICIENT_BUFFER:
				delete[] lpCacheEntry;
				lpCacheEntry			   = (LPINTERNET_CACHE_ENTRY_INFO) new char[dwEntrySize];
				lpCacheEntry->dwStructSize = dwEntrySize;
				dwTrySize				   = dwEntrySize;
				BOOL bSuccess;
				if (hCacheDir == NULL)
					bSuccess = ( hCacheDir = FindFirstUrlCacheEntry(NULL, lpCacheEntry, &dwTrySize) ) != NULL;
				else
					bSuccess = FindNextUrlCacheEntry(hCacheDir, lpCacheEntry, &dwTrySize) != 0;

				if (bSuccess)
					dwError = ERROR_SUCCESS;
				else {
					dwError 	= GetLastError();
					dwEntrySize = dwTrySize;							// use new size returned
				}
				break;

				// we are done
			case ERROR_NO_MORE_ITEMS:
				bDone					   = TRUE;
				//x bResult 			   = TRUE;						//+++ ǖgp̂悤.
				break;

				// we have got an entry
			case ERROR_SUCCESS:
				if (bDelCookie && lpCacheEntry->CacheEntryType & COOKIE_CACHE_ENTRY)
					DeleteUrlCacheEntry(lpCacheEntry->lpszSourceUrlName);

				// Fixed by zzZ(thx
				if ( bDelCash && !( lpCacheEntry->CacheEntryType & (COOKIE_CACHE_ENTRY | URLHISTORY_CACHE_ENTRY) ) )
					DeleteUrlCacheEntry(lpCacheEntry->lpszSourceUrlName);

				// get ready for next entry
				dwTrySize				   = dwEntrySize;

				if ( FindNextUrlCacheEntry(hCacheDir, lpCacheEntry, &dwTrySize) )
					dwError = ERROR_SUCCESS;
				else {
					dwError 	= GetLastError();
					dwEntrySize = dwTrySize;							// use new size returned
				}
				break;

				// unknown error
			default:
				bDone	= TRUE;
				break;
			}

			if (bDone) {
				delete[] lpCacheEntry;

				if (hCacheDir)
					FindCloseUrlCache(hCacheDir);
			}
		} while (!bDone);
	}


	void DelHistory()
	{
		bool	bDelHistory  = (CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_DEL_HISTORY) != 0;	//+++ ? TRUE : FALSE;
		if (bDelHistory == false)
			return;

		IUrlHistoryStg2*	pUrlHistoryStg2 = NULL;
		HRESULT 	hr = CoCreateInstance(CLSID_CUrlHistory, NULL, CLSCTX_INPROC, IID_IUrlHistoryStg2, (void **) &pUrlHistoryStg2);
		if ( SUCCEEDED(hr) ) {
			hr = pUrlHistoryStg2->ClearHistory();
			pUrlHistoryStg2->Release();
		}
	}


	//+++ FNŁAʂ̃vOtŋNꂽꍇ́Aɂ邪A
	//+++       ̊O̒ǉ\DDEoRōs悤ŁAɂ邱Ƃ͂قƂǂȂ...?
	void OnNewInstance(ATOM nAtom)			// WM_NEWINSTANCE
	{
		enum { NAME_LEN = 0x4000 };
		TCHAR szBuff[NAME_LEN+2];

		if (::GlobalGetAtomName(nAtom, szBuff, NAME_LEN) != 0) {
			dmfTRACE(_T("CMainFrame::OnNewInstance: %s\n"), szBuff);
			OnUserOpenFile( szBuff, DonutGetStdOpenFlag() );
			::GlobalDeleteAtom(nAtom);
		}

		if ( !(CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOACTIVATE) ) {
			MtlSetForegroundWindow(m_hWnd); 	//EChEANeBuɂ
			if (m_bTray)									//+++
				OnGetOut(0, 0, 0);							//+++ ̓_~[
			if (m_bOldMaximized == 0 && m_bFullScreen == 0) //+++
				ShowWindow_Restore(1);			//ShowWindow(SW_RESTORE);	//+++ TCY߂.
		}
	}


	////////////////////////////////////////////////////////////////////////////////
	//t@Cj[
	//@R}hnh
	////////////////////////////////////////////////////////////////////////////////

	////VK쐬

	//|[y[W
	void OnFileNewHome(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		HWND hWndChild = OnUserOpenFile( NULL, DonutGetStdOpenActivateFlag() );

		if (hWndChild) {
			CWebBrowser2 browser = DonutGetIWebBrowser2(hWndChild);

			if (browser.m_spBrowser != NULL)
				browser.GoHome();
		}
	}


	//݂̃y[W
	void OnFileNewCopy(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		HWND hWndActive = MDIGetActive();

		if (hWndActive) {
			CWebBrowser2 browser = DonutGetIWebBrowser2(hWndActive);

			if (browser.m_spBrowser != NULL) {
				CString strURL = browser.GetLocationURL();

				if ( !strURL.IsEmpty() )
					OnUserOpenFile( strURL, DonutGetStdOpenActivateFlag() );
			}
		}
	}


	LRESULT OnFileNew(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		if (CFileNewOption::s_dwFlags == FILENEW_BLANK)
			OnFileNewBlank(0, 0, 0);
		else if (CFileNewOption::s_dwFlags == FILENEW_COPY) {
			if (MDIGetActive() != NULL)
				SendMessage(WM_COMMAND, MAKEWPARAM(ID_FILE_NEW_COPY, 0), 0);
			else
				OnFileNewBlank(0, 0, 0);
		} else if (CFileNewOption::s_dwFlags == FILENEW_HOME)
			OnFileNewHome(0, 0, 0);
		else
			ATLASSERT(FALSE);

		return 0;
	}


	//󔒃y[W
	void OnFileNewBlank(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		OnUserOpenFile( _T("about:blank"), DonutGetStdOpenActivateFlag() );
		SendMessage(WM_COMMAND, ID_SETFOCUS_ADDRESSBAR, 0);
	}


	//Nbv{[h
	void OnFileNewClipBoard(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CString strText = MtlGetClipboardText();

		if ( strText.IsEmpty() )
			return;

		OnUserOpenFile( strText, DonutGetStdOpenActivateFlag() );
	}


	//Default.dfg
	// UDT DGSTR
	LRESULT OnFileOpenDef(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		CString 	strPath = GetExeDirectory() + _T("Default.dfg");
		ATLTRACE2( atlTraceGeneral, 4, _T("CMainFrame::OnFileOpenDef\n") );
		OnUserOpenFile( strPath, DonutGetStdOpenCreateFlag() );
		return 0;
	}
	// ENDE


	void OnViewHome(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		bool bNew = ::GetAsyncKeyState(VK_CONTROL) < 0 || ::GetAsyncKeyState(VK_SHIFT) < 0;

		if (bNew || MDIGetActive() == NULL) {
			OnFileNewHome(0, 0, 0);
		} else {
			SetMsgHandled(FALSE);
		}
	}


	void OnResized(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		if (m_wndStatusBar.m_hWnd == NULL)
			return;

		//+++ FXe[^Xo[̃vNVER{{bNX̃TCY
		{
			CRect	rcComboPart;
			if (g_bSwapProxy == false)
				m_wndStatusBar.GetRect(4, rcComboPart);
			else
				m_wndStatusBar.GetRect(1, rcComboPart);

			rcComboPart.top   -= 1;
			rcComboPart.bottom = rcComboPart.top + rcComboPart.Height() * 10;
			m_cmbBox.MoveWindow(rcComboPart, TRUE);
		}

		{
			//vOCCxg - TCY
			CPluginManager::BroadCast_PluginEvent(DEVT_CHANGESIZE, 0, 0);
		}
	}


	// U.H
	void ShowLinkText(BOOL bShow)
	{
		REBARBANDINFO rbBand;

		memset( &rbBand, 0, sizeof (REBARBANDINFO) );
		rbBand.cbSize = sizeof (REBARBANDINFO);

		int 		  nCount = int ( ::SendMessage(m_hWndToolBar, RB_GETBANDCOUNT, 0, 0) );

		for (int ii = 0; ii < nCount; ii++) {
			rbBand.fMask = RBBIM_ID;
			::SendMessage(m_hWndToolBar, RB_GETBANDINFO, (WPARAM) ii, (LPARAM) (LPREBARBANDINFO) &rbBand);

			if (rbBand.wID != IDC_LINKBAR && rbBand.wID != IDC_SEARCHBAR && rbBand.wID != IDC_ADDRESSBAR)
				continue;

			// UDT JOBBY

			rbBand.fMask = RBBIM_TEXT;

			if (bShow) {
				// UDT JOBBY
				if (rbBand.wID == IDC_ADDRESSBAR)
					rbBand.lpText = _T("AhX");
				else if (rbBand.wID == IDC_LINKBAR)
					rbBand.lpText = _T("N");
				else
					rbBand.lpText = _T("");

				// ENDE
			}

			::SendMessage(m_hWndToolBar, RB_SETBANDINFO, (WPARAM) ii, (LPARAM) (LPREBARBANDINFO) &rbBand);
		}
	}
	// END



	// U.H
	void OnFileNewSelectText(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		SendMessage(WM_COMMAND, MAKEWPARAM(ID_EDIT_COPY, 0), 0);
		SendMessage(WM_COMMAND, MAKEWPARAM(ID_FILE_NEW_CLIPBOARD, 0), 0);
	}


	// U.H
	void OnShowTextChg(BOOL bShow)
	{
		ShowLinkText(bShow);
		m_AddressBar.ShowAddresText(m_hWndToolBar, bShow);
	}


	// U.H
	void OnGoAddressBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		m_AddressBar.SetFocus();
	}


	// U.H
	LRESULT OnSysCommand(UINT nID, CPoint point)
	{
		switch (nID) {
		case ID_VIEW_COMMANDBAR:
			SendMessage(m_hWnd, WM_COMMAND, ID_VIEW_COMMANDBAR, 0);
			SetMsgHandled(TRUE);
			break;

	  #if 1	//+++ ŏ{^ɁA^XNgCɓ悤ɂĂ݂.
		case SC_MINIMIZE:
			if ((CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_MINBTN2TRAY)	//+++ ŏ{^Ń^XNgCɓݒ̂ƂA
				&& (point.x || point.y)											//+++ x,y0,0Ȃ^XNo[ŃNbNꍇ낤ŁAgCɂꂸAŏĂ݂.
			) {
				OnGetOut(0,0,0);
				SetMsgHandled(TRUE);
				break;
			}
			//ɑ.
	  #endif

		default:
			SetMsgHandled(FALSE);
			break;
		}

		return 0;
	}


	LRESULT OnPopupClose(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CIgnoredURLsOption::s_bValid = !CIgnoredURLsOption::s_bValid;
		return 0;
	}


	LRESULT OnTitleClose(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CCloseTitlesOption::s_bValid = !CCloseTitlesOption::s_bValid;
		return 0;
	}


	LRESULT OnDoubleClose(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CIgnoredURLsOption::s_bValid = !CIgnoredURLsOption::s_bValid;
		CCloseTitlesOption::s_bValid = !CCloseTitlesOption::s_bValid;
		return 0;
	}


	LRESULT OnPrivacyReport(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		HWND	hWndActive = MDIGetActive();
		if (hWndActive == NULL)
			return 0;

		CWebBrowser2	browser    = DonutGetIWebBrowser2(hWndActive);
		CString 		strURL	   = browser.GetLocationURL();
		CComBSTR		bstrURL(strURL);

		CComPtr<IServiceProvider>		spSP;
		browser.m_spBrowser->QueryInterface(IID_IServiceProvider, (void **) &spSP);

		if (spSP == NULL)
			return 0;

		CComPtr<IEnumPrivacyRecords>	spEnumRecords;
		spSP->QueryService(CLSID_IEnumPrivacyRecords, &spEnumRecords);

		// UH
		// spSP->QueryInterface(IID_IEnumPrivacyRecords, (void**) &spEnumRecords);
		// spSP->QueryInterface(CLSID_IEnumPrivacyRecords, (void**) &spEnumRecords);
		if (spEnumRecords == NULL)
			return 0;

		HINSTANCE		hInstDLL;
		DWORD			(WINAPI * __DoPrivacyDlg)(HWND, LPOLESTR, IEnumPrivacyRecords *, BOOL) = NULL;

		if ( ( hInstDLL = LoadLibrary("shdocvw.dll") ) == NULL )
			return 0;

		__DoPrivacyDlg	= ( DWORD (WINAPI *)(HWND, LPOLESTR, IEnumPrivacyRecords *, BOOL) )
							GetProcAddress( hInstDLL, "DoPrivacyDlg" );
		if (__DoPrivacyDlg == NULL)
			return 0;

		BOOL	bPrivacyImpacted = FALSE;
		spEnumRecords->GetPrivacyImpacted(&bPrivacyImpacted);
		__DoPrivacyDlg(m_hWnd, bstrURL, spEnumRecords, !bPrivacyImpacted);

		return 1;
	}


	// UH
	LRESULT OnCookiesIE6(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/)
	{
		DWORD	  dwLv = 0;

		switch (wID) {
		case ID_URLACTION_COOKIES_BLOCK:	dwLv = PRIVACY_TEMPLATE_NO_COOKIES; 	break;
		case ID_URLACTION_COOKIES_HI:		dwLv = PRIVACY_TEMPLATE_HIGH;			break;
		case ID_URLACTION_COOKIES_MIDHI:	dwLv = PRIVACY_TEMPLATE_MEDIUM_HIGH;	break;
		case ID_URLACTION_COOKIES_MID:		dwLv = PRIVACY_TEMPLATE_MEDIUM; 		break;
		case ID_URLACTION_COOKIES_LOW:		dwLv = PRIVACY_TEMPLATE_MEDIUM_LOW; 	break;
		case ID_URLACTION_COOKIES_ALL:		dwLv = PRIVACY_TEMPLATE_LOW;			break;
		}

		HINSTANCE	hInstDLL;
		DWORD		(WINAPI * __PrivacySetZonePreferenceW)(DWORD, DWORD, DWORD, LPCWSTR) = NULL;

		if ( ( hInstDLL = LoadLibrary("wininet.dll") ) == NULL )
			return 0;

		__PrivacySetZonePreferenceW = ( DWORD (WINAPI *)(DWORD, DWORD, DWORD, LPCWSTR) )
											GetProcAddress( hInstDLL, "PrivacySetZonePreferenceW" );

		if (__PrivacySetZonePreferenceW == NULL)
			return 0;

		__PrivacySetZonePreferenceW(URLZONE_INTERNET, PRIVACY_TYPE_FIRST_PARTY, dwLv, NULL);
		__PrivacySetZonePreferenceW(URLZONE_INTERNET, PRIVACY_TYPE_THIRD_PARTY, dwLv, NULL);
		return 0;
	}


	LRESULT OnHilight(LPCTSTR lpszKeyWord)
	{
		HWND hWndActive = MDIGetActive();

		if (hWndActive == NULL)
			return 0;

		return SendMessage(hWndActive, WM_USER_HILIGHT, (WPARAM) lpszKeyWord, 0);
	}


	LRESULT OnFindKeyWord(LPCTSTR lpszKeyWord, BOOL bBack)
	{
		HWND hWndActive = MDIGetActive();

		if (hWndActive == NULL)
			return 0;

		return SendMessage(hWndActive, WM_USER_FIND_KEYWORD, (WPARAM) lpszKeyWord, (LPARAM) bBack);
	}


	LRESULT OnWindowCloseCmp(int nTarIndex, BOOL bLeft)
	{
		HWND			   hWndActive = MDIGetActive();

		if (hWndActive == NULL)
			return 0;

		CSimpleArray<HWND> arrWnd;
		int 			   ii;

		for (ii = 0; ii < m_MDITab.GetItemCount(); ii++) {
			HWND hWnd = m_MDITab.GetTabHwnd(ii);

			if (bLeft && ii < nTarIndex)
				arrWnd.Add(hWnd);
			else if (bLeft == FALSE && ii > nTarIndex)
				arrWnd.Add(hWnd);
		}

		for (ii = 0; ii < arrWnd.GetSize(); ii++) {
			SendMessage(arrWnd[ii], WM_CLOSE, 0, 0);
		}

		return 1;
	}


	LRESULT OnChangeCSS(LPCTSTR lpszStyleSheet)
	{
		if (CStyleSheetOption::s_bSetUserSheet)
			CStyleSheetOption::SetUserSheetName(lpszStyleSheet);

		//minit

		HWND hWndActive = MDIGetActive();

		if (hWndActive == NULL)
			return 0;

		return SendMessage(hWndActive, WM_USER_CHANGE_CSS, (WPARAM) lpszStyleSheet, 0);
	}


	LRESULT OnSearchBarCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		HWND	hWndActive = MDIGetActive();

		if (hWndActive == NULL)
			return 0;

		CEdit	edit	   = m_SearchBar.GetEditCtrl();
		CString str;	//+++   = MtlGetWindowText(edit);
		str = _GetSelectText(edit);

		if ( str.IsEmpty() )
			return 0;

		switch (wID) {
		case ID_SEARCHBAR_SEL_UP:
			m_SearchBar.SearchPage(FALSE);
			//SendMessage(hWndActive, WM_USER_FIND_KEYWORD, (WPARAM)str.GetBuffer(0), (LPARAM)FALSE);
			break;

		case ID_SEARCHBAR_SEL_DOWN:
			m_SearchBar.SearchPage(TRUE);
			//SendMessage(hWndActive, WM_USER_FIND_KEYWORD, (WPARAM)str.GetBuffer(0), (LPARAM)TRUE);
			break;

		case ID_SEARCHBAR_HILIGHT:
			m_SearchBar.SearchHilight();
			//SendMessage(hWndActive, WM_USER_HILIGHT, (WPARAM)str.GetBuffer(0), (LPARAM)0);
			break;
		}

		return 0;
	}


	// U.H
	LRESULT OnInitMenuPopup(HMENU hMenuPopup, UINT uPos, BOOL bSystemMenu)
	{
		// VXej[́AȂ
		if (bSystemMenu)
			return 0;

		if (m_FavoriteMenu.m_menu == hMenuPopup)
			return 0;

		if (m_FavGroupMenu.m_menu == hMenuPopup)
			return 0;

		if (m_styleSheetMenu.m_menu == hMenuPopup)
			return 0;

		CMenuHandle 	menu = hMenuPopup;
		CAccelerManager accel(m_hAccel);

		// Ԗڂ̃j[Ȃ͂ĕҏWȂ
		CString 		strCmd;

		if (menu.GetMenuString(0, strCmd, MF_BYPOSITION) == 0) {
			menu.RemoveMenu(0, MF_BYPOSITION);
			return 0;
		}

		if (CMainOption::s_dwMainExtendedStyle2 & MAIN_EX2_NOCSTMMENU)
			return 0;

		for (int ii = 0; ii < menu.GetMenuItemCount(); ii++) {
			strCmd = _T("");
			UINT	nID    = menu.GetMenuItemID(ii);
			menu.GetMenuString(nID, strCmd, MF_BYCOMMAND);

			if ( strCmd.IsEmpty() ) {
				// NT4p
				if (strCmd.LoadString(nID) == FALSE)
					continue;
			}

			CString strShorCut;

			if ( !accel.FindAccelerator(nID, strShorCut) )	//tɂȂĂ̂ŏC minit
				continue;

			if (strCmd.Find(_T("\t")) != -1) {
				strCmd = strCmd.Left( strCmd.Find(_T("\t")) );
			}

			if (strShorCut.IsEmpty() == FALSE)
				strCmd = strCmd + _T("\t") + strShorCut;

			UINT	uState = menu.GetMenuState(nID, MF_BYCOMMAND);
			menu.ModifyMenu(nID, MF_BYCOMMAND, nID, strCmd);

			if (uState & MF_CHECKED)
				menu.CheckMenuItem(nID, MF_CHECKED);

			if (uState & MF_GRAYED)
				menu.EnableMenuItem(nID, MF_GRAYED);
		}

		return 0;
	}


	// UDT DGSTR //Update minit
	LRESULT OnFavoriteExpBar(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		m_ExplorerBar.ShowBar(true);
		//m_ExplorerBar.Show();
		MtlSendCommand(m_ExplorerBar.m_FavBar.m_hWnd, wID);
		m_wndSplit.SetSinglePaneMode();
		return 0;
	}


	void OnRegisterAsBrowser(WORD wNotifyCode, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		if (wNotifyCode == NM_ON) {
			MtlForEachMDIChild( m_hWndMDIClient, CSendCommand(ID_REGISTER_AS_BROWSER, NM_ON) );
		} else if (wNotifyCode == NM_OFF) {
			MtlForEachMDIChild( m_hWndMDIClient, CSendCommand(ID_REGISTER_AS_BROWSER, NM_OFF) );
		} else if ( !_check_flag(MAIN_EX_REGISTER_AS_BROWSER, CMainOption::s_dwMainExtendedStyle) ) {
			CMainOption::s_dwMainExtendedStyle |= MAIN_EX_REGISTER_AS_BROWSER;
			MtlForEachMDIChild( m_hWndMDIClient, CSendCommand(ID_REGISTER_AS_BROWSER, NM_ON) );
		} else {
			CMainOption::s_dwMainExtendedStyle &= ~MAIN_EX_REGISTER_AS_BROWSER;
			MtlForEachMDIChild( m_hWndMDIClient, CSendCommand(ID_REGISTER_AS_BROWSER, NM_OFF) );
		}
	}


	void OnFileNewClipBoard2(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CString strText = MtlGetClipboardText();

		if ( strText.IsEmpty() )
			return;

		OnUserOpenFile( strText, DonutGetStdOpenFlag() );	// allow the option
	}


	void OnFileNewClipBoardEx(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		m_ExplorerBar.m_ClipBar.OpenClipboardUrl();
	}


	void OnFileWorkOffline(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		MtlSetGlobalOffline( !MtlIsGlobalOffline() );
		UpdateTitleBarUpsideDown();
	}


	LRESULT OnFileOpen(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		dmfTRACE( _T("CMainFrame::OnFileOpen\n") );
		COpenURLDlg dlg;

		if ( dlg.DoModal() == IDOK && !dlg.m_strEdit.IsEmpty() ) {
			OnUserOpenFile( dlg.m_strEdit, DonutGetStdOpenFlag() );
		}

		return 0;
	}


	LRESULT OnFileExit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		PostMessage(WM_CLOSE);
		return 0;
	}


	void OnEditCut(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CEdit editAddress = m_AddressBar.GetEditCtrl();
		CEdit editSearch  = m_SearchBar.GetEditCtrl();

		if (::GetFocus() == editAddress) {
			editAddress.Cut();
		} else if (::GetFocus() == editSearch) {
			editSearch.Cut();
		} else {
			SetMsgHandled(FALSE);							// MtlWeb.hCWebBrowserCommandHandler
			return;
		}
	}


	void OnEditCopy(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CEdit editAddress = m_AddressBar.GetEditCtrl();
		CEdit editSearch  = m_SearchBar.GetEditCtrl();

		if (::GetFocus() == editAddress) {
			editAddress.Copy();
		} else if (::GetFocus() == editSearch) {
			editSearch.Copy();
		} else {
			SetMsgHandled(FALSE);							// MtlWeb.hCWebBrowserCommandHandler
			return;
		}
	}


	void OnEditPaste(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CEdit editAddress = m_AddressBar.GetEditCtrl();
		CEdit editSearch  = m_SearchBar.GetEditCtrl();

		if (::GetFocus() == editAddress) {
			editAddress.Paste();
		} else if (::GetFocus() == editSearch) {
			editSearch.Paste();
		} else {
			SetMsgHandled(FALSE);
			return;
		}
	}


	void OnEditSelectAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CEdit editAddress = m_AddressBar.GetEditCtrl();
		CEdit editSearch  = m_SearchBar.GetEditCtrl();

		if (::GetFocus() == editAddress) {
			editAddress.SetSelAll();
		} else if (::GetFocus() == editSearch) {
			editSearch.SetSelAll();
		} else {
			SetMsgHandled(FALSE);							// MtlWeb.hCWebBrowserCommandHandler
			return;
		}
	}


	// U.H
	LRESULT OnViewSearchBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		MtlToggleBandVisible(m_hWndToolBar, IDC_SEARCHBAR);
		UpdateLayout();
		return 0;
	}


	// U.H
	LRESULT OnViewCommandBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		MtlToggleBandVisible(m_hWndToolBar, ATL_IDW_COMMAND_BAR);
		UpdateLayout();
		return 0;
	}


	LRESULT OnViewToolBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		// It sucks, band index is dynamic.
		// ::SendMessage(m_hWndToolBar, RB_SHOWBAND, 0, bNew);	// toolbar is band #0
		MtlToggleBandVisible(m_hWndToolBar, ATL_IDW_TOOLBAR);
		UpdateLayout();
		return 0;
	}


	LRESULT OnViewAddressBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		MtlToggleBandVisible(m_hWndToolBar, IDC_ADDRESSBAR);
		UpdateLayout();
		return 0;
	}


	LRESULT OnViewLinkBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		MtlToggleBandVisible(m_hWndToolBar, IDC_LINKBAR);
		UpdateLayout();
		return 0;
	}


	LRESULT OnViewGoButton(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		if ( _check_flag( ABR_EX_GOBTNVISIBLE, m_AddressBar.GetAddressBarExtendedStyle() ) )
			m_AddressBar.ModifyAddressBarExtendedStyle(ABR_EX_GOBTNVISIBLE, 0);
		else
			m_AddressBar.ModifyAddressBarExtendedStyle(0, ABR_EX_GOBTNVISIBLE);

		return 0;
	}


	LRESULT OnViewTabBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		MtlToggleBandVisible(m_hWndToolBar, IDC_MDITAB);
		UpdateLayout();
		return 0;
	}


	LRESULT OnViewTabBarMulti(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		DWORD dwOldStyle = m_MDITab.GetMDITabExtendedStyle();

		if (dwOldStyle & MTB_EX_MULTILINE)
			dwOldStyle &= ~MTB_EX_MULTILINE;
		else
			dwOldStyle |=  MTB_EX_MULTILINE;

		m_MDITab.SetMDITabExtendedStyle(dwOldStyle);
		return 0;
	}


	LRESULT OnViewAddBarDropDown(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		if ( m_AddressBar.GetDroppedStateEx() )
			m_AddressBar.ShowDropDown(FALSE);
		else
			m_AddressBar.ShowDropDown(TRUE);

		return 0;
	}


	LRESULT OnViewStatusBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		BOOL bNew = !::IsWindowVisible(m_hWndStatusBar);

		m_bStatusBarVisibleUnlessFullScreen = bNew; // save
		::ShowWindow(m_hWndStatusBar, bNew ? SW_SHOWNOACTIVATE : SW_HIDE);
		UpdateLayout();
		return 0;
	}


	LRESULT OnViewToolBarCust(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		m_ToolBar.StdToolBar_Customize();
		return 0;
	}


	void OnFavoriteAdd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		::SendMessage(MDIGetActive(), WM_COMMAND, (WPARAM) ID_FAVORITE_ADD, 0);
	}


	void OnFavoriteOrganize(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		bool bOldShell = _check_flag(MAIN_EX_ORGFAVORITEOLDSHELL, CMainOption::s_dwMainExtendedStyle);

		//		CString strPath = DonutGetFavoritesFolder();
		//		MtlOrganizeFavorite(m_hWnd, bOldShell, strPath);
		MtlOrganizeFavorite( m_hWnd, bOldShell, DonutGetFavoritesFolder() );
	}


public:
	///+++	I[gobNAbv̊Jnݒ.
	void SetAutoBackUp() {
		OnBackUpOptionChanged(0,0,0);
	}

private:
	void OnBackUpOptionChanged(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		if (m_nBackUpTimerID != 0) {
			KillTimer(m_nBackUpTimerID);
			m_nBackUpTimerID = 0;
		}

		if (CMainOption::s_dwMainExtendedStyle & MAIN_EX_BACKUP)
			m_nBackUpTimerID = SetTimer(1, 1000 * 60 * CMainOption::s_dwBackUpTime);
	}


	void OnTimer(UINT_PTR nIDEvent, TIMERPROC dmy = 0)
	{
		switch (nIDEvent) {
		case ENT_READ_ACCEL:
			if (m_hAccel) {
				CAccelerManager 	accelManager(m_hAccel);
				m_hAccel = accelManager.LoadAccelaratorState(m_hAccel);
				::KillTimer(m_hWnd, nIDEvent);
			}
			break;

		default:
			//+++ default.dfg̃I[gobNAbv.
			if (m_nBackUpTimerID == nIDEvent && m_nBackUpTimerID) {
				_SaveGroupOption( CStartUpOption::GetDefaultDFGFilePath(), true );
			} else {
				SetMsgHandled(FALSE);
				return;
			}
			break;
		}
	}


	void OnViewOptionDonut(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		ShowNewStyleDonutOption();
		return;
	}


	void ShowNewStyleDonutOption()
	{
		BOOL							bSkinChange = FALSE;

		CMenu							menu	= CExMenuManager::LoadFullMenu();

		CMainPropertyPage				pageMain(m_hWnd);
		CMainPropertyPage2				pageMain2(m_hWnd);
		CDLControlPropertyPage			pageDLC(m_hWnd);
		CMDITabPropertyPage 			pageTab(&m_MDITab, menu.m_hMenu);
		CDonutAddressBarPropertyPage	pageAddress(m_AddressBar, m_SearchBar);
		CDonutFavoritesMenuPropertyPage pageFav;
		CFileNewPropertyPage			pageFileNew;
		CStartUpPropertyPage			pageStartUp;
		CProxyPropertyPage				pageProxy;
		CKeyBoardPropertyPage			pageKeyBoard(m_hAccel, menu.m_hMenu);
		CToolBarPropertyPage			pageToolBar(menu.m_hMenu, &m_ToolBar.m_arrStdBtn, &bSkinChange);
		CMousePropertyPage				pageMouse(menu.m_hMenu);
		CMouseGesturePropertyPage		pageGesture(menu.m_hMenu);
		CSearchPropertyPage 			pageSearch;
		CMenuPropertyPage				pageMenu(menu.m_hMenu, m_CmdBar);
		CExplorerPropertyPage			pageExplorer;
		CDestroyPropertyPage			pageDestroy;
		CSkinPropertyPage				pageSkin(m_hWnd, &bSkinChange);
		CLinkBarPropertyPage			pageLinks(m_LinkBar);

		CString 						strURL, strTitle;
		HWND							hWndActive	= MDIGetActive();

		if (hWndActive) {
			CWebBrowser2 browser = DonutGetIWebBrowser2(hWndActive);

			if (browser.m_spBrowser != NULL) {
				strURL	 = browser.GetLocationURL();
				strTitle = MtlGetWindowText(hWndActive); // pChild->get_LocationName();
			}
		}

		CIgnoredURLsPropertyPage		pageURLs(strURL);
		CCloseTitlesPropertyPage		pageTitles( strTitle );
		CDonutExecutablePropertyPage	pageExe;
		CDonutConfirmPropertyPage		pageCnf;
		CPluginPropertyPage 			pagePlugin;

		CTreeViewPropertySheet			sheet( _T("Donut̃IvV") );

		sheet.AddPage( pageMain 		 );
		sheet.AddPage( pageMain2	 , 1 );
		sheet.AddPage( pageToolBar		 );
		sheet.AddPage( pageTab		 , 1 );
		sheet.AddPage( pageAddress	 , 0 );
		sheet.AddPage( pageSearch	 , 0 );
		sheet.AddPage( pageLinks	 , 0 );
		sheet.AddPage( pageExplorer 	 );
		sheet.AddPage( pageMenu 		 );
		sheet.AddPage( pageFav		 , 1 );
		sheet.AddPage( pageKeyBoard 	 );
		sheet.AddPage( pageMouse		 );
		sheet.AddPage( pageGesture	 , 1 );
		sheet.AddPage( pageFileNew		 );
		sheet.AddPage( pageStartUp		 );
		sheet.AddPage( pageDestroy		 );
		sheet.AddPage( pageDLC			 );
		sheet.AddPage( pageURLs 	 , 1 );
		sheet.AddPage( pageTitles	 , 0 );
		//sheet.AddPage( pageDeterrent	 );

		sheet.AddPage( pageExe			 );
		sheet.AddPage( pageCnf			 );
		sheet.AddPage( pageProxy		 );
		sheet.AddPage( pageSkin 		 );
		sheet.AddPage( pagePlugin		 );

		sheet.DoModal();

		m_cmbBox.ResetProxyList();

		// L[̌ďo
		CAccelerManager accelManager(m_hAccel);
		m_hAccel = accelManager.LoadAccelaratorState(m_hAccel);

	  #if 0 //+++	"^u[hŋN"̃`FbN𔽉f... ς肵Ȃł.
		m_mcCmdBar.setOnlyCloseButton(CMainOption::s_bTabMode);
	  #endif
	}


	void OnViewOption(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		if (MDIGetActive() == NULL)
			MtlShowInternetOptions();
	}


	LRESULT OnWindowCloseAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		if ( !CDonutConfirmOption::OnCloseAll(m_hWnd) )
			return 0;

		CWaitCursor 		 cur;
		CLockRedrawMDIClient lock(m_hWndMDIClient);
		CLockRedraw 		 lock2(m_MDITab);
		MtlCloseAllMDIChildren(m_hWndMDIClient);
		return 0;
	}


	bool _IsFullScreen()
	{
	  #if 1 //+++
		return m_bFullScreen;
	  #else
		return (GetStyle() & WS_CAPTION) == 0;
	  #endif
	}


	void _ShowBandsFullScreen(BOOL bOn, bool bInit = false)
	{
		static BOOL 	s_bOldVisibleStatusBar;
		int 			nIndex = 0;
		if (bOn) { // remove caption
			// save prev visible
			int 		nToolbarPluginCount = CPluginManager::GetCount(PLT_TOOLBAR);
			m_mapToolbarOldVisible.RemoveAll();

			for (nIndex = 0; nIndex < _countof(STDBAR_ID); nIndex++) {
				m_mapToolbarOldVisible.Add( STDBAR_ID[nIndex], MtlIsBandVisible( m_hWndToolBar, STDBAR_ID[nIndex] ) );
			}
			for (nIndex = 0; nIndex < nToolbarPluginCount; nIndex++) {
				m_mapToolbarOldVisible.Add( IDC_PLUGIN_TOOLBAR + nIndex,
											MtlIsBandVisible( m_hWndToolBar, IDC_PLUGIN_TOOLBAR + nIndex ) );
			}
			s_bOldVisibleStatusBar = ::IsWindowVisible(m_hWndStatusBar) != 0;

			{
				CIniFileI pr( g_szIniFileName, _T("FullScreen") );
				MtlShowBand(m_hWndToolBar, ATL_IDW_COMMAND_BAR	, pr.GetValue(_T("ShowMenu")	, FALSE) != 0);
				MtlShowBand(m_hWndToolBar, ATL_IDW_TOOLBAR		, pr.GetValue(_T("ShowToolBar") , FALSE) != 0);
				MtlShowBand(m_hWndToolBar, IDC_ADDRESSBAR		, pr.GetValue(_T("ShowAdress")	, FALSE) != 0);
				MtlShowBand(m_hWndToolBar, IDC_MDITAB			, pr.GetValue(_T("ShowTab") 	, FALSE) != 0);
				MtlShowBand(m_hWndToolBar, IDC_LINKBAR			, pr.GetValue(_T("ShowLink")	, FALSE) != 0);
				MtlShowBand(m_hWndToolBar, IDC_SEARCHBAR		, pr.GetValue(_T("ShowSearch")	, FALSE) != 0);
				if (pr.GetValue(_T("ShowStatus"), FALSE ) == FALSE)
					::ShowWindow(m_hWndStatusBar, SW_HIDE);
				else
					::ShowWindow(m_hWndStatusBar, SW_SHOWNOACTIVATE);
			}
			for (nIndex = 0; nIndex < nToolbarPluginCount; nIndex++)
				MtlShowBand(m_hWndToolBar, IDC_PLUGIN_TOOLBAR + nIndex, FALSE);
		} else {
			for (nIndex = 0; nIndex < m_mapToolbarOldVisible.GetSize(); nIndex++)
				MtlShowBand( m_hWndToolBar, m_mapToolbarOldVisible.GetKeyAt(nIndex), m_mapToolbarOldVisible.GetValueAt(nIndex) );

			::ShowWindow(m_hWndStatusBar, s_bOldVisibleStatusBar ? SW_SHOWNOACTIVATE : SW_HIDE);
		}
	}


	void _FullScreen(BOOL bOn)
	{
		//static bool m_bOldMaximized = 0;
		_ShowBandsFullScreen(bOn);

		if (bOn) {							// remove caption
			// save prev visible
			CWindowPlacement	wndpl;
			GetWindowPlacement(&wndpl);

			{
				CIniFileO	pr( g_szIniFileName, _T("Main") );
				wndpl.WriteProfile(pr, _T("frame."));
				//x pr.Close();
			}

			//m_bMinimized		= 0;
			m_bOldMaximized 	= (wndpl.showCmd == SW_SHOWMAXIMIZED);
			ModifyStyle(WS_CAPTION, 0);

			ShowWindow(SW_HIDE);
			SetMenu(NULL);

			m_mcToolBar.m_bVisible = true;

			ShowWindow(SW_MAXIMIZE);
			if (m_bOldMaximized == 0) {
				SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER | SWP_FRAMECHANGED);
			}
			m_bFullScreen = true;
		} else {
			m_mcToolBar.m_bVisible = false;
			// restore prev visible
		  #if 1 //+++	LvV̒͂Â̏ꍇ
			if (CSkinOption::s_nMainFrameCaption)
				ModifyStyle(0, WS_CAPTION);
		  #else
			ModifyStyle(0, WS_CAPTION);
		  #endif
			if (m_bOldMaximized == 0) {
				ShowWindow_Restore(1);		//ShowWindow(SW_RESTORE);		//+++ TCY߂
			} else {
				SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER | SWP_FRAMECHANGED);
			}
			m_bFullScreen = false;
		}
	}


	void OnViewFullScreen(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		if (_IsFullScreen() == 0)			//+++
		{
			_FullScreen(TRUE);
		} else {
			_FullScreen(FALSE);
		}
	}


public:
	//+++ N̑TCYݒ.
	void startupMainFrameStayle(int nCmdShow)
	{
		CIniFileI  pr( g_szIniFileName, _T("Main") );
		int wndSML	= MtlGetProfileMainFrameState(pr, *this, nCmdShow); 	//+++ s,m,l,full𔻕ʂĂ(b)
		pr.Close();
		m_bOldMaximized 	= 0;
		if (wndSML == 2)
			m_bOldMaximized = 1;
		if (CMainOption::s_dwMainExtendedStyle & MAIN_EX_FULLSCREEN)
			_FullScreen(TRUE);
	}

private:
	void OnFavoriteGroupSave(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		if (MDIGetActive() == NULL)
			return;

		TCHAR		szOldPath[MAX_PATH];	// save current directory
		::GetCurrentDirectory(MAX_PATH, szOldPath);

		const TCHAR szFilter[] = _T("Donut Favorite Groupt@C(*.dfg)\0*.dfg\0\0");

		::SetCurrentDirectory( DonutGetFavoriteGroupFolder() );

		CFileDialog fileDlg(FALSE, _T("dfg"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
		fileDlg.m_ofn.lpstrInitialDir = DonutGetFavoriteGroupFolder();
		fileDlg.m_ofn.lpstrTitle	  = _T("CɓO[v̕ۑ");

		if (fileDlg.DoModal() == IDOK) {
			_SaveGroupOption(fileDlg.m_szFileName);
			::SendMessage(m_hWnd, WM_REFRESH_EXPBAR, 1, 0);
		}

		// restore current directory
		::SetCurrentDirectory(szOldPath);
	}


	void OnFavoriteGroupAdd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		::SendMessage(MDIGetActive(), WM_COMMAND, (WPARAM) ID_FAVORITE_GROUP_ADD, 0);
	}


	void OnFavoriteGroupOrganize(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		::ShellExecute(m_hWnd, NULL, DonutGetFavoriteGroupFolder(), NULL, NULL, SW_SHOWNORMAL);
	}


	void OnViewRefreshAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		MtlForEachMDIChild( m_hWndMDIClient, CPostCommand(ID_VIEW_REFRESH) );
	}


	void OnViewStopAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		MtlForEachMDIChild( m_hWndMDIClient, CPostCommand(ID_VIEW_STOP) );
	}


	void OnSetFocusAddressBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND hWndCtl)
	{
		::SetFocus( m_AddressBar.GetEditCtrl() );
	}


	void OnSetFocusSearchBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND hWndCtl)
	{
		::SetFocus( m_SearchBar.GetEditCtrl() );
	}


	void OnSetFocusSearchBarEngine(WORD /*wNotifyCode*/, WORD /*wID*/, HWND hWndCtl)
	{ //minit
		m_SearchBar.SetFocusToEngine();
	}


	void OnTabLeft(WORD /*wNotifyCode*/, WORD /*wID*/, HWND hWndCtl)
	{
		m_MDITab.LeftTab();
	}


	void OnTabRight(WORD /*wNotifyCode*/, WORD /*wID*/, HWND hWndCtl)
	{
		m_MDITab.RightTab();
	}


  #if 1 //+++
	//+++ 擪^u1..8I. 9͍Ō̃^uI
	LRESULT OnTabIdx(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL & /*bHandled*/)
	{
		ATLASSERT(wID >= ID_TAB_IDX_1 && wID <= ID_TAB_IDX_LAST);
		int nCount = m_MDITab.GetItemCount();

		if (wID == ID_TAB_IDX_LAST) {
			wID =  nCount - 1;
		} else {
			wID -= ID_TAB_IDX_1;
			if (wID < 0 || wID >=8 || wID >= nCount)
				return 0;
		}
		m_MDITab.SetCurSelEx(wID);
		return 0;
	}
  #endif


	void __AddToAddressBoxUnique(const CString &strURL)
	{
		COMBOBOXEXITEM item;

		item.mask	 = CBEIF_TEXT;
		item.iItem	 = 0;
		item.pszText = (LPTSTR) (LPCTSTR) strURL;

		// search the same string
		int 		   nCount = m_AddressBar.GetCount();

		for (int n = 0; n < nCount; ++n) {
			CString str;
			MtlGetLBTextFixed(m_AddressBar, n, str);

			if (strURL == str) {
				m_AddressBar.DeleteItem(n);
				break;
			}
		}

		m_AddressBar.InsertItem(&item);
	}


	void __MoveToTopAddressBox(const CString &strURL)
	{
		COMBOBOXEXITEM item;

		item.mask	 = CBEIF_TEXT;
		item.iItem	 = 0;
		item.pszText = (LPTSTR) (LPCTSTR) strURL;

		// search the same string
		int 		   nCount = m_AddressBar.GetCount();

		for (int n = 0; n < nCount; ++n) {
			CString str;
			MtlGetLBTextFixed(m_AddressBar, n, str);

			if (strURL == str) {
				m_AddressBar.DeleteItem(n);
				m_AddressBar.InsertItem(&item);
				break;
			}
		}
	}


	// Implementation

private:
	void _ReadProfile()
	{
		// read tab
		{
			CIniFileI	pr( g_szIniFileName, _T("MDITab") );
			MtlGetProfileMDITab(pr, m_MDITab);
			//x pr.Close(); 	//+++
		}

		// tHg
		MTL::CLogFont lf;

		if (m_font.m_hFont) {
			m_font.GetLogFont(lf);
			m_MDITab.SetMDITabLogFont(lf);
		}

	  #if 0 //+++	ʓrĂяo悤ɕύX.
		SetAutoBackUp();		//		OnBackUpOptionChanged(0, 0, 0);
	  #endif
	}


	void _WriteProfile()
	{
		// save frame and status bar
		CIniFileO	pr( g_szIniFileName, _T("Main") );
		MtlWriteProfileMainFrameState(pr, m_hWnd);
		/*Mtl*/WriteProfileStatusBarState(pr, m_hWndStatusBar);

		// save MDI tab
		pr.ChangeSectionName(_T("MDITab"));
		MtlWriteProfileMDITab(pr, m_MDITab);

		// save rebar
		pr.ChangeSectionName(_T("ReBar"));
		MtlWriteProfileReBarBandsState(pr, m_hWndToolBar);
		pr.Close();

	  #if 1 //+++ OnClosêςȂɍs悤ɕύX... ς肱
		// save group options
		_SaveGroupOption( CStartUpOption::GetDefaultDFGFilePath() );
	  #endif
	}


  #if 1 //+++ WS_CAPTIONtXN[AƂÔĂ̂ŁAMtl̊O֐̂ֈړ
	template <class _Profile>
	void /*Mtl*/WriteProfileStatusBarState( _Profile &__profile, HWND hWndStatusBar, const CString &strPrefix = _T("statusbar.") )
	{
		ATLASSERT( ::IsWindow(hWndStatusBar) );

		// eAޔ͕ۑȂ
		HWND hWndParent = ::GetParent(hWndStatusBar);
		if (hWndParent) {
			if (::IsWindowVisible(hWndParent) == FALSE)
				return;
			if (_IsFullScreen())
				return;
		}
		LONG lRet		= __profile.SetValue( ::IsWindowVisible(hWndStatusBar) != 0, strPrefix + _T("Visible") );
		ATLASSERT(lRet == ERROR_SUCCESS);
	}
  #endif

	// Overrides WTL sucks

public:
	static BOOL AddSimpleReBarBandCtrl(
		HWND	hWndReBar,
		HWND	hWndBand,
		int 	nID,
		LPTSTR	lpstrTitle,
		UINT	fStyle,
		int 	cxWidth,
		BOOL	bFullWidthAlways,
		HBITMAP hBitmap 		= NULL)
	{
		dmfTRACE( _T("CMainFrame::AddSimpleReBarBandCtrl\n") );
		ATLASSERT( ::IsWindow(hWndReBar) ); 	// must be already created
		ATLASSERT( ::IsWindow(hWndBand) );		// must be already created
		MTLASSERT_KINDOF(REBARCLASSNAME, hWndReBar);

		// Set band info structure
		REBARBANDINFO rbBand;
		rbBand.cbSize	 = sizeof (REBARBANDINFO);
	  #if (_WIN32_IE >= 0x0400)
		rbBand.fMask	 = RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE | RBBIM_ID | RBBIM_SIZE | RBBIM_IDEALSIZE;
	  #else
		rbBand.fMask	 = RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_STYLE | RBBIM_ID | RBBIM_SIZE;
	  #endif	//!(_WIN32_IE >= 0x0400)

		rbBand.fMask	|= RBBIM_BACKGROUND | RBBIM_TEXT;
		rbBand.fStyle	 = fStyle;
		rbBand.lpText	 = lpstrTitle;
		rbBand.hwndChild = hWndBand;
		rbBand.wID		 = nID;

		rbBand.hbmBack	 = hBitmap;
		rbBand.fStyle	|= RBBS_FIXEDBMP;

		// Calculate the size of the band
		BOOL		  bRet;
		RECT		  rcTmp;
		int 		  nBtnCount = (int) ::SendMessage(hWndBand, TB_BUTTONCOUNT, 0, 0L);

		if (nBtnCount > 0) {
			bRet				= ::SendMessage(hWndBand, TB_GETITEMRECT, nBtnCount - 1, (LPARAM) &rcTmp) != 0;
			ATLASSERT(bRet);
			rbBand.cx			= (cxWidth != 0) ? cxWidth : rcTmp.right;
			rbBand.cyMinChild	= rcTmp.bottom - rcTmp.top;

			if (bFullWidthAlways) {
				rbBand.cxMinChild = rbBand.cx;
			} else if (lpstrTitle == 0) {
				CRect rcTmp;					// check!!
				bRet			  = ::SendMessage(hWndBand, TB_GETITEMRECT, 0, (LPARAM) &rcTmp) != 0;
				ATLASSERT(bRet);
				rbBand.cxMinChild = rcTmp.right;
			} else {
				rbBand.cxMinChild = 0;
			}
		} else {								// no buttons, either not a toolbar or really has no buttons
			bRet				= ::GetWindowRect(hWndBand, &rcTmp) != 0;
			ATLASSERT(bRet);
			rbBand.cx			= (cxWidth != 0) ? cxWidth : (rcTmp.right - rcTmp.left);
			rbBand.cxMinChild	= (bFullWidthAlways) ? rbBand.cx : 0;
			rbBand.cyMinChild	= rcTmp.bottom - rcTmp.top;
		}

	  #if (_WIN32_IE >= 0x0400)
		// NOTE: cxIdeal used for CHEVRON, if MDI cxIdeal changed dynamically.
		rbBand.cxIdeal = rcTmp.right;			//rbBand.cx is not good.
	  #endif		//(_WIN32_IE >= 0x0400)

		// Add the band
		LRESULT 	  lRes = ::SendMessage(hWndReBar, RB_INSERTBAND, (WPARAM) -1, (LPARAM) &rbBand);

		if (lRes == 0) {
			ATLTRACE2( atlTraceUI, 0, _T("Failed to add a band to the rebar.\n") );
			return FALSE;
		}

	  #if (_WIN32_IE >= 0x0501)
		if (nID == IDC_LINKBAR)
			::SendMessage(hWndBand, TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_HIDECLIPPEDBUTTONS);
	  #endif		//(_WIN32_IE >= 0x0501)

		return TRUE;
	}


private:
	//+++ O[vIvṼZ[u.
	//+++ - t@C̔r₷邽߁AWƁAinit@Cւ݂̏̃^C~O𕪗.
	//+++ - r䎩̂CIniFileɔC.
	//+++ - ́Aq̏W̎擾܂ߕʃXbhŏĂAǂ̕ӂ܂
	//+++	낢šɂȂĂ͗l.i"iށE߂"TravelLogɁAieR|[lg(dll)
	//+++	ŃnOĂj

	// ^uP̏擾
	struct _Function_EnumChildSaveOption {
		CMainFrame *				m_pMainFrame;
		HWND						m_hWndActive;
		std::list<SDfgSaveInfo>&	m_rDfgSaveInfoList;
		int 						m_nIndex;
		bool						m_bSaveFB;
		int 						m_nActiveIndex;

		_Function_EnumChildSaveOption(
				CMainFrame *				pMainFrame,
				HWND						hWndActive,
				std::list<SDfgSaveInfo>&	rDrfSaveInfoList,
				int 						nIndex		= 0,
				bool						bSaveFB 	= FALSE)
			:	m_pMainFrame(pMainFrame)
			,	m_hWndActive(hWndActive)
			,	m_rDfgSaveInfoList(rDrfSaveInfoList)
			,	m_nIndex(nIndex)
			,	m_bSaveFB(bSaveFB)
			,	m_nActiveIndex(-1)
		{
		}

		void operator ()(HWND hWnd)
		{
			if (hWnd == m_hWndActive)
				m_nActiveIndex = m_nIndex;

			CString 	 strSection;
			strSection.Format("Window%d", m_nIndex);

			//3ȏ̈𑗂̂ʓ|Ȃ̂ŒCChildFrame𑀍
			CChildFrame *pChild = m_pMainFrame->GetChildFrame(hWnd);
			if (!pChild) {
				ErrorLogPrintf("dfg̃Z[uł̏擾%s(qEBhE%#x)̎擾Ɏs\n", LPCTSTR(strSection), hWnd);
				return;
			}

			try {	//+++ ÔߗO`FbN.
				m_rDfgSaveInfoList.push_back( SDfgSaveInfo() );
				m_rDfgSaveInfoList.back().m_section = strSection;
				pChild->m_view.m_ViewOption.GetDfgSaveInfo( m_rDfgSaveInfoList.back(), m_bSaveFB );
			} catch(...) {
				ErrorLogPrintf("dfg̃Z[u%s(qEBhE%#x)̃Z[uɗO\n", LPCTSTR(strSection), hWnd);
			}
			++m_nIndex;
		}
	};

	class CSaveGroupOptionToFile {
	public:
		CSaveGroupOptionToFile()
			:	m_bOldMaximized(0)
			,	m_bSaveTravelLog(0)
			,	m_nIndex(0)
			,	m_nActiveIndex(0)
			,	m_phThread(0)
			,	m_strFileName()
			,	m_dfgSaveInfoList()
		{
		}

		~CSaveGroupOptionToFile() {
			if (m_phThread && *m_phThread) {	//+++ XbhĂƁAm_dfgSaveInfoList̃fXgNg܂...
				DWORD dwResult = ::WaitForSingleObject(*m_phThread, DONUT_BACKUP_THREADWAIT);
				//x CloseHandle(*m_phThread);
			}
		}


		void Run(CMainFrame* pMainWnd, const CString &strFileName, bool bDelay) // modified by minit
		{
			if (pMainWnd == 0)
				return;
			if (pMainWnd->m_hGroupThread) {
				DWORD dwReturnCode = 0;
				::GetExitCodeThread(pMainWnd->m_hGroupThread, &dwReturnCode);
				if (dwReturnCode == STILL_ACTIVE) {
					ErrorLogPrintf("defalut.dfg̑ÕZ[uɗ\zȏɎԂĂ悤Ȃ̂ō͌.\n");
					return;
				}
				//+++ UI.
				::CloseHandle(pMainWnd->m_hGroupThread);
				pMainWnd->m_hGroupThread = NULL;
			}

			m_phThread			= &pMainWnd->m_hGroupThread;
			m_strFileName		= strFileName;
			m_bOldMaximized		= FALSE;
			m_bSaveTravelLog	= CMainOption::s_bTravelLogGroup != 0/*? TRUE : FALSE*/;
			m_dfgSaveInfoList.clear();
			HWND	hWndActive	= pMainWnd->MDIGetActive(&m_bOldMaximized);

			//+++ ܂͏擾s.
			_Function_EnumChildSaveOption	f(pMainWnd, hWndActive, m_dfgSaveInfoList, 0, m_bSaveTravelLog);

			try {	//+++ ӖȂȂǔÔߗO`FbN.
				// f=
				pMainWnd->m_MDITab.ForEachWindow( f );		// MtlForEachMDIChild(m_hWndMDIClient, f);
			} catch (...) {
				ErrorLogPrintf("O[vIvVZ[uɗO\n");
			}

			m_nIndex		= f.m_nIndex;
			m_nActiveIndex	= f.m_nActiveIndex;

			if (bDelay == 0) {	//+++ init@Cւ݂̏𓯊łꍇ.
				WriteIniFile();
			} else {			//+++ init@Cւ݂̏񓯊ɂꍇ.
				UINT	dwThreadID = 0;
				pMainWnd->m_hGroupThread = (HANDLE) _beginthreadex(NULL, 0, CSaveGroupOptionToFile::WriteIniFile_Thread, (LPVOID) this, 0, &dwThreadID);
			}
		}

	private:
		static UINT __stdcall WriteIniFile_Thread(void* pParam)
		{
			CSaveGroupOptionToFile* pThis = (CSaveGroupOptionToFile*)pParam;
			pThis->WriteIniFile();
			_endthreadex(0);
			return 0;
		}

		void WriteIniFile()
		{
			//+++ dfgt@CɃZ[u
			CIniFileO	pr( m_strFileName, _T("Window") );
			pr.RemoveFileToBak();			// strFileName 폜(.bak)

			//+++ ŜɊւݒۑ
			pr.ChangeSectionName( _T("Header") );
			pr.SetValue( m_nIndex				, _T("count")	  );
			pr.SetValue( m_nActiveIndex 		, _T("active")	  );	// active index
			pr.SetValue( (m_bOldMaximized != 0)	, _T("maximized") );

			//+++ Ƃ̐ݒۑ
			for (std::list<SDfgSaveInfo>::iterator it = m_dfgSaveInfoList.begin();
					it != m_dfgSaveInfoList.end();
					++it)
			{
				it->WriteProfile(pr, m_bSaveTravelLog);
			}
		}

	private:
		HANDLE* 					m_phThread;
		BOOL						m_bOldMaximized;
		bool						m_bSaveTravelLog;
		int 						m_nIndex;
		int 						m_nActiveIndex;
		CString 					m_strFileName;
		std::list<SDfgSaveInfo> 	m_dfgSaveInfoList;
	};
	CSaveGroupOptionToFile			m_saveGroupOptionToFile;		//+++ Z[u.


	///+++
	void _SaveGroupOption(const CString &strFileName, bool bDelay=false)
	{
		m_saveGroupOptionToFile.Run(this, strFileName, bDelay);
	}



	void _LoadGroupOption(const CString &strFileName, bool bClose)
	{
		dmfTRACE( _T("CMainFrame::_LoadGroupOption\n") );

		CLockRedrawMDIClient	 lock(m_hWndMDIClient);
		CMDITabCtrl::CLockRedraw lock2(m_MDITab);
		CWaitCursor 			 cur;

		if (bClose)
			MtlCloseAllMDIChildren(m_hWndMDIClient);

		DWORD			dwCount 	= 0;
	  #if INISECTION_USE_MUTEX != 1
		CIniFileI		pr( strFileName, _T("Header") );
		if (pr.QueryValue( dwCount, _T("count") ) != ERROR_SUCCESS)
			return;
		DWORD			dwActive	= pr.GetValue( _T("active")   , 0 );
		DWORD			dwMaximized = pr.GetValue( _T("maximized"), 0 );
		pr.Close();
	  #else
		CIniFileI		pr( strFileName, _T("Header") );
		if (pr.QueryValue( dwCount, _T("count") ) != ERROR_SUCCESS)
			return;
		DWORD			dwActive	= pr.GetValue( _T("active")   , 0 );
		DWORD			dwMaximized = pr.GetValue( _T("maximized"), 0 );
	  #endif

		bool			bActiveChildExistAlready = (MDIGetActive() != NULL);

		m_MDITab.m_bInsertHere		= true;
		m_MDITab.m_nInsertIndex 	= m_MDITab.GetItemCount();

		CChildFrame *	pChildActive = NULL;
		for (DWORD dw = 0; dw < dwCount; ++dw) {
			CChildFrame *pChild = CChildFrame::NewWindow(m_hWndMDIClient, m_MDITab, m_AddressBar);
			// if no active child, as there is no client edge in MDI client window,
			// so GetClientRect is different a little and a resizing will occur when switching.
			// That is, only the first child window is activated.
			if (pChild == NULL)
				continue;

			++m_MDITab.m_nInsertIndex;

			// activate now!
			pChild->ActivateFrame(MDIGetActive() != NULL ? SW_SHOWNOACTIVATE : -1);

			// if tab mode, no need to load window placement.
			pChild->m_view.m_ViewOption.GetProfile(strFileName, dw, !CMainOption::s_bTabMode);

			// ߂Eiނ̍ڂݒ肷
			if (CMainOption::s_bTravelLogGroup) {
				CString 	strSection;
				strSection.Format("Window%d", dw);
				_Load_OptionalData(pChild, strFileName, strSection);
			}

			if (dw == dwActive)
				pChildActive = pChild;
		}

		m_MDITab.m_bInsertHere	= false;
		m_MDITab.m_nInsertIndex = -1;

		if (pChildActive == NULL)
			return;

		if (!bActiveChildExistAlready) {						// there was no active window
			MDIActivate(pChildActive->m_hWnd);
			if (CMainOption::s_bTabMode || dwMaximized == 1) {	// in tab mode
				MDIMaximize(pChildActive->m_hWnd);
			}
		} else {												// already an active window exists
			if ( !(CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOACTIVATE) )
				MDIActivate(pChildActive->m_hWnd);
		}
	}


public:
	BEGIN_UPDATE_COMMAND_UI_MAP( CMainFrame )
		CHAIN_UPDATE_COMMAND_UI_MEMBER( m_MainOption  )
		CHAIN_UPDATE_COMMAND_UI_MEMBER( m_secZone	  )
		CHAIN_UPDATE_COMMAND_UI_MEMBER( m_ExplorerBar )
		CHAIN_MDI_CHILD_UPDATE_COMMAND_UI() 						// first of all

		bool bActiveChild = (MDIGetActive() != NULL);

		// File menu
		UPDATE_COMMAND_UI_SETDEFAULT_FLAG		( ID_FILE_NEW_HOME , FILENEW_HOME , CFileNewOption::s_dwFlags )
		UPDATE_COMMAND_UI_SETDEFAULT_FLAG_PASS	( ID_FILE_NEW_COPY , FILENEW_COPY , CFileNewOption::s_dwFlags )
		UPDATE_COMMAND_UI_SETDEFAULT_FLAG		( ID_FILE_NEW_BLANK, FILENEW_BLANK, CFileNewOption::s_dwFlags )
		UPDATE_COMMAND_UI_ENABLE_IF 			( ID_FILE_NEW_COPY		, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 			( ID_FILE_NEW_CLIPBOARD , _IsClipboardAvailable() )
		UPDATE_COMMAND_UI_SETDEFAULT			( ID_FILE_NEW_CLIPBOARD2 )
		UPDATE_COMMAND_UI_ENABLE_IF 			( ID_FILE_NEW_CLIPBOARD2, _IsClipboardAvailable() )
		UPDATE_COMMAND_UI_ENABLE_IF 			( ID_FILE_SAVE_AS		, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 			( ID_FILE_PAGE_SETUP	, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 			( ID_FILE_PRINT 		, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 			( ID_FILE_PROPERTIES	, bActiveChild )
		UPDATE_COMMAND_UI_SETCHECK_IF			( ID_FILE_WORKOFFLINE	, MtlIsGlobalOffline() )
		UPDATE_COMMAND_UI_ENABLE_IF 			( ID_FILE_CLOSE 		, bActiveChild )
		//UPDATE_COMMAND_UI_POPUP_ENABLE_IF 	( ID_RECENT_DOCUMENT,CMainOption::s_pMru->m_arrDocs.GetSize( ))
		UPDATE_COMMAND_UI_ENABLE_IF_WITH_POPUP	( ID_RECENT_DOCUMENT, _GetRecentCount(), _GetRecentCount() )

		// Edit menu
		//		UPDATE_COMMAND_UI_ENABLE_IF( ID_EDIT_CUT		, bActiveChild )
		//		UPDATE_COMMAND_UI_ENABLE_IF( ID_EDIT_COPY		, bActiveChild )
		//		UPDATE_COMMAND_UI_ENABLE_IF( ID_EDIT_PASTE		, bActiveChild )
		//		UPDATE_COMMAND_UI_ENABLE_IF( ID_EDIT_SELECT_ALL , bActiveChild )

		// AhXo[T[`o[ɃtH[JX or OLER}hgp\ǂ
		CEdit editAddress = m_AddressBar.GetEditCtrl();
		CEdit editSearch  = m_SearchBar.GetEditCtrl();
		bool  bFocus	  = (::GetFocus() == editAddress || ::GetFocus() == editSearch);
		bool  bCut		  = false, bCopy = false, bPaste = false, bSelectAll = false;
		if (bActiveChild) {
			CWebBrowser2 wb = DonutGetIWebBrowser2( MDIGetActive() );
			bCut			= (wb.QueryStatusWB(OLECMDID_CUT)		& OLECMDF_ENABLED) != 0;
			bCopy			= (wb.QueryStatusWB(OLECMDID_COPY)		& OLECMDF_ENABLED) != 0;
			bPaste			= (wb.QueryStatusWB(OLECMDID_PASTE) 	& OLECMDF_ENABLED) != 0;
			bSelectAll		= (wb.QueryStatusWB(OLECMDID_SELECTALL) & OLECMDF_ENABLED) != 0;
		}
		UPDATE_COMMAND_UI_ENABLE_IF ( ID_EDIT_CUT		, bFocus || bCut		)
		UPDATE_COMMAND_UI_ENABLE_IF ( ID_EDIT_COPY		, bFocus || bCopy		)
		UPDATE_COMMAND_UI_ENABLE_IF ( ID_EDIT_PASTE 	, bFocus || bPaste		)
		UPDATE_COMMAND_UI_ENABLE_IF ( ID_EDIT_SELECT_ALL, bFocus || bSelectAll	)
		// ܂

		UPDATE_COMMAND_UI_ENABLE_IF ( ID_EDIT_FIND				, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF ( ID_EDIT_OPEN_SELECTED_REF , bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF ( ID_EDIT_OPEN_SELECTED_TEXT, bActiveChild )
		//UPDATE_COMMAND_UI_ENABLE_IF( ID_VIEW_SETFOCUS, bActiveChild )
		// View menu
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_SEARCHBAR,	MtlIsBandVisible( m_hWndToolBar, IDC_SEARCHBAR		) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_COMMANDBAR,	MtlIsBandVisible( m_hWndToolBar, ATL_IDW_COMMAND_BAR) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_TOOLBAR,		MtlIsBandVisible( m_hWndToolBar, ATL_IDW_TOOLBAR	) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_ADDRESSBAR,	MtlIsBandVisible( m_hWndToolBar, IDC_ADDRESSBAR 	) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_LINKBAR,		MtlIsBandVisible( m_hWndToolBar, IDC_LINKBAR		) )
		UPDATE_COMMAND_UI_SETCHECK_FLAG ( ID_VIEW_GOBUTTON, 	ABR_EX_GOBTNVISIBLE, m_AddressBar.GetAddressBarExtendedStyle() )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_TABBAR,		MtlIsBandVisible( m_hWndToolBar, IDC_MDITAB 		) )
		UPDATE_COMMAND_UI_SETCHECK_FLAG ( ID_VIEW_TABBAR_MULTI, MTB_EX_MULTILINE, m_MDITab.GetMDITabExtendedStyle() )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_TOOLBAR_LOCK,  _IsRebarBandLocked()					)
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_SEARCHBUTTON,  m_SearchBar.GetToolIconState() 		)
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_CLIPBOARDBAR,  m_ExplorerBar.IsClipboardBarVisible()	)
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_PANELBAR, 	 m_ExplorerBar.IsPanelBarVisible()		)
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_PLUGINBAR,	 m_ExplorerBar.IsPluginBarVisible() 	)
		UPDATE_COMMAND_UI_SETCHECK_FLAG ( ID_EXPLORERBAR_AUTOSHOW, MAIN_EXPLORER_AUTOSHOW, CMainOption::s_dwExplorerBarStyle )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_PRIVACYREPORT, 	bActiveChild							)
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_STATUS_BAR,	::IsWindowVisible(m_hWndStatusBar)		)

		UPDATE_COMMAND_UI_ENABLE_IF_WITH_POPUP	( ID_VIEW_BACK, bActiveChild, bActiveChild		)			// with popup
		UPDATE_COMMAND_UI_ENABLE_IF 		( ID_VIEW_FORWARD	, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 		( ID_VIEW_REFRESH	, bActiveChild			)

		UPDATE_COMMAND_UI_POPUP_ENABLE_IF	( ID_VIEW_BACK1 	, bActiveChild			)
		UPDATE_COMMAND_UI_POPUP_ENABLE_IF	( ID_VIEW_FORWARD1	, bActiveChild			)

		UPDATE_COMMAND_UI_ENABLE_IF 	(  ID_VIEW_STOP 		, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	(  ID_VIEW_STOP_ALL 	, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	(  ID_VIEW_REFRESH		, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	(  ID_VIEW_REFRESH_ALL	, bActiveChild			)
		UPDATE_COMMAND_UI_POPUP_ENABLE_IF( ID_AUTOREFRESH_NONE	, bActiveChild			)
		UPDATE_COMMAND_UI_POPUP_ENABLE_IF( ID_VIEW_FONT_LARGEST , bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	(  ID_VIEW_FONT_SIZE	, bActiveChild			)

		//UPDATE_COMMAND_UI_ENABLE_IF_WITH_POPUP( ID_VIEW_ENCODECONTAINER, bActiveChild, bActiveChild ) 	// minit

		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_VIEW_SOURCE		, bActiveChild			)
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_VIEW_FULLSCREEN	, _IsFullScreen()		)

		// Favorite menu
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_FAVORITE_ADD		, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_FAVORITE_GROUP_SAVE, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_FAVORITE_GROUP_ADD , bActiveChild			)
		// Tool menu
		UPDATE_COMMAND_UI_ENABLE_IF_WITH_POPUP( ID_DLCTL_DLIMAGES, bActiveChild, bActiveChild ) 			// with poup
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DLCTL_CHG_MULTI	, bActiveChild			)					// UDT DGSTR
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DLCTL_ON_OFF_MULTI , bActiveChild			)					// UDT UH
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DLCTL_BGSOUNDS 	, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DLCTL_VIDEOS		, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF_WITH_POPUP( ID_DLCTL_RUNACTIVEXCTLS, bActiveChild, bActiveChild )		// with popup
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DLCTL_CHG_SECU 	, bActiveChild			)					// UDT DGSTR
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DLCTL_ON_OFF_SECU	, bActiveChild			)					// UDT UH
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DLCTL_DLACTIVEXCTLS, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DLCTL_SCRIPTS		, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DLCTL_JAVA 		, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_DOCHOSTUI_OPENNEWWIN, bActiveChild 		)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_MESSAGE_FILTER 	, bActiveChild			)					// UH
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_MOUSE_GESTURE		, bActiveChild			)					// UH
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_BLOCK_MAILTO		, bActiveChild			)					// UH
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_EDIT_IGNORE		, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_TITLE_COPY 		, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_COPY_TITLEANDURL	, bActiveChild			)					//minit
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_URL_COPY			, bActiveChild			)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_EDIT_CLOSE_TITLE	, bActiveChild			)					// UDT DGSTR

		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_STYLESHEET_USE_USERS, CStyleSheetOption::GetUseUserSheet() )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_STYLESHEET_SET_USERS, CStyleSheetOption::s_bSetUserSheet	)

		// Help
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_APP_HELP			, _IsExistHTMLHelp()	)					// UDT DGSTR

		// Misc
		// Window menu
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_WINDOW_CLOSE_ALL		, bActiveChild		)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_WINDOW_CLOSE_EXCEPT	, bActiveChild		)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_WINDOW_REFRESH_EXCEPT	, bActiveChild		)					// U.H
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_TAB_LEFT				, bActiveChild		)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_TAB_RIGHT				, bActiveChild		)
		UPDATE_COMMAND_UI_ENABLE_IF_WITH_POPUP( ID_WINDOW_RESTORE, bActiveChild, bActiveChild ) 			// with popup
		UPDATE_COMMAND_UI_ENABLE_IF 	( ATL_IDS_SCPREVWINDOW		, bActiveChild		)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ATL_IDS_SCNEXTWINDOW		, bActiveChild		)
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_WINDOW_CASCADE  , bActiveChild && !CMainOption::s_bTabMode )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_WINDOW_TILE_HORZ, bActiveChild && !CMainOption::s_bTabMode )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_WINDOW_TILE_VERT, bActiveChild && !CMainOption::s_bTabMode )
		UPDATE_COMMAND_UI				( ID_WINDOW_ARRANGE  , OnUpdateWindowArrange	)					// to update Window Menu
		// UPDATE_COMMAND_UI_ENABLE_IF( ID_WINDOW_ARRANGE, bActiveChild && !CMainOption::s_bTabMode )
		// Misc
		// UPDATE_COMMAND_UI_SETTEXT( ID_DEFAULT_PANE, _T("fB" ))
		UPDATE_COMMAND_UI				( IDC_PROGRESS		, OnUpdateProgressUI		)
		UPDATE_COMMAND_UI				( ID_SECURE_PANE	, OnUpdateStautsIcon		)
		UPDATE_COMMAND_UI				( ID_PRIVACY_PANE	, OnUpdateStautsIcon		)

		// UH
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_POPUP_CLOSE	, CIgnoredURLsOption::s_bValid )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_TITLE_CLOSE	, CCloseTitlesOption::s_bValid )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_DOUBLE_CLOSE	, CIgnoredURLsOption::s_bValid && CCloseTitlesOption::s_bValid )

		// UH
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_URLACTION_COOKIES_BLOCK, ChkCookies(ID_URLACTION_COOKIES_BLOCK) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_URLACTION_COOKIES_HI	, ChkCookies(ID_URLACTION_COOKIES_HI   ) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_URLACTION_COOKIES_MIDHI, ChkCookies(ID_URLACTION_COOKIES_MIDHI) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_URLACTION_COOKIES_MID	, ChkCookies(ID_URLACTION_COOKIES_MID  ) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_URLACTION_COOKIES_LOW	, ChkCookies(ID_URLACTION_COOKIES_LOW  ) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_URLACTION_COOKIES_ALL	, ChkCookies(ID_URLACTION_COOKIES_ALL  ) )
		UPDATE_COMMAND_UI_SETCHECK_IF	( ID_URLACTION_COOKIES_CSTM , ChkCookies(ID_URLACTION_COOKIES_CSTM ) )

		UPDATE_COMMAND_UI_POPUP_ENABLE_IF( ID_STYLESHEET_BASE	, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_CSS_DROPDOWN		, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_VIEW_UP			, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_EDIT_FIND_MAX		, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_VIEW_SOURCE_SELECTED,bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_FILE_PRINT_PREVIEW , bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_SEARCH_PAGE		, bActiveChild )							//o[̃y[W{^
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_SEARCHBAR_SEL_UP	, bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_SEARCHBAR_SEL_DOWN , bActiveChild )
		UPDATE_COMMAND_UI_ENABLE_IF 	( ID_SEARCHBAR_HILIGHT	, bActiveChild )
		//minit
		//CHAIN_UPDATE_COMMAND_UI_MEMBER( m_DockingPluginManager )

	END_UPDATE_COMMAND_UI_MAP()


private:
	// UDT DGSTR
	bool _IsExistHTMLHelp(void)
	{
		return ( 0xFFFFFFFF != GetFileAttributes( MtlGetHTMLHelpPath() ) );
	}
	// ENDE



	bool ChkCookies(UINT nID)
	{
		HINSTANCE	hInstDLL = LoadLibrary("wininet.dll");
		if (hInstDLL == NULL)
			return false;

		DWORD (WINAPI * __PrivacyGetZonePreferenceW)(DWORD, DWORD, LPDWORD, LPWSTR, LPDWORD) = NULL;
		__PrivacyGetZonePreferenceW = ( DWORD (WINAPI *)(DWORD,DWORD,LPDWORD,LPWSTR, LPDWORD) )
										GetProcAddress(hInstDLL,"PrivacyGetZonePreferenceW");
		if (__PrivacyGetZonePreferenceW == NULL)
			return false;

		DWORD	dwCookie1 = 0;
		DWORD	dwCookie2 = 0;
		DWORD	BufLen	  = 0;
		DWORD	ret;
		ret = __PrivacyGetZonePreferenceW(URLZONE_INTERNET, PRIVACY_TYPE_FIRST_PARTY, &dwCookie1, NULL, &BufLen);
		ret = __PrivacyGetZonePreferenceW(URLZONE_INTERNET, PRIVACY_TYPE_THIRD_PARTY, &dwCookie2, NULL, &BufLen);

		bool		bSts		= false;
		switch (nID) {
		case ID_URLACTION_COOKIES_BLOCK:
			if (dwCookie1 == dwCookie2 && dwCookie1 == PRIVACY_TEMPLATE_NO_COOKIES)
				bSts = true;
			break;

		case ID_URLACTION_COOKIES_HI:
			if (dwCookie1 == dwCookie2 && dwCookie1 == PRIVACY_TEMPLATE_HIGH)
				bSts = true;
			break;

		case ID_URLACTION_COOKIES_MIDHI:
			if (dwCookie1 == dwCookie2 && dwCookie1 == PRIVACY_TEMPLATE_MEDIUM_HIGH)
				bSts = true;
			break;

		case ID_URLACTION_COOKIES_MID:
			if (dwCookie1 == dwCookie2 && dwCookie1 == PRIVACY_TEMPLATE_MEDIUM)
				bSts = true;
			break;

		case ID_URLACTION_COOKIES_LOW:
			if (dwCookie1 == dwCookie2 && dwCookie1 == PRIVACY_TEMPLATE_MEDIUM_LOW)
				bSts = true;
			break;

		case ID_URLACTION_COOKIES_ALL:
			if (dwCookie1 == dwCookie2 && dwCookie1 == PRIVACY_TEMPLATE_LOW)
				bSts = true;
			break;

		case ID_URLACTION_COOKIES_CSTM:
			if (dwCookie1 == PRIVACY_TEMPLATE_ADVANCED)
				bSts = true;
			if (dwCookie2 == PRIVACY_TEMPLATE_ADVANCED)
				bSts = true;
			break;
		}

		return bSts;
	}


	void OnUpdateWindowArrange(CCmdUI *pCmdUI)
	{
		// toolbar has not this command button, called only on menu popuping
		MDIRefreshMenu();
		MtlCompactMDIWindowMenuDocumentList( m_menuWindow, _nWindowMenuItemCount,
											CFavoritesMenuOption::GetMaxMenuItemTextLength() );

		pCmdUI->Enable(MDIGetActive() != NULL && !CMainOption::s_bTabMode);
	}


	void OnUpdateProgressUI(CCmdUI *pCmdUI)
	{
		CProgressBarCtrl progressbar = pCmdUI->m_wndOther;

		progressbar.ShowWindow(SW_HIDE);
	}


	void OnUpdateStautsIcon(CCmdUI *pCmdUI)
	{
		pCmdUI->m_wndOther.SendMessage(WM_STATUS_SETICON, MAKEWPARAM(pCmdUI->m_nID, -1), 0);
	}


	bool _IsClipboardAvailable()
	{
		return ::IsClipboardFormatAvailable(CF_TEXT) == TRUE;
	}


	void _FocusChecker()
	{
		// Note. On idle time, give focus back to browser window...
		dmfTRACE( _T("_FocusChecker\n") );

		HWND hWndActive 				 = MDIGetActive();
		if (hWndActive == NULL)
			return;

		HWND hWndForeground 			 = ::GetForegroundWindow();
		bool bMysteriousWindowForeground = MtlIsKindOf( hWndForeground, _T("Internet Explorer_Hidden") );

		if ( bMysteriousWindowForeground && MtlIsWindowCurrentProcess(hWndForeground) ) {
			if (m_bTray)									//+++ gCԂ畜.
				OnGetOut(0, 0, 0);							//+++ ̓_~[
			if (m_bOldMaximized == 0 && m_bFullScreen == 0) //+++
				ShowWindow_Restore(1);		//ShowWindow(SW_RESTORE);		//+++ TCY߂
			MtlSetForegroundWindow(m_hWnd);
		}

		if ( !MtlIsApplicationActive(m_hWnd) ) {
			dmfTRACE(_T(" application is not active\n"), hWndForeground);
			return;
		}

		HWND hWndFocus					 = ::GetFocus();
		if ( hWndFocus != NULL && !MtlIsFamily(m_hWnd, hWndFocus) ) {
			dmfTRACE(_T(" not family(focus=%x)\n"), hWndFocus);
			return;
		}

		if ( ::IsChild(m_hWndToolBar, hWndFocus) ) {
			dmfTRACE( _T(" on rebar\n") );
			return;
		}

		if ( ::IsChild(m_ExplorerBar, hWndFocus) ) {
			dmfTRACE( _T(" on explorer bar\n") );
			return;
		}

		if ( hWndFocus == NULL || m_hWnd == hWndFocus || hWndActive == hWndFocus
		   || MtlIsKindOf( hWndFocus, _T("Shell DocObject View") ) )
		{
			dmfTRACE( _T(" Go!!!!!\n") );
			MtlSendCommand(hWndActive, ID_VIEW_SETFOCUS);
		}
	}


	// UH
	void InitStatusBar()
	{
		enum {	//+++ ID̓ftHg̖OɂȂĂ邪Aꍇɂ₱̂ŁÄÄƂĈ.
			ID_PAIN_1	= ID_PROGRESS_PANE,
			ID_PAIN_2	= ID_COMBOBOX_PANE,
		};
		DWORD		dwVal	  = 0;
		DWORD		dwSzPain1 = 125;
		DWORD		dwSzPain2 = 125;

		{
			CIniFileI	pr( g_szIniFileName, _T("StatusBar") );

			if (pr.QueryValue( dwVal, _T("SizePain") ) == ERROR_SUCCESS) {
				dwSzPain1 = LOWORD(dwVal);
				dwSzPain2 = HIWORD(dwVal);
			}

			if (pr.QueryValue( dwVal, _T("SwapPain") ) == ERROR_SUCCESS)
				g_bSwapProxy = dwVal != 0;
		}

		//+++ ʒȕC.
		if (g_bSwapProxy == 0) {
			g_dwProgressPainWidth = dwSzPain1;					//+++ 蔲ŃvOXyC̉O[oϐɍT.
			m_wndStatusBar.SetPaneWidth(ID_PAIN_1, 0);			//dwSzPain1); //N̓yCTCY0
			if (m_cmbBox.IsUseIE())
				dwSzPain2 = 0;									// IEProxygꍇProxyyCTCY0
			m_wndStatusBar.SetPaneWidth(ID_PAIN_2, dwSzPain2);
		} else {	// ĂƂ.
			g_dwProgressPainWidth = dwSzPain2;					//+++ 蔲ŃvOXyC̉O[oϐɍT.
			m_wndStatusBar.SetPaneWidth(ID_PAIN_2, dwSzPain2);	//+++ ĂƂ́AŏTCYm.
			if (m_cmbBox.IsUseIE())
				dwSzPain1 = 0;									// IEProxygꍇProxyyCTCY0
			m_wndStatusBar.SetPaneWidth(ID_PAIN_1, dwSzPain1);
		}

		m_wndStatusBar.SetPaneWidth(ID_SECURE_PANE	, 25);
		m_wndStatusBar.SetPaneWidth(ID_PRIVACY_PANE , 25);
	}


	//minit
	LRESULT OnSpecialKeys(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		int nCode = 0;
		switch (wID) {
		case ID_SPECIAL_HOME:		nCode = VK_HOME;	break;
		case ID_SPECIAL_END:		nCode = VK_END; 	break;
		case ID_SPECIAL_PAGEUP: 	nCode = VK_PRIOR;	break;
		case ID_SPECIAL_PAGEDOWN:	nCode = VK_NEXT;	break;
		case ID_SPECIAL_UP: 		nCode = VK_UP;		break;
		case ID_SPECIAL_DOWN:		nCode = VK_DOWN;	break;
		default:	ATLASSERT(FALSE);
		}
		PostMessage(WM_KEYDOWN, nCode, 0);
		return S_OK;
	}


	LRESULT OnSecurityReport(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		HWND	hWndActive = MDIGetActive();
		if (hWndActive == NULL)
			return 0;

		//With Internet Explorer 6 for Microsoft Windows XP Service Pack 2 (SP2) and later
		//Ă
		CWebBrowser2	   browser	  = DonutGetIWebBrowser2(hWndActive);
		IOleCommandTarget *pct;

		if ( SUCCEEDED( browser.m_spBrowser->QueryInterface(IID_IOleCommandTarget, (void **) &pct) ) ) {
			pct->Exec(&CGID_ShellDocView, SHDVID_SSLSTATUS, 0, NULL, NULL);
			pct->Release();
		}

		return S_OK;
	}


	BOOL CMainFrame::TranslateMessageToBHO(MSG *pMsg)
	{
		if (  (WM_KEYFIRST		 <= pMsg->message) && (pMsg->message <= WM_KEYLAST	)
		   || (WM_IME_SETCONTEXT <= pMsg->message) && (pMsg->message <= WM_IME_KEYUP) )
		{
			int nCount = CPluginManager::GetCount(PLT_TOOLBAR);

			for (int i = 0; i < nCount; i++) {
				if ( CPluginManager::Call_PreTranslateMessage(PLT_TOOLBAR, i, pMsg) )
					return TRUE;
			}
		}

		return FALSE;
	}


	void _RemoveTmpDirectory()
	{
		CString 	strTempPath = GetExeDirectory() + _T("ShortcutTmp\\");
		if (::GetFileAttributes(strTempPath) != 0xFFFFFFFF) {
			MtlForEachFile( strTempPath, CMainFrame::_Function_DeleteFile(0) );
			::RemoveDirectory(strTempPath);
		}
	}


	struct _Function_DeleteFile {
		int m_dummy;
		_Function_DeleteFile(int ndummy) : m_dummy(ndummy)
		{
		}


		void operator ()(const CString &strFile)
		{
			if ( MtlIsExt( strFile, _T(".tmp") ) )
				::DeleteFile(strFile);
		}
	};


	LRESULT OnWindowThumbnail(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
	  #if 0 //+++	XRĝA߂p#if.
		CThumbnailDlg	dlg;
		dlg.DoModal(m_hWnd, (LPARAM)m_hWndMDIClient);
	  #endif
		return S_OK;
	}


	LRESULT OnSpecialRefreshSearchEngine(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		m_SearchBar.RefreshEngine();
		return 0;
	}


	BOOL _Load_OptionalData(CChildFrame *pChild, const CString &strFileName, CString &strSection)
	{
		pChild->SetDfgFileNameSection(strFileName, strSection);
		return TRUE;
	}


	BOOL _Load_OptionalData2(CChildFrame *pChild,
							 std::vector<std::pair<CString, CString> > &ArrayFore,
							 std::vector<std::pair<CString, CString> > &ArrayBack)
	{
		pChild->SetArrayHist( ArrayFore, ArrayBack );
		return TRUE;
	}


	LRESULT OnMenuRecentDocument(HMENU hMenu)
	{
		CRecentDocumentListFixed *pList;
		pList = CMainOption::s_pMru;
		CMenuHandle 			  menu	 = hMenu;

		if (menu.m_hMenu == NULL)
			return 0;

		if (pList == NULL)
			return 0;

		if (menu.GetMenuItemCount() == 0)
			menu.AppendMenu(MF_ENABLED | MF_STRING, ID_RECENTDOCUMENT_FIRST, (LPCTSTR) NULL);
		else if (menu.GetMenuItemID(0) != ID_RECENTDOCUMENT_FIRST)
			return 0;

		HMENU					  hMenuT = pList->GetMenuHandle();
		pList->SetMenuHandle(menu);
		pList->UpdateMenu();
		pList->SetMenuHandle(hMenuT);

		return 1;
	}


	LRESULT OnMenuRecentLast(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		return ::SendMessage(m_hWnd, WM_COMMAND, ID_RECENTDOCUMENT_FIRST, 0);
	}


	int _GetRecentCount()
	{
		return CMainOption::s_pMru->m_arrDocs.GetSize();
	}


	LRESULT _OnMDIActivate(HWND hWndActive)
	{
		//vOCɃ^uύXꂽƂ`
		int 		  nTabIndex;
		IWebBrowser2 *pWB2;

		if (hWndActive == NULL) {
			nTabIndex = -1;
			pWB2	  = NULL;
		} else {
			nTabIndex = m_MDITab.GetTabIndex(hWndActive);
			pWB2	  = DonutGetIWebBrowser2(hWndActive);
		}

		int 		  nCount = CPluginManager::GetCount(PLT_TOOLBAR);

		for (int i = 0; i < nCount; i++) {
			if ( CPluginManager::Call_Event_TabChanged(PLT_TOOLBAR, i, nTabIndex, pWB2) )
				return TRUE;
		}

		return 0;
	}


	LRESULT OnTabListDefault(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		CPoint pos;
		::GetCursorPos(&pos);

		int    nRet = m_MDITab.ShowTabListMenuDefault(pos.x, pos.y);

		if (nRet == -1)
			return 0;

		HWND   hWnd = m_MDITab.GetTabHwnd(nRet);

		if ( ::IsWindow(hWnd) )
			::SendMessage(m_wndMDIClient, WM_MDIACTIVATE, (WPARAM) hWnd, 0);

		return 0;
	}


	LRESULT OnTabListVisible(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		CPoint pos;
		::GetCursorPos(&pos);

		int    nRet = m_MDITab.ShowTabListMenuVisible(pos.x, pos.y);

		if (nRet == -1)
			return 0;

		HWND   hWnd = m_MDITab.GetTabHwnd(nRet);

		if ( ::IsWindow(hWnd) )
			::SendMessage(m_wndMDIClient, WM_MDIACTIVATE, (WPARAM) hWnd, 0);

		return 0;
	}


	LRESULT OnTabListAlphabet(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		CPoint pos;
		::GetCursorPos(&pos);

		int    nRet = m_MDITab.ShowTabListMenuAlphabet(pos.x, pos.y);

		if (nRet == -1)
			return 0;

		HWND   hWnd = m_MDITab.GetTabHwnd(nRet);

		if ( ::IsWindow(hWnd) )
			::SendMessage(m_wndMDIClient, WM_MDIACTIVATE, (WPARAM) hWnd, 0);

		return 0;
	}


	LRESULT OnShowActiveMenu(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		HWND	hWndActive = MDIGetActive();
		if (!hWndActive)
			return 0;

		int  nIndex 	= m_MDITab.GetTabIndex(hWndActive);
		m_MDITab.ShowTabMenu(nIndex);

		return 0;
	}


	LRESULT OnMainFrameMinimize(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		ShowWindow(SW_MINIMIZE);
		//m_bOldMaximized = 0;
		// //m_bMinimized    = 1;
		return 0;
	}


	LRESULT OnMainFrameMaximize(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		ShowWindow(SW_MAXIMIZE);
		m_bOldMaximized = 1;
		// //m_bMinimized    = 0;
		return 0;
	}


	LRESULT OnMainFrameNormMaxSize(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		if (m_bOldMaximized) {
			//ShowWindow(SW_RESTORE);
			ShowWindow_Restore(1);	//ShowWindow(SW_RESTORE);		//TCY߂
			m_bOldMaximized = 0;
		} else {
			ShowWindow(SW_MAXIMIZE);
			m_bOldMaximized = 1;
		}
		return 0;
	}


public:
	LRESULT OnUseUserStyleSheet(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		bool	bNowFlag = !CStyleSheetOption::GetUseUserSheet();

		CStyleSheetOption::SetUseUserSheet(bNowFlag);
		return 0;
	}


private:
	LRESULT OnSetUserStyleSheet(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		bool	bNowFlag = !CStyleSheetOption::s_bSetUserSheet;

		CStyleSheetOption::s_bSetUserSheet = bNowFlag;
		return 0;
	}


	LRESULT OnShowExMenu(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		CMenu menu = CExMenuManager::LoadExMenu(CExMenuManager::EXMENU_ID_FIRST);
		POINT pos;

		GetCursorPos(&pos);
		menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, pos.x, pos.y, m_hWnd, NULL);
		return 0;
	}


	LRESULT OnSelectUserFolder(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		MtlSendCommand(m_ExplorerBar.m_FavBar.m_hWnd, ID_SELECT_USERFOLDER);
		return 0;
	}


	LRESULT OnSearchHistory(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		MtlSendCommand(m_ExplorerBar.m_FavBar.m_hWnd, ID_SEARCH_HISTORY);
		return 0;
	}


	LRESULT OnJumpToWebSite(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		//CString strSite = _T("http://www5.ocn.ne.jp/~minute/tab/"); //unDonutÂ
		//CString strSite = _T("http://undonut.sakura.ne.jp/"); // unDonutV
		//CString strSite = _T("http://tekito.genin.jp/undonut+.html"); //unDonut+
		CString strSite = _T("http://ichounonakano.sakura.ne.jp/64/undonut/"); //unDonut+mod.

		OnUserOpenFile( strSite, DonutGetStdOpenFlag() );
		return 0;
	}


	LRESULT OnCommandDirect(int nCommand, LPCTSTR lpstr)
	{
		CString str(lpstr);

		if (str.Find( _T("tp://") ) != -1) {
			StrToNormalUrl(str);		//+++
			DonutOpenFile( m_hWnd, str, DonutGetStdOpenFlag() );
		} else {
			if (nCommand == ID_SEARCH_DIRECT) {
				CEdit edit = m_SearchBar.GetEditCtrl();
				edit.SendMessage(WM_CHAR, 'P');
				edit.SetWindowText(lpstr);
				m_SearchBar.SearchWeb();
			} else if (nCommand == ID_OPENLINK_DIRECT) {
				SendMessage(WM_COMMAND, ID_EDIT_OPEN_SELECTED_REF, 0);
			}
		}

		return 0;
	}


private:
	void InitSkin()
	{
		setMainFrameBg(CSkinOption::s_nMainFrameBgColor);			//+++ Ct[Bgݒ.
		initCurrentIcon();											//+++ ACR
		m_CmdBar.setMenuBarStyle(m_hWndToolBar, false); 			//+++ j[ (FEVATWH̒Zɂ邩ۂ)

		m_MDITab.SetDrawStyle(CSkinOption::s_nTabStyle);			//^u
		m_ReBar.RefreshSkinState(); 								//ReBar
		m_wndStatusBar.ReloadSkin( CSkinOption::s_nStatusStyle		//Xe[^Xo[
								 , CSkinOption::s_nStatusTextColor
								 , CSkinOption::s_nStatusBackColor);

		setMainFrameCaptionSw(CSkinOption::s_nMainFrameCaption);	//+++ Ct[̃LvV̗L.
	}


	HRESULT OnSkinChange()
	{
		InvalidateRect(NULL, TRUE);

		//bZ[Wu[hLXgׂ
		CSkinOption::GetProfile();

		setMainFrameBg(CSkinOption::s_nMainFrameBgColor);			//+++ Ct[Bgݒ.

		initCurrentIcon();											//+++ ACR
		m_CmdBar.setMenuBarStyle(m_hWndToolBar, true);				//+++ j[
		m_ReBar.RefreshSkinState(); 								//ReBar
		m_CmdBar.InvalidateRect(NULL, TRUE);						//j[o[
		m_MDITab.ReloadSkin(CSkinOption::s_nTabStyle);				//^u
		m_ToolBar.ReloadSkin(); 									//c[o[
		m_AddressBar.ReloadSkin(CSkinOption::s_nComboStyle);		//AhXo[
		m_SearchBar.ReloadSkin(CSkinOption::s_nComboStyle); 		//o[
		m_LinkBar.InvalidateRect(NULL, TRUE);						//No[
		m_ExplorerBar.ReloadSkin(); 								//GNXv[o[
		m_ExplorerBar.m_PanelBar.ReloadSkin();						//plo[
		m_ExplorerBar.m_PluginBar.ReloadSkin(); 					//vOCo[
		m_wndStatusBar.ReloadSkin(CSkinOption::s_nStatusStyle		//Xe[^Xo[
								, CSkinOption::s_nStatusTextColor
								, CSkinOption::s_nStatusBackColor);

		setMainFrameCaptionSw(CSkinOption::s_nMainFrameCaption);	//+++ LvV

		//tbV
		InvalidateRect(NULL, TRUE);

		return 0;
	}


  #if 1 //+++	Ct[Caption on/off
	void setMainFrameCaptionSw(int sw)
	{
		if (sw == 0) {	//+++ LvVOꍇ
			ModifyStyle(WS_CAPTION, 0);
		} else {
			ModifyStyle(0, WS_CAPTION); 			//+++ LvVꍇ.
		}
		m_mcCmdBar.SetExMode(sw ? 0/*L*/ : m_hWnd/**/);

		SetWindowPos(NULL, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER | SWP_FRAMECHANGED);
	}
  #endif


	///+++ ݂̃XL̃ACR()ݒ.
	///     HICON ̊JĂȂĂ悢? ʖڂŃ[NĂ?...wiñ\[XǗĂ悤킩....
	void initCurrentIcon()
	{
		//+++ xp rWAX^CꎞIoff
		CTheme		theme;
		theme.SetWindowTheme(m_hWnd, L" ", L" ");

		/*static*/ HICON hIcon	= 0;
		//if (hIcon)
		//	::CloseHandle(hIcon);
		//hIcon 		= 0;
		CString strDir	= _GetSkinDir();
		m_strIcon		= strDir + "MainFrameBig.ico";
		if (IsExistFile(m_strIcon) == 0)
			m_strIcon	= strDir + "icon.ico";
		if (IsExistFile(m_strIcon))
			hIcon = (HICON)::LoadImage(ModuleHelper::GetResourceInstance(), m_strIcon, IMAGE_ICON, 32, 32, LR_SHARED|LR_LOADFROMFILE );
		if (hIcon == 0) {
			m_strIcon.Empty();
			hIcon = (HICON)::LoadImage(ModuleHelper::GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
		}
		if (hIcon)
			::SetClassLongPtr(m_hWnd, GCLP_HICON  , (LONG_PTR)hIcon );
		//::CloseHandle(hIcon);

		/*static*/ HICON hIconSm	= 0;
		//if (hIconSm)
		//	::CloseHandle(hIconSm);
		//hIconSm			= 0;
		m_strIconSm 		= strDir + "MainFrameSmall.ico";
		if (IsExistFile(m_strIconSm) == 0)
			m_strIconSm 	= strDir + "icon.ico";
		if (IsExistFile(m_strIconSm))
			hIconSm 	= (HICON)::LoadImage(ModuleHelper::GetResourceInstance(), m_strIconSm, IMAGE_ICON, 16, 16, LR_SHARED|LR_LOADFROMFILE);
		if (hIconSm == 0) {
			m_strIconSm.Empty();
			hIconSm   = (HICON)::LoadImage(ModuleHelper::GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
		}
		if (hIconSm)
			::SetClassLongPtr(m_hWnd, GCLP_HICONSM, (LONG_PTR)hIconSm );
		//::CloseHandle(hIconSm);

		//+++ XP̃rWAX^Cɖ߂...͂Ȃ
		theme.SetWindowTheme(m_hWnd, 0, 0);
	}


	//+++ Ct[Bgݒ.
	void setMainFrameBg(int bgColor)
	{
		m_nBgColor = bgColor;

		CString 	strPath = _GetSkinDir() + _T("bg.bmp");
		m_bmpBg.Attach( AtlLoadBitmapImage(strPath.GetBuffer(0), LR_LOADFROMFILE) );
	}


	///+++ bg`
	bool drawMainFrameBg(HDC hDC)
	{
	  #if 1 //+++ bg^Ĉ
		if (m_bmpBg.m_hBitmap) {		// bg摜~l߂ĕ\
			DrawBmpBg_Tile(hDC);
			return 1;
		} else if (m_nBgColor >= 0) {	// Fw肪΁A̐Fłׂh
			HBRUSH	hBrushBg = CreateSolidBrush(COLORREF(m_nBgColor));
			RECT	rect;
			GetClientRect(&rect);
			::FillRect( hDC, &rect, hBrushBg );
			DeleteObject(hBrushBg);
			return 1;
		}
		return 0;
	  #else //+++ wiFbgɕ\KvƂ
		if (m_nBgColor < 0 || m_bmpBg.m_hBitmap == 0)
			return 0;

		if (m_nBgColor >= 0) {
			HBRUSH	hBrushBg = CreateSolidBrush(COLORREF(m_nBgColor));
			RECT	rect;
			GetClientRect(&rect);
			::FillRect( hDC, &rect, hBrushBg );
			DeleteObject(hBrushBg);
		}
		if (m_bmpBg.m_hBitmap) {
			//if (m_nBgStyle == SKIN_BG_STYLE_TILE)
			DrawBmpBg_Tile(hDC);
			//else if (m_nBGStyle == SKN_BG_STYLE_STRETCH)
			//DrawBmpBg_Stretch(hDC);
		}
		return 1;
	  #endif
	}


	//+++ bg`(~l߂^Cv)
	void DrawBmpBg_Tile(HDC hDC)
	{
		CRect	rc;
		GetClientRect(&rc);

		CDC 	dcSrc;
		dcSrc.CreateCompatibleDC(hDC);

		HBITMAP hOldbmpSrc	= dcSrc.SelectBitmap(m_bmpBg.m_hBitmap);
		SIZE	size;
		m_bmpBg.GetSize(size);
		DWORD	srcW = size.cx;
		DWORD	srcH = size.cy;
		DWORD	dstW = rc.Width();
		DWORD	dstH = rc.Height();
		for (unsigned y = 0; y < dstH; y += srcH) {
			for (unsigned x = 0; x < dstW; x += srcW) {
				::BitBlt(hDC, x, y, srcW, srcH, dcSrc, 0, 0, SRCCOPY);
			}
		}

		dcSrc.SelectBitmap(hOldbmpSrc);
	}

  #if 0 //+++ ʂ̍XV悤킩Ȃ̂ŁAgk͎~
	//+++ 摜g債ĕ\.
	void DrawBmpBg_Stretch(HDC hDC)
	{
		CRect	rc;
		GetClientRect(&rc);
	  #if 0
		InvalidateRect(rc, TRUE);
		UpdateWindow();
	  #endif

		CDC 	dcSrc;
		dcSrc.CreateCompatibleDC(hDC);

		HBITMAP hOldbmpSrc	= dcSrc.SelectBitmap(m_bmpBg.m_hBitmap);
		SIZE	size;
		m_bmpBg.GetSize(size);
		DWORD	srcW = size.cx;
		DWORD	srcH = size.cy;
		double	srcR = double(srcW) / double(srcH);
		DWORD	dstW = rc.Width();
		DWORD	dstH = rc.Height();
		double	dstR = double(dstW) / double(dstH);
		if (dstR > srcR) {			//+++ `͈͂̂قA摜
			srcH = DWORD( srcH * srcR / dstR );
		} else if (dstR < srcR) {	//+++ `͈͂̂قA摜c
			srcW = DWORD( srcW * dstR / srcR );
		}
		::StretchBlt(hDC, 0, 0, dstW, dstH, dcSrc , 0, 0, srcW, srcH, SRCCOPY);
		dcSrc.SelectBitmap(hOldbmpSrc);
		//ValidateRect(NULL);
	}
   #endif


public:
  #if 0 //+++ Ƃ
	HICON	LoadIcon4AboutDialog()
	{
		int 	w = ::GetSystemMetrics(SM_CXICON);
		int 	h = ::GetSystemMetrics(SM_CYICON);
		HICON	hIcon = 0;
	  #if 1
		if (IsExistFile(m_strIcon))
			hIcon = (HICON)::LoadImage(ModuleHelper::GetResourceInstance(), m_strIcon, IMAGE_ICON, w, h, LR_SHARED|LR_LOADFROMFILE);
		if (hIcon == 0)
	  #endif
			hIcon = (HICON)::LoadImage(ModuleHelper::GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, w, h, LR_DEFAULTCOLOR );
		return hIcon;
	}
  #endif


	CChildFrame *GetChildFrame(HWND hWndChild)
	{
		if ( !::IsWindow(hWndChild) )
			return NULL;

		//@ChildFrame |C^
		//s@NULL((BOOL)FALSE)
		return (CChildFrame *) ::SendMessage(hWndChild, WM_GET_CHILDFRAME, 0, 0);
	}


	CChildFrame *GetActiveChildFrame()
	{
		HWND	hWnd = MDIGetActive();
		if (hWnd)
			return GetChildFrame(hWnd);
		return NULL;
	}


	CString GetActiveSelectedText()
	{
		CChildFrame *pChild = GetActiveChildFrame();
		if (pChild)
			return pChild->GetSelectedTextLine();
		return CString();
	}


private:
  #if 1	// saitamap̂Ot@CǍɂĔėp.
	HWND _OpenAboutFile(CString strFile)
	{
	  #if 0	//+++ unDonut.ini [ETC] SAITAMA=1`ĂȂꍇ͋A
		{
			CIniFileI pr( g_szIniFileName, _T("ETC") );
			DWORD	  dwFlag = pr.GetValue(_T("SAITAMA"));
			if (dwFlag == 0)
				return 0;
		}
	  #endif

		if (strFile.Left(6) != _T("about:"))
			return NULL;
		strFile     = strFile.Mid(6);		// about:
		bool  bWarn = (strFile == "warning");
		if (bWarn == 0) {
			strFile     = GetFullPath_ForExe( "help\\about\\" + strFile );	//
			if (IsExistFile(strFile) == 0)	//t@CȂ炩
				return NULL;
		}
		HWND					hWndChild = OnUserOpenFile( _T("about:blank"), DonutGetStdOpenFlag() );
		if ( !::IsWindow(hWndChild) )
			return NULL;

		CChildFrame *			pChild	  = GetChildFrame(hWndChild);
		if (!pChild)
			return hWndChild;

		CComPtr<IHTMLDocument2> pDoc;
		HRESULT 				hr;
		int 					ct		  = 0;

		while (1) {
			hr = pChild->m_spBrowser->get_Document( (IDispatch **) &pDoc );
			if (SUCCEEDED(hr) && pDoc) {
				break;
			}
			Sleep(100);

			ct++;
			if (ct > 50)
				return hWndChild;
		}

		CString		strText;
		if (bWarn) {	//+++ x̂Ƃ́A肻[ǂ
			HRSRC		hRes	  = ::FindResource( _Module.GetModuleInstance(), MAKEINTRESOURCE(IDR_TEXT_WARNING/*IDR_TEXT_SAITAMA*/), _T("TEXT") );
			HGLOBAL 	hMem	  = ::LoadResource(_Module.GetModuleInstance(), hRes);
			LPTSTR		lpstr	  = (LPTSTR) ::LockResource(hMem);
			strText   = CString(lpstr);
		} else {		//+++ ʏ help/about/̃t@Cǂݍ
			strText	  = FileLoadTextString( strFile );
		}

		HGLOBAL 	hHTMLText = GlobalAlloc(GPTR, strText.GetLength() + 1);
		if (hHTMLText) {
			CComPtr<IStream> pStream;
			CopyMemory(hHTMLText, strText, strText.GetLength() + 1);
			hr = ::CreateStreamOnHGlobal(hHTMLText, TRUE, &pStream);
			if ( SUCCEEDED(hr) ) {
				// Call the helper function to load the browser from the stream.
				LoadWebBrowserFromStream( pChild->m_spBrowser , pStream  );
			}

			GlobalFree( hHTMLText );
		}

		/*SAFEARRAY *psfArray;
		   VARIANT *pparam;
		   psfArray = SafeArrayCreateVector(VT_VARIANT, 0, 1);
		   if(psfArray){
			hr = SafeArrayAccessData(psfArray,(LPVOID*) & pparam);
			pparam->vt = VT_BSTR;
			pparam->bstrVal = bstrSaitama;
			hr = SafeArrayUnaccessData(psfArray);
			hr = pDoc->write(psfArray);
			SafeArrayDestroy(psfArray);
		   }*/

		//m_AddressBar.GetEditCtrl().SetWindowText(strFile);
		//int index = m_MDITab.GetTabIndex(hWndChild);
		//m_MDITab.SetItemText(index,strFile);
		return hWndChild;
	}
  #endif

	HRESULT LoadWebBrowserFromStream(IWebBrowser *pWebBrowser, IStream *pStream)
	{
		HRESULT 			hr;
		IDispatch * 		pHtmlDoc		   = NULL;
		IPersistStreamInit *pPersistStreamInit = NULL;

		// Retrieve the document object.
		hr = pWebBrowser->get_Document( &pHtmlDoc );
		if ( SUCCEEDED(hr) ) {
			// Query for IPersistStreamInit.
			hr = pHtmlDoc->QueryInterface( IID_IPersistStreamInit,	(void **) &pPersistStreamInit );
			if ( SUCCEEDED(hr) ) {
				// Initialize the document.
				hr = pPersistStreamInit->InitNew();
				if ( SUCCEEDED(hr) ) {
					// Load the contents of the stream.
					hr = pPersistStreamInit->Load( pStream );
				}
				pPersistStreamInit->Release();
			}
		}

		return S_OK;
	}


	LRESULT OnShowToolBarMenu()
	{
		POINT		pt = {0};

		::GetCursorPos(&pt);

		CMenuHandle submenu = ::GetSubMenu(::GetSubMenu(m_hMenu, 2), 0);
		if ( submenu.IsMenu() )
			submenu.TrackPopupMenu(TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, pt.x, pt.y, m_hWnd);

		return 0;
	}


	HRESULT OnSearchWebSelText(LPCTSTR lpstrText, LPCTSTR lpstrEngine)
	{
		int 	nLoopCnt = 0;
		BOOL	bFirst	 = (DonutGetStdOpenCreateFlag() & D_OPENFILE_ACTIVATE) != 0;	//+++ ? TRUE : FALSE;

		m_SearchBar.OpenSearch(lpstrText, lpstrEngine, nLoopCnt, bFirst);

		return S_OK;
	}


	//+++
	void OnSearchWeb_engineId(UINT code, int id, HWND hWnd)
	{
		ATLASSERT(ID_INSERTPOINT_SEARCHENGINE <= id && id <= ID_INSERTPOINT_SEARCHENGINE_END);
		MtlSendCommand(m_SearchBar.m_hWnd, WORD(id));
	}


	//+++
	HRESULT	OnSearchEngineMenu(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		MtlSendCommand(m_SearchBar.m_hWnd, WORD(ID_SEARCHENGINE_MENU));
		return 0;
	}



	LRESULT OnSetExProperty(LPCTSTR lpstrUrlFile)
	{
		CString 		  strUrlFile = lpstrUrlFile;

		if ( !MtlIsExt( strUrlFile, _T(".url") ) )
			return 0;

		CExPropertyDialog dlg(strUrlFile);
		dlg.DoModal();

		return 0;
	}


public:
	/////////////////////////////////////////////
	// DonutP API
	/////////////////////////////////////////////

	IDispatch *ApiGetDocumentObject(int nTabIndex)
	{
		HWND		 hTabWnd = m_MDITab.GetTabHwnd(nTabIndex);
		if (hTabWnd == NULL)
			return NULL;

		CWebBrowser2 browser = DonutGetIWebBrowser2(hTabWnd);

		IDispatch *  spDocument = 0;
		browser.m_spBrowser->get_Document(&spDocument);
		return (IDispatch *) spDocument;
	}


	IDispatch *ApiGetWindowObject(int nTabIndex)
	{
		HWND					  hTabWnd = m_MDITab.GetTabHwnd(nTabIndex);
		if (hTabWnd == NULL)
			return NULL;

		CWebBrowser2			  browser = DonutGetIWebBrowser2(hTabWnd);

		CComPtr<IDispatch>		  spDisp  = 0;
		HRESULT 				  hr	  = browser.m_spBrowser->get_Document(&spDisp);
		CComQIPtr<IHTMLDocument2> spDoc   = spDisp;

		IHTMLWindow2 *			  spWnd   = 0;
		spDoc->get_parentWindow(&spWnd);
		return (IDispatch *) spWnd;
	}


	IDispatch *ApiGetWebBrowserObject(int nTabIndex)
	{
		HWND		  hTabWnd	= m_MDITab.GetTabHwnd(nTabIndex);

		if (hTabWnd == NULL)
			return NULL;

		CWebBrowser2  browser	= DonutGetIWebBrowser2(hTabWnd);

		IWebBrowser2 *spBrowser = 0;
		browser.m_spBrowser->QueryInterface(IID_IWebBrowser2, (void **) &spBrowser);
		return (IDispatch *) spBrowser;
	}


	long ApiGetTabIndex()
	{
		return m_MDITab.GetCurSel();
	}


	void ApiSetTabIndex(int nTabIndex)
	{
		m_MDITab.SetCurSelEx(nTabIndex);
	}


	void ApiClose(int nTabIndex)
	{
		HWND hTabWnd = m_MDITab.GetTabHwnd(nTabIndex);

		::SendMessage(hTabWnd, WM_COMMAND, ID_FILE_CLOSE, 0);
	}


	long ApiGetTabCount()
	{
		return m_MDITab.GetItemCount();
	}


	void ApiMoveToTab(int nBeforIndex, int nAfterIndex)
	{
		CSimpleArray<int> aryBefor;
		aryBefor.Add(nBeforIndex);
		m_MDITab.MoveItems(nAfterIndex + 1, aryBefor);
	}


	int ApiNewWindow(BSTR bstrURL, BOOL bActive)
	{
		CString 	 strURL(bstrURL);

		int 		 nCmdShow = bActive ? -1 : SW_SHOWNOACTIVATE;

		if (m_MDITab.GetItemCount() == 0)
			nCmdShow = -1;

		CChildFrame *pChild   = CChildFrame::NewWindow(m_hWndMDIClient, m_MDITab, m_AddressBar);
		if (pChild == NULL)
			return -1;

		pChild->ActivateFrame(nCmdShow);

		if ( strURL.IsEmpty() )
			strURL = _T("about:blank");

		pChild->SetWaitBeforeNavigate2Flag();			//+++ ABeforeNavigate2()s܂ł̊ԃAhXo[XVȂ悤ɂtOon
		pChild->Navigate2(strURL);
pChild->ForceMessageLoop();								//+++ ... łɕsv낤Ƃ肠c...
		return m_MDITab.GetTabIndex(pChild->m_hWnd);
	}


	void ApiShowPanelBar()
	{
		if ( m_ExplorerBar.IsPanelBarVisible() )
			return;

		SendMessage(WM_COMMAND, ID_VIEW_PANELBAR, 0);
	}


	long ApiGetTabState(int nIndex)
	{
		BYTE bytData = 0;

		if (m_MDITab.GetItemState(nIndex, bytData) == false)
			return -1;

		long nRet	 = 0;

		if (bytData & TCISTATE_SELECTED) {
			nRet = 1;
		} else if (bytData & TCISTATE_MSELECTED) {
			nRet = 2;
		}

		return nRet;
	}


	IDispatch *ApiGetPanelWebBrowserObject()
	{
		if ( !m_ExplorerBar.m_PanelBar.IsWindow() )
			m_ExplorerBar.m_PanelBar.CreatePanelBar(m_hWnd, FALSE);

		return m_ExplorerBar.m_PanelBar.GetPanelWebBrowserObject();
	}


	IDispatch *ApiGetPanelWindowObject()
	{
		if ( !m_ExplorerBar.m_PanelBar.IsWindow() )
			m_ExplorerBar.m_PanelBar.CreatePanelBar(m_hWnd, FALSE);

		return m_ExplorerBar.m_PanelBar.GetPanelWindowObject();
	}


	IDispatch *ApiGetPanelDocumentObject()
	{
		if ( !m_ExplorerBar.m_PanelBar.IsWindow() )
			m_ExplorerBar.m_PanelBar.CreatePanelBar(m_hWnd, FALSE);

		return m_ExplorerBar.m_PanelBar.GetPanelDocumentObject();
	}


	//IAPI2 by minit
	void ApiExecuteCommand(int nCommand)
	{
		::SendMessage(m_hWnd, WM_COMMAND, (WPARAM) (nCommand & 0xFFFF), 0);
	}


	void ApiGetSearchText( /*[out, retval]*/ BSTR *bstrText)
	{
		CString strBuf;
		CEdit	edit = m_SearchBar.GetEditCtrl();
		int 	len  = edit.GetWindowTextLength() + 1;

		edit.GetWindowText(strBuf.GetBuffer(len), len);
		strBuf.ReleaseBuffer();
		*bstrText = CComBSTR(strBuf).Copy();
	}


	void ApiSetSearchText(BSTR bstrText)
	{
		CString strText = bstrText;
		CEdit	edit	= m_SearchBar.GetEditCtrl();

		edit.SendMessage(WM_CHAR, 'P');
		edit.SetWindowText(strText);
	}


	void ApiGetAddressText( /*[out, retval]*/ BSTR *bstrText)
	{
		CString strBuf;
		CEdit	edit = m_AddressBar.GetEditCtrl();
		int 	len  = edit.GetWindowTextLength() + 1;

		edit.GetWindowText(strBuf.GetBuffer(len), len);
		strBuf.ReleaseBuffer();
		*bstrText = CComBSTR(strBuf).Copy();
	}


	void ApiSetAddressText(BSTR bstrText)
	{
		CString strText = bstrText;
		CEdit	edit	= m_AddressBar.GetEditCtrl();

		edit.SendMessage(WM_CHAR, 'P');
		edit.SetWindowText(strText);
	}


	LRESULT ApiGetExtendedTabState(int nIndex)
	{
		HWND hWndChild = m_MDITab.GetTabHwnd(nIndex);

		if ( !::IsWindow(hWndChild) )
			return 0x80000000;

		return ::SendMessage(hWndChild, WM_GET_EXTENDED_TABSTYLE, 0, 0);
	}


	void ApiSetExtendedTabState(int nIndex, long nState)
	{
		HWND hWndChild = m_MDITab.GetTabHwnd(nIndex);

		if ( !::IsWindow(hWndChild) )
			return;

		::SendMessage(hWndChild, WM_SET_EXTENDED_TABSTYLE, (WPARAM) nState, 0);
	}


	LRESULT ApiGetKeyState(int nKey)
	{
		//return (::GetAsyncKeyState(nKey) & 0x80000000) != 0;		//+++ ꂾƁAXNvgŕsł邱Ƃ邩ȂŁAԌ^̂قɍ킹.
		return (::GetAsyncKeyState(nKey) & 0x80000000);
	}


	long ApiGetProfileInt(BSTR bstrFile, BSTR bstrSection, BSTR bstrKey, int nDefault)
	{
		CString 	strFile    = bstrFile;
		CString 	strSection = bstrSection;
		CString 	strKey	   = bstrKey;
		CIniFileI	pr(strFile, strSection);
		return (long)pr.GetValue( strKey, nDefault );
	}


	void ApiWriteProfileInt(BSTR bstrFile, BSTR bstrSection, BSTR bstrKey, int nValue)
	{
		CString 	strFile    = bstrFile;
		CString 	strSection = bstrSection;
		CString 	strKey	   = bstrKey;
		CIniFileO	pr(strFile, strSection);
		pr.SetValue(nValue, strKey);
		//x pr.Close(); 	//+++
	}


	void ApiGetProfileString(BSTR bstrFile, BSTR bstrSection, BSTR bstrKey, BSTR bstrDefault, /*[out, retval]*/ BSTR *bstrText)
	{
		CString 	strFile 	= bstrFile;
		CString 	strSection	= bstrSection;
		CString 	strKey		= bstrKey;
		CString 	strDefault	= bstrDefault;
		CIniFileI	pr(strFile, strSection);
		CString 	strBuf		= pr.GetString(strKey, strDefault, 0xFFFFFFFF); //+++ size=0xFFFFFFFF̏ꍇ̓obt@TCYgŎ擾.
		*bstrText = CComBSTR(strBuf).Copy();
	}


	void ApiWriteProfileString(BSTR bstrFile, BSTR bstrSection, BSTR bstrKey, BSTR bstrText)
	{
		CString 		strFile    = bstrFile;
		CString 		strSection = bstrSection;
		CString 		strKey	   = bstrKey;
		CString 		strText    = bstrText;
		CIniFileO	pr(strFile, strSection);
		pr.SetValue( strText, strKey );
	}


	void ApiGetScriptFolder( /*[out, retval]*/ BSTR *bstrFolder)
	{
		ATLASSERT(bstrFolder != 0);
		CString 	strBuf = GetExeDirectory() + _T("Script\\");
		if (::GetFileAttributes(strBuf) == 0xFFFFFFFF)
			strBuf.Empty();

		*bstrFolder = CComBSTR(strBuf).Copy();
	}


	void ApiGetCSSFolder( /*[out, retval]*/ BSTR *bstrFolder)
	{
		ATLASSERT(bstrFolder != 0);
		CString 	strBuf = GetExeDirectory() + _T("CSS\\");
		if (::GetFileAttributes(strBuf) == 0xFFFFFFFF)
			strBuf.Empty();

		*bstrFolder = CComBSTR(strBuf).Copy();
	}


	void ApiGetBaseFolder( /*[out, retval]*/ BSTR *bstrFolder)
	{
		ATLASSERT(bstrFolder != 0);
		CString 	strBuf = GetExeDirectory();
		if (::GetFileAttributes(strBuf) == 0xFFFFFFFF)
			strBuf.Empty();

		*bstrFolder = CComBSTR(strBuf).Copy();
	}


	void ApiGetExePath( /*[out, retval]*/ BSTR *bstrPath)
	{
		ATLASSERT(bstrPath != 0);
		TCHAR Buf[MAX_PATH];
		::GetModuleFileName(_Module.GetModuleInstance(), Buf, MAX_PATH);
		*bstrPath = CComBSTR(Buf).Copy();
	}


	void ApiSetStyleSheet(int nIndex, BSTR bstrStyleSheet, BOOL bOff)
	{
		HWND		 hWndChild = m_MDITab.GetTabHwnd(nIndex);

		if ( !::IsWindow(hWndChild) )
			return;

		CChildFrame *pChild    = GetChildFrame(hWndChild);
		if (pChild == NULL)
			return;

		CString 	 strStylePath(bstrStyleSheet);
		CString 	 strStyleTitle;

		if ( bOff || strStylePath.IsEmpty() ) {
			// Off or Default
		} else {
			// Set New StyleSheet
			strStyleTitle = strStylePath.Mid(strStylePath.ReverseFind('\\') + 1);
		}

		pChild->StyleSheet(strStyleTitle, bOff, strStylePath);
	}


	//IAPI3
	void ApiSaveGroup(BSTR bstrGroupFile)
	{
		CString strFile = bstrGroupFile;

		_SaveGroupOption(strFile);
	}


	void ApiLoadGroup(BSTR bstrGroupFile, BOOL bClose)
	{
		CString strFile = bstrGroupFile;

		_LoadGroupOption(strFile, bClose != 0/*? true : false*/);
	}


private:
	struct _ExtendProfileInfo {
		/*const*/LPCTSTR	lpstrIniPath;
		/*const*/LPCTSTR	lpstrSection;
		BOOL			  	bGroup;
	};


public:
	int ApiNewWindow3(BSTR bstrURL, BOOL bActive, long ExStyle, void *pExInfo)
	{
		CString 	 strURL   = bstrURL;

		int 		 nCmdShow = bActive ? -1 : SW_SHOWNOACTIVATE;

		if (m_MDITab.GetItemCount() == 0)
			nCmdShow = -1;

		CChildFrame *pChild   = CChildFrame::NewWindow(m_hWndMDIClient, m_MDITab, m_AddressBar);

		if (pChild == NULL)
			return -1;

		pChild->ActivateFrame(nCmdShow);

		if ( strURL.IsEmpty() )
			strURL = _T("about:blank");

		if (*(int *) pExInfo) {
			_ExtendProfileInfo *_pExInfo   = (_ExtendProfileInfo *) pExInfo;
			CString 			strPath    = _pExInfo->lpstrIniPath;
			CString 			strSection = _pExInfo->lpstrSection;
			try {
				_Load_OptionalData(pChild, strPath, strSection);
			} catch (...) {
				ErrorLogPrintf("ApiNewWindow3");
				MessageBox( _T("OG[܂B(In NewWindow3 Function)\n"
							   "Ŝ߃vOċNĂB") );
			}

			if (_pExInfo->bGroup) {
				pChild->m_view.m_ViewOption._GetProfile(strPath, strSection, !CMainOption::s_bTabMode);
			} else {
				pChild->OnSetExtendedTabStyle(ExStyle | CChildFrame::FLAG_SE_NOREFRESH);
			}
		} else {
			pChild->OnSetExtendedTabStyle(ExStyle | CChildFrame::FLAG_SE_NOREFRESH);
		}

		pChild->SetWaitBeforeNavigate2Flag();			//+++ ABeforeNavigate2()s܂ł̊ԃAhXo[XVȂ悤ɂtOon
		pChild->Navigate2(strURL);
pChild->ForceMessageLoop();								//+++ ... łɕsv낤Ƃ肠c....
		return m_MDITab.GetTabIndex(pChild->m_hWnd);
	}


	long ApiAddGroupItem(BSTR bstrGroupFile, int nIndex)
	{
		HWND		 hWndChild = m_MDITab.GetTabHwnd(nIndex);

		if ( !::IsWindow(hWndChild) )
			return -1;

		CChildFrame *pChild    = GetChildFrame(hWndChild);

		if (pChild == NULL)
			return -1;

		return pChild->_AddGroupOption(bstrGroupFile);
	}


	long ApiDeleteGroupItem(BSTR bstrGroupFile, int nIndex)
	{
		CString 		strGroupFile = bstrGroupFile;
		{
			CString 	strSection;
			strSection.Format(_T("Window%d"), nIndex);
			CIniFileO	pr(strGroupFile, strSection);
			bool		bRet = pr.DeleteSection();
			pr.Close();
			if (!bRet) {
				MessageBox("Error1: ZNV̍폜Ɏs܂B");
				return 0;
			}
		}

		std::list<CString>	buf;
		bool bRet = FileReadString(strGroupFile, &buf);
		if (!bRet) {
			MessageBox("Error2: t@C̓ǂݍ݂Ɏs܂B");
			return 0;
		}

		std::list<CString>::iterator str;

		for (str = buf.begin(); str != buf.end(); ++str) {
			CString strCheck = str->Left(7);
			strCheck.MakeUpper();

			if ( strCheck == _T("[WINDOW") ) {
				int nSecIndex = atoi( str->Mid(7, str->GetLength() - 7 - 1) );
				if (nSecIndex > nIndex) {
					str->Format("[Window%d]", nSecIndex - 1);
				}
			}
		}

		bRet = FileWriteString(strGroupFile, &buf);
		if (!bRet) {
			MessageBox("Error3: t@C݂̏Ɏs܂B");
			return 0;
		}

		DWORD		dwCount = 0, dwActive = 0, dwMaximize = 0;
		CIniFileIO	pr( strGroupFile, _T("Header") );
		pr.QueryValue( dwCount, _T("Count") );
		if (dwCount) {
			dwCount--;
			pr.SetValue( dwCount, _T("Count") );
		}

		pr.QueryValue( dwActive, _T("active") );
		if (dwCount == 0)
			pr.DeleteValue( _T("active") );
		else if ( (int) dwActive > nIndex )
			pr.SetValue( dwActive - 1, _T("active") );

		pr.QueryValue( dwMaximize, _T("maximized") );

		if (dwCount == 0)
			pr.DeleteValue( _T("maximized") );
		else if ( (int) dwMaximize > nIndex )
			pr.SetValue( dwMaximize - 1, _T("maximized") );

		return 1;
	}


	//IAPI4
	HWND ApiGetHWND(long nType)
	{
		if (nType == 0)
			return m_hWnd;
		return NULL;
	}


	LRESULT OnPluginCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled); //PluginEventImpl.hŎ
};



#include "PluginEventImpl.h"

/////////////////////////////////////////////////////////////////////////////
